2023-08-28 15:27:09 +0000 Marco Bettini <marco.bettini@open-xchange.com> (47349e2482)

    mail-crypt: mail_crypt_mailbox_allocated() - Force cross-user copies to
    (de,re)encrypt the contents


M	src/plugins/mail-crypt/mail-crypt-plugin.c

2023-09-06 15:04:49 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (aaaa810590)

    NEWS: Update NEWS with changes


M	NEWS

2023-09-06 08:34:51 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (bafdc83211)

    lib-sql: driver-mysql - Use API state to check if there is connection

    db->mysql cannot be NULL.

    Broken in 542877c08eb8130733567e5b718933bc3cdc8426

M	src/lib-sql/driver-mysql.c

2023-09-05 13:39:40 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (21927de9f4)

    dsync: Destroy name128_remotesep_hash in dsync_mailbox_tree_deinit()

    Forgotten in 678d0463849ba777106eb7875f27db07a5d8e3df

M	src/doveadm/dsync/dsync-mailbox-tree.c

2023-09-02 17:50:55 +1000 Ted Phelps <phelps@gnusto.com> (6901e5fc1c)

    dsync: Fix an infinite loop

    Be sure to update 'name' when traversing the components of a path in
    convert_name_to_remote_sep.  Otherwise we end up allocating a lot of memory
    and failing.

M	src/doveadm/dsync/dsync-mailbox-tree.c

2023-08-30 13:19:47 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (542877c08e)

    lib-sql: driver-mysql - Initialize MYSQL struct once

    Calling initialize more than once will leak memory.

M	src/lib-sql/driver-mysql.c

2023-08-30 13:21:12 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (939e47c94e)

    lib-sql: driver-mysql - Use driver_mysql_disconnect() in deinit

    This ensures we call mysql_close() only in one place.

M	src/lib-sql/driver-mysql.c

2023-08-29 15:04:04 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (f55acdc81c)

    lib-sql: driver-mysql - Use container_of instead of blind cast


M	src/lib-sql/driver-mysql.c

2023-07-17 10:36:32 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (34f597596e)

    lib-sql: Disconnect SQL connection on error


M	src/lib-sql/driver-mysql.c

2023-06-22 10:48:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (648b5a3a6e)

    mdbox: Fix crash still if fdatasync_path() fails

    Broken still in a8424a71d70e2f5c54d9e2aab8338cf9547b15b4

M	src/lib-storage/index/dbox-multi/mdbox-save.c

2023-08-30 15:46:20 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (02bf7bd126)

    configure: Update version


M	configure.ac

2023-08-30 15:45:45 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (c658ae5288)

    NEWS: Add news for 2.3.21


M	NEWS

2023-06-15 13:32:11 +0200 Karl Fleischmann <karl.fleischmann@open-xchange.com> (daff6f22c1)

    stats: Allow empty event exporters when registering metrics


M	src/stats/stats-metrics.c

2023-08-29 10:13:34 +0000 Marco Bettini <marco.bettini@open-xchange.com> (c7a8868882)

    fts: doveadm - Add missing pool initialization in cmd_search_box()

    Broken by: 467a664b5fce33f3d47a3e1171ecacb508968d1a

M	src/plugins/fts/doveadm-fts.c

2023-08-24 12:26:44 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (526b66635d)

    auth: db-oauth2 - Set default value for active_attribute and active_value to
    empty string

    Otherwise it will always require this attribute to be present when not 
    configured.

M	src/auth/db-oauth2.c

2023-08-24 22:16:36 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (476e03f65b)

    login-common: If authentication is aborted, clear out final response.


M	src/login-common/sasl-server.c

2023-06-01 10:47:50 +0000 Marco Bettini <marco.bettini@open-xchange.com> (bfb698553f)

    auth: db-oauth2 - Handle the case for check on attribute presence only


M	src/auth/db-oauth2.c

2023-06-01 08:37:56 +0000 Marco Bettini <marco.bettini@open-xchange.com> (b6e310356f)

    auth: db_oauth2_user_is_enabled() - Flatten the code


M	src/auth/db-oauth2.c

2022-05-17 15:19:49 -0400 Steve Mokris <steve@kosada.com> (7969d5be1d)

    auth: db-oauth2 - Fail login if active_attribute is missing

    If active_attribute is required by config, we should fail to login when it's
    missing.

M	src/auth/db-oauth2.c

2023-05-12 11:48:25 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (f3e85d8f51)

    lib-oauth2: Do not send empty client_id or client_secret


M	src/lib-oauth2/oauth2-request.c

2023-05-12 11:47:41 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (9ad55e6c04)

    lib-oauth2: Do not send client_id and client_secret as parameters in POST
    queries

    They need to be configured in the URL as Basic auth instead.

M	src/lib-oauth2/oauth2-request.c

2023-05-12 08:59:50 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (e449757553)

    lib-oauth2: Do not send client_id & client_secret as POST parameters when
    doing introspection


M	src/lib-oauth2/oauth2-request.c

2023-05-08 08:38:20 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (8623cb0319)

    lib-oauth2: Validate scope when configured


M	src/lib-oauth2/oauth2-jwt.c
M	src/lib-oauth2/test-oauth2-jwt.c

2023-05-08 08:23:39 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (9c7f5a74a7)

    lib-oauth2: Remove typ check

    It is not really useful. And mostly just keeps breaking when people invent
    new kty values.

M	src/lib-oauth2/oauth2-jwt.c

2023-05-08 08:21:43 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (63e0c9ede4)

    lib-oauth2: Ensure aud field has client_id when set.

    OpenID Connect 1.0 specification says that "aud" field must contain OAuth
    2.0 client_id of the Relying Party as an audience value.

M	src/lib-oauth2/oauth2-jwt.c

2023-05-15 13:49:58 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (18576fde01)

    auth: mech-oauth2 - Always fail with protocol specific error


M	src/auth/mech-oauth2.c

2023-05-15 11:51:19 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (59647f483c)

    auth: mech-oauth2 - Look for openid configuration URL if missing


M	src/auth/mech-oauth2.c
M	src/auth/passdb-oauth2.c
M	src/auth/passdb.h

2023-05-04 15:44:15 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (3db58fd809)

    lib-oauth2: Return failure instead of crash with invalid or missing token


M	src/lib-oauth2/oauth2-request.c

2022-12-14 10:10:12 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (d6ff43f766)

    auth: db-oauth2 - Add accessor for OpenID configuration URL


M	src/auth/db-oauth2.c
M	src/auth/db-oauth2.h

2023-06-02 14:20:08 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (77e2d55092)

    auth: db-oauth2 - Store request username


M	src/auth/db-oauth2.c

2023-05-15 12:41:39 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (3a69b83a35)

    auth: Add auth_request_fail_with_reply()


M	src/auth/auth-request.c
M	src/auth/auth-request.h

2023-05-15 13:49:41 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (d8fdd193f0)

    auth: Pass along final response with failure


M	src/auth/auth-request-handler.c

2023-05-15 12:28:53 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (78b8d7c861)

    lib-auth: Move auth_client_request_continue() lower

    Simplifies next commit

M	src/lib-auth/auth-client-request.c

2023-05-15 14:27:55 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (7e5c9ad6da)

    login-common: Serve final response for client on failure


M	src/login-common/client-common-auth.c
M	src/login-common/client-common.c
M	src/login-common/client-common.h
M	src/login-common/sasl-server.c
M	src/login-common/sasl-server.h

2023-05-15 13:49:51 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (dbb801a8f0)

    login-common: Ignore resp when present


M	src/login-common/client-common-auth.c

2023-05-03 14:35:54 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (5061e0c48a)

    acl: Fix wrong \HasChildren flags for parent mailboxes containing '*' and
    '%'

    '*' in mailbox name is replaced with '%' while child mailboxes still have
    '*' in their path, this results in wrong \HasNoChildren flag.

M	src/plugins/acl/acl-mailbox-list.c

2023-05-03 14:35:18 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (f2e50d5676)

    lib-storage: Whitespace cleanup.


M	src/lib-storage/list/mailbox-list-iter.c

2023-05-09 07:22:15 +0000 Marco Bettini <marco.bettini@open-xchange.com> (50af4232c1)

    lib-storage: Add mail_get_message_id_no_validation()


M	src/lib-storage/mail-storage.h
M	src/lib-storage/mail.c

2023-05-16 09:40:55 +0000 Marco Bettini <marco.bettini@open-xchange.com> (06aecd2b95)

    lib-dict: redis_reply_callback() - Don't crash if there is no callback


M	src/lib-dict/dict-redis.c

2023-04-18 00:08:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (175043954c)

    lib-index: Delete dovecot.index.cache during purging if it becomes too large

    This only happens if the file was already too large before the purging 
    happens. This mainly fixes assert-crashes caused by old huge >1GB cache 
    files.

    Fixes: Panic: file mail-index-util.c: line 10 (mail_index_uint32_to_offset):
    assertion failed: (offset < 0x40000000)

M	src/lib-index/mail-cache-purge.c

2022-05-17 12:31:40 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (9f903ee879)

    lib-master: Use ssl_require_crl setting only for server-side SSL settings

    We don't currently properly support checking CRLs when acting as SSL client. 
    The CRL would have to be stored as part of the CAs, which isn't commonly 
    done. This bug has been in the code ever since it was added in 
    30c5c1fc3608ae575f11960281d3e338b6bf7bc8, but it became more noticeable with
    recent changes that started using lib-master for getting all SSL client
    settings, e.g. 1e5324b5805bf7299cd8196f7b659fe935f027bd

M	src/lib-master/master-service-ssl-settings.c

2023-04-06 09:04:35 +0200 Karl Fleischmann <karl.fleischmann@open-xchange.com> (08528c38e1)

    stats: stats_metrics_add_dynamic() - Validate event exporter


M	src/stats/stats-metrics.c

2023-03-23 15:37:28 +0000 Marco Bettini <marco.bettini@open-xchange.com> (b3981ea5c6)

    lib-master: stats_client_deinit() - Ensure conn.output is flushed before
    returning

    This prevents losing exported events still waiting in buffers while the
    process exits.

M	src/lib-master/stats-client.c

2023-03-27 08:19:38 +0000 Marco Bettini <marco.bettini@open-xchange.com> (e52db68ff4)

    lib-master: stats_event_callback() - Skip if conn.output is already closed

    This also prevents further errors from happening on the closed stream.

M	src/lib-master/stats-client.c

2023-03-24 14:04:00 +0000 Marco Bettini <marco.bettini@open-xchange.com> (9c3e210f1e)

    lib-master: stats_client_send_event() - Also flush conn.output and check for
    errors


M	src/lib-master/stats-client.c

2023-03-23 15:35:49 +0000 Marco Bettini <marco.bettini@open-xchange.com> (6231b7af67)

    lib-master: stats_event_write() - Don't accumulate more than IO_BLOCK_SIZE
    bytes in str buffer


M	src/lib-master/stats-client.c

2023-02-24 14:06:14 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d6c67f24c4)

    lib: event-filter-parser.y - Add workaround for nerrs being unused warning

    Fixes with clang-17: warning: variable 'event_filter_parser_nerrs' set but
    not used

M	src/lib/event-filter-parser.y

2023-02-24 14:02:01 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (6c22f4dc1f)

    global: Remove dead code


M	src/lib-dict/test-dict-client.c
M	src/lib-master/test-event-stats.c
M	src/lib/test-mempool-allocfree.c

2021-12-31 11:29:02 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7c73ba5364)

    lib-dict: test-dict-client - Handle shutdown cleanly with ctrl-c


M	src/lib-dict/test-dict-client.c

2022-07-07 13:58:02 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (4c06fee481)

    login-common: Handle missing ssl_iostream in get_var_expand_table()

    It can be missing during connection disconnection when connection is lost
    uncleanly.

M	src/login-common/client-common.c

2023-04-04 11:51:22 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b0fd628d56)

    notify-status: Fix crash if user initialization fails

    The deinit code crashed if mail_namespaces_created hook hadn't been called 
    before user was deinitialized.

M	src/plugins/notify-status/notify-status-plugin.c

2023-06-29 13:40:24 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (2340275fad)

    lib-sql: pgsql - Use orig_ioloop instead of local variable

    orig_ioloop is used later, leaving it NULL here causes problems when timeout
    is added by sqlpool.

    Broken in 8981a973987c237552e46b68075b64caa8c1f5bb

M	src/lib-sql/driver-pgsql.c

2023-06-26 10:43:00 +0000 Marco Bettini <marco.bettini@open-xchange.com> (4c3ae0468e)

    dbox: Fix for dangling pointer being passed to cleanup_interval()

    Broken in 88eee28fd86d619b26ce6aebadca5b18e748dc6f

M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-common/dbox-storage.h
M	src/lib-storage/index/dbox-multi/mdbox-map.c

2023-06-20 18:58:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (7268e169ec)

    mdbox: Optimize mail_temp_scan_interval storage/ scanning

    Use the generic dbox scanning code, which avoids stat()ing the directory by 
    keeping the timestamp in index header. Also do the scanning while at session
    deinit instead of startup, so the latency isn't visible to clients.

M	src/lib-storage/index/dbox-multi/mdbox-map.c

2023-06-20 18:58:00 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (37ddfe8efb)

    lib-storage: Split off index_mailbox_view_update_last_temp_file_scan()


M	src/lib-storage/index/index-storage.c
M	src/lib-storage/index/index-storage.h

2023-06-20 22:28:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6b4a3f8e7b)

    dbox: mail_temp_scan_interval - Fix deleted temp file prefix

    dbox files are always created with DBOX_TEMP_FILE_PREFIX, not the mailbox 
    list-specific prefix. This was a problem only if dbox was used with 
    LAYOUT=Maildir++, which nobody was likely to do. Other layouts had identical
    temp file prefixes to DBOX_TEMP_FILE_PREFIX.

M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-06-20 18:54:49 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (41ddf30762)

    dbox: Split off dbox_mailbox_list_cleanup()


M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-common/dbox-storage.h

2023-06-20 18:44:52 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (58028ecbcf)

    mdbox: Don't do temp file scanning for mailbox directories

    The intention was to delete any temporary mail files that have been left 
    behind by crashed processes, but mail files are written to storage/ 
    directory.

M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-common/dbox-storage.h
M	src/lib-storage/index/dbox-single/sdbox-storage.c

2023-06-20 18:24:34 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a8424a71d7)

    mdbox: Fix fdatasync() path when saving mails

    It was supposed to be called on the parent directory of where mails were 
    written, i.e. storage/ directory. The previous code was instead calling it 
    on the mailbox-specific directory (similarly to sdbox) where nothing was 
    written.

M	src/lib-storage/index/dbox-multi/mdbox-save.c

2023-06-20 18:21:38 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (c6935e5ef2)

    mdbox: Fix crash if fdatasync_path() fails

    There is no dest_mail anymore at this stage of transaction.

M	src/lib-storage/index/dbox-multi/mdbox-save.c

2023-04-12 12:06:52 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (7bb46f7e89)

    lib-storage: Rollback save transaction when transaction commit fails.


M	src/lib-storage/index/index-transaction.c

2023-02-05 20:51:12 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ac81ce75a6)

    sdbox: Fix panic due to leaked mail_index_view if sync fails

    Fixes: Panic: Leaked view for index .../dbox-Mails/dovecot.index: Opened in
    mail-index-sync.c:445

M	src/lib-storage/index/dbox-single/sdbox-sync.c

2023-02-05 20:50:06 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (aae93d3ea7)

    lib-index: Don't update log_file_tail_offset on sync if reading
    dovecot.index.log failed

    This is more of a theoretical issue, since dovecot.index.log read failure is 
    very unlikely.

M	src/lib-index/mail-index-sync-update.c

2023-02-05 20:47:08 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (830a7db7c0)

    lib-index: Don't update max_tail_offset if write to dovecot.index.log fails

    The max_tail_offset didn't actually increase in that situation. This fixes
    wrongly updating mail_index_header.log_file_tail_offset after write to
    dovecot.index.log failed (due to out of disk space), which in turn can cause
    some unexpected errors.

M	src/lib-index/mail-transaction-log-append.c

2023-02-05 20:46:34 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (08740f7902)

    lib-index: Fix event leak if purging dovecot.index.cache fails


M	src/lib-index/mail-cache-purge.c

2022-11-02 15:56:54 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (6d5eb29761)

    lib-oauth2: jwt - Allow missing 'typ' field


M	src/lib-oauth2/oauth2-jwt.c
M	src/lib-oauth2/test-oauth2-jwt.c

2020-05-28 15:05:08 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (9f528295d1)

    lib-oauth2: test-oauth2-jwt - Ensure we ignore 'none' algorithm


M	src/lib-oauth2/test-oauth2-jwt.c

2023-04-14 11:35:30 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (3ea25161a3)

    lib-login: Don't update process title if verbose_proctitle=no

    Broken by 4fcd7f497577af361fc3313fbc07a61c14e17715

M	src/lib-master/master-login.c

2023-03-24 03:26:33 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1e8d0face3)

    global: Enable login_server_settings.update_proctitle


M	src/imap-urlauth/imap-urlauth.c
M	src/imap/main.c
M	src/pop3/main.c
M	src/submission/main.c

2023-03-24 03:26:11 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (2a9b8c4e3a)

    lib-login: Add login_server_settings.update_proctitle

    Update the current login state in process title when enabled.

M	src/lib-master/master-login.c
M	src/lib-master/master-login.h

2023-03-24 04:02:28 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (5266019fbb)

    lib-login: Keep connection in server's linked list until it's fully freed

    Otherwise the connection isn't accessible from any global variables.

M	src/lib-master/master-login.c

2023-03-24 02:29:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (af6edaef3f)

    imap: Update process title while unhibernating

    Previously the process title stayed as [idling] even though the process was 
    busy waiting on the imap-hibernate process to finish sending the 
    unhibernation request.

M	src/imap/imap-master-client.c
M	src/imap/imap-master-client.h
M	src/imap/main.c

2023-03-24 02:00:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ed42bc9c0f)

    lib-master: Set process title to [initializing] until
    master_service_init_finish()


M	src/lib-master/master-service.c

2023-03-24 02:02:58 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d591711cdb)

    lib: Add process_title_get_counter()


M	src/lib/process-title.c
M	src/lib/process-title.h

2023-03-24 01:53:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c7cf91d863)

    master: Set VERBOSE_PROCTITLE environment to child processes

    This is needed for updating process title during initialization before 
    settings are read.

M	src/lib-master/master-interface.h
M	src/master/service-process.c

2023-03-24 01:15:21 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (f89dec342d)

    imap: Disconnect imap-master client if it's not sending anything for 25
    seconds


M	src/imap/imap-master-client.c

2023-03-24 01:45:34 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (61e4e19d06)

    imap: Improve disconnection log message if it happens immediately after
    unhibernation

    The "No commands sent after unhibernation" can mean that imap-hibernate 
    process saw a timeout while unhibernating and shutdown the connection. Or it
    can also mean just that the client itself disconnected.

M	src/imap/imap-client.c

2023-03-24 01:41:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8eb93d1c41)

    imap-hibernate: If unhibernation fails, make sure imap process won't finish
    it later on

    Especially if unhibernation fails due to a connection timeout to imap 
    process due to high load, it's possible that the imap process will 
    eventually finish the unhibernation and continue with the client. This is 
    rather confusing, since imap-hibernate process already logged that the 
    client got disconnected.

M	src/imap-hibernate/imap-client.c

2022-01-13 16:54:18 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e4d6c8055e)

    imap: Add client.unhibernated boolean


M	src/imap/imap-client.c
M	src/imap/imap-client.h
M	src/imap/imap-common.h
M	src/imap/imap-master-client.c
M	src/imap/main.c
M	src/imap/test-imap-client-hibernate.c

2023-05-05 15:20:34 +0000 Marco Bettini <marco.bettini@open-xchange.com> (80ddfb7b30)

    auth: mech_gssapi_unwrap() - Release gss_release_buffe(outbuf) before
    returning


M	src/auth/mech-gssapi.c

2023-03-23 22:23:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7566d8783f)

    master: Fix service { idle_kill } to work better on busy servers

    The previous behavior was to kill a process once it had idled for idle_kill 
    seconds. However, on a busy server the new connections are picked up
    somewhat randomly by all the idling processes, so there's never any single
    process idling for a long time. This effectively prevents the idle_kill from
    killing any processes, even if there are unnecessarily many of them.

    The new behavior here tracks the lowest number of idling processes during 
    idle_kill time interval. Then it kills that many processes. If the load 
    stays the same, this should shrink the number of processes to the number 
    that is needed to handle the load, but no more.

M	src/master/service-monitor.c
M	src/master/service-process.c
M	src/master/service.h

2023-03-23 16:07:26 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d0e74ddac0)

    master: Replace per-process idle_kill timeout with per-service

    This is much more efficient, since it doesn't have to keep updating the 
    timeout constantly for busy processes.

    This change still preserves the original way the idle_kill setting behaves.

M	src/master/service-monitor.c
M	src/master/service-process.c
M	src/master/service-process.h
M	src/master/service.h

2023-03-23 16:37:08 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (008622eb2c)

    master: Add asserts to make sure counters don't wrap


M	src/master/service-process.c

2023-03-23 16:36:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (6cfee1e183)

    master: Add service.process_idling to count number of idling processes


M	src/master/service-monitor.c
M	src/master/service-process.c
M	src/master/service.h

2023-03-23 15:09:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a4e9e0c9b3)

    master: Split processes list to busy and idling processes

    Keep the idling processes sorted by idle_start time. This will be needed by
    the next commit.

M	src/master/main.c
M	src/master/master-client.c
M	src/master/service-monitor.c
M	src/master/service-process.c
M	src/master/service-process.h
M	src/master/service.c
M	src/master/service.h

2023-02-28 12:05:44 +0000 Marco Bettini <marco.bettini@open-xchange.com> (3b67507e97)

    dbox: dbox_cleanup_temp_files() - Fuzz scan interval adding 0..+30% based on
    username hash


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-02-28 11:45:43 +0000 Marco Bettini <marco.bettini@open-xchange.com> (c3756423f0)

    dbox: dbox_cleanup_temp_files() - Reformat code


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-02-28 11:44:48 +0000 Marco Bettini <marco.bettini@open-xchange.com> (5fcf0da179)

    dbox: dbox_cleanup_temp_files() - Remove unnecessary else/else if after
    returns


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-02-28 11:30:22 +0000 Marco Bettini <marco.bettini@open-xchange.com> (e91d8309f5)

    dbox: dbox_mailbox_open() - Drop unused ctime


M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-common/dbox-storage.h
M	src/lib-storage/index/dbox-multi/mdbox-storage.c
M	src/lib-storage/index/dbox-single/sdbox-storage.c

2023-02-28 11:21:10 +0000 Marco Bettini <marco.bettini@open-xchange.com> (4bf0ee1814)

    dbox: dbox_mailbox_open() - Move dbox_cleanup_temp_files() to
    dbox_mailbox_close()


M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/dbox-common/dbox-storage.h
M	src/lib-storage/index/dbox-multi/mdbox-storage.c
M	src/lib-storage/index/dbox-single/sdbox-storage.c

2023-02-28 10:15:50 +0000 Marco Bettini <marco.bettini@open-xchange.com> (f18b8e9f46)

    dbox: dbox_mailbox_open() - Infer last_temp_file_scan from dir's atime if 0


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-02-28 10:14:26 +0000 Marco Bettini <marco.bettini@open-xchange.com> (4ddb4f7656)

    dbox: dbox_mailbox_create() - Update last_temp_file_scan


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-03-03 16:15:17 +0000 Marco Bettini <marco.bettini@open-xchange.com> (119d496acd)

    lib-storage: dbox_cleanup_temp_files() - Fix inverted check for ENOENT


M	src/lib-storage/index/dbox-common/dbox-storage.c

2023-03-24 08:53:27 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (eab9fd0154)

    stats: openmetrics - Set field always when used

    Satisfied static analysers.

    Broken in ba19a18d54cb7cf7de93d6a235862a408cfe5828

M	src/stats/stats-service-openmetrics.c

2023-01-26 08:15:29 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (8aef0ce5ea)

    stats: openmetrics - Create metrics for all specified fields


M	src/stats/stats-service-openmetrics.c

2023-04-04 00:43:55 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4c74cf89f6)

    dsync: Fix handling mailboxes with % character when BROKENCHAR isn't
    explicitly set in config

    When vname_escape_char (= BROKENCHAR) isn't explicitly set in configuration,
    '%' character (or if it was hierarchy separator, '~') was used as the
    default internal escape character. However, this was used inconsistently
    between local and remote mailbox trees. The remote tree stored the mailbox
    names unescaped, while the local mailbox names were escaped. This
    inconsistency caused dsync to do unnecessary mailbox renames, which might
    have ended up failing.

    This especially fixes dsync failures when mailbox name ended with the '%' 
    character.

M	src/doveadm/dsync/dsync-brain-mailbox-tree.c
M	src/doveadm/dsync/dsync-mailbox-tree-fill.c
M	src/doveadm/dsync/dsync-mailbox-tree.h

2023-04-04 00:43:04 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e69f52d697)

    dsync: Refactor dsync_brain_mailbox_to_parts() into
    dsync_mailbox_name_to_parts()


M	src/doveadm/dsync/dsync-brain-mailbox-tree.c
M	src/doveadm/dsync/dsync-mailbox-tree.c
M	src/doveadm/dsync/dsync-mailbox-tree.h

2023-03-20 14:00:48 +0000 Marco Bettini <marco.bettini@open-xchange.com> (37f46933cf)

    virtual: virtual_backend_box_lookup() - Enforce callers to check if the call
    succeeded


M	src/plugins/virtual/virtual-mail.c
M	src/plugins/virtual/virtual-storage.c
M	src/plugins/virtual/virtual-storage.h
M	src/plugins/virtual/virtual-sync.c

2023-03-24 13:50:29 +0000 Marco Bettini <marco.bettini@open-xchange.com> (f861c0be75)

    virtual: virtual_sync_apply_existing_expunges() - Don't crash if the backend
    mailbox has been removed


M	src/plugins/virtual/virtual-sync.c

2023-01-02 10:23:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c29eccb64e)

    lib-index: Fix assert-crash when header's log_file_seq/offset shrinks

    mail_index_sync_set_log_view() is also missing this check, but it doesn't 
    seem to actually happen. It's likely handled by mail_index_map() already.

    Fixes: Panic: file mail-transaction-log-view.c: line 165
    (mail_transaction_log_view_set): assertion failed: (min_file_seq <=
    max_file_seq)

M	src/lib-index/mail-index-sync.c

2022-03-21 12:22:38 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (d3aa3d876a)

    lib-http: http-server-connection - Fix segfault occurring when output is
    resumed on closed connection.


M	src/lib-http/http-server-connection.c

2023-03-07 15:53:06 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7b60aa05af)

    man: Add doveadm fts check fast/full


M	doc/man/doveadm-fts.1.in

2023-02-09 17:04:22 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (5b6f678009)

    lib-imap-client: Fix/clarify selection state handling

    The old code assumed that selected_box would be non-NULL while a new mailbox 
    is being selected. That's not true though, the imapc-storage code closes the 
    old mailbox before selecting the next one. So the QRESYNC-specific code for 
    tracking selected-state was never being used. Fixed this, and clarified in 
    general how the selected-state is supposed to work.

M	src/lib-imap-client/imapc-client.c
M	src/lib-imap-client/imapc-connection.c
M	src/lib-imap-client/imapc-connection.h

2023-02-09 17:03:00 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (2d6514adf9)

    lib-imap-client: Rename imapc_connection.selecting_box to
    qresync_selecting_box

    It's only used when QRESYNC extension is enabled.

M	src/lib-imap-client/imapc-connection.c

2023-02-09 16:21:24 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (dbe23ac284)

    imapc: Fix handling EXISTS reply to previous mailbox while selecting new
    mailbox

    For example if the communication was:

    C: a SELECT box1
    ... C: b SELECT box2 S: * 10 EXISTS S: * 1 EXISTS S: * OK [UIDVALIDITY
    1675948459] UIDs valid S: ... S: b OK

    The first EXISTS is meant for box1, not box2. Fixed by not starting a FETCH
    (FLAGS) for the mailbox being selected until the tagged reply is received.

M	src/lib-storage/index/imapc/imapc-mailbox.c

2023-02-09 16:12:35 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a11c232854)

    imapc: Don't process untagged replies in mailbox that isn't fully selected
    yet

    For example if the communication was:

    C: a SELECT box1
    ... C: b SELECT box2 S: * 1 EXPUNGE S: * 1 EXISTS S: * OK [UIDVALIDITY
    1675948459] UIDs valid S: ... S: b OK

    The expunge was intended for box1, not box2. This caused: Warning:
    imapc(...): Mailbox '...' state corrupted: EXPUNGE received for empty
    mailbox - reconnecting

    Fixed this by ignoring untagged EXPUNGE, FETCH, SEARCH and ESEARCH replies 
    when the UIDVALIDITY reply hasn't been yet received for a mailbox.

M	src/lib-storage/index/imapc/imapc-mailbox.c
M	src/lib-storage/index/imapc/imapc-storage.h

2023-02-08 20:40:41 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (cf7d19e729)

    auth: test-lua - Check that password is returned in lookup


M	src/auth/test-lua.c

2023-02-08 20:32:57 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (0cc4207a33)

    auth: test-lua - Test bad keynames end up ignored


M	src/auth/test-lua.c

2023-02-01 13:58:42 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (97e121bb6d)

    lib-storage: mail-user - Add event_ prefixed values from userdb as event
    fields


M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h

2023-02-01 13:53:42 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (01263527d5)

    login-common: Add event_ prefixed values from auth as event fields


M	src/lib-auth/auth-client-request.c
M	src/login-common/client-common-auth.c
M	src/login-common/sasl-server.c

2023-02-06 21:23:48 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (bb8fbcc60a)

    auth: db-lua - Skip invalid keys and values on field export


M	src/auth/db-lua.c

2023-01-20 16:41:47 +0100 Markus Valentin <markus.valentin@open-xchange.com> (0e3b992877)

    maildir: maildir_mailbox_open() - Split off maildir_is_selectable()


M	src/lib-storage/index/maildir/maildir-storage.c

2023-01-20 16:40:22 +0100 Markus Valentin <markus.valentin@open-xchange.com> (7522de9385)

    maildir: maildir_mailbox_open() - If the namespace root or INBOX has any
    subdir create others as well


M	src/lib-storage/index/maildir/maildir-storage.c

2023-01-20 08:50:48 +0100 Markus Valentin <markus.valentin@open-xchange.com> (d669ab7d1b)

    maildir: maildir_mailbox_open() - Disable maildir subdirectory creation for
    INBOX

    This was added in 522925f6e9ff8fe9592511c2221b3d6526d4cbf4. In the meantime
    autocreate code changed so this is no longer valid.

M	src/lib-storage/index/maildir/maildir-storage.c

2023-01-09 15:10:47 +0100 Markus Valentin <markus.valentin@open-xchange.com> (dc1d871a38)

    welcome-plugin: Remove welcome_open_box()


M	src/plugins/welcome/welcome-plugin.c

2023-01-09 15:06:54 +0100 Markus Valentin <markus.valentin@open-xchange.com> (171295bdef)

    welcome-plugin: Move script_execute() to welcome_create_box()

    The welcome script was executed while opening the INBOX only when the same
    session had created it. This could have led to unexpectedly not executing
    welcome when not opening the mailbox right after it was created.

    The original code delayed the welcome script run because mailbox creation 
    wasn't finished until the mailbox was opened. This seems to have become 
    fixed at some point.

M	src/plugins/welcome/welcome-plugin.c

2023-01-17 08:44:55 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (cb666c441a)

    lib-http: server - Fix potential crash with previous change on client
    disconnect

    Broken by 1418d1e9018fc34287722467c6ee506f3e378e1a

M	src/lib-http/http-server-response.c

2023-01-11 14:32:20 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1414b26044)

    lib-http: test-http-payload - Use ostream-final-trickle for server
    connections


M	src/lib-http/test-http-payload.c

2023-01-11 14:31:55 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (72de31a36e)

    lib-http: test-http-payload - Add filenames to data mismatch error messages


M	src/lib-http/test-http-payload.c

2023-01-11 14:26:53 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b0801787b2)

    lib-test: Add ostream-final-trickle


M	src/lib-test/Makefile.am
A	src/lib-test/ostream-final-trickle.c
A	src/lib-test/ostream-final-trickle.h

2023-01-11 16:02:38 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d3a0ff0ef3)

    lib: Add connection_vfuncs.init()


M	src/lib/connection.c
M	src/lib/connection.h

2023-01-12 12:23:31 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e72869b16a)

    lib-http: server - Don't disconnect client before response is fully sent

    This could happen at least when the payload is empty and the final LF was 
    buffered.

M	src/lib-http/http-server-response.c

2023-01-11 00:44:40 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a5bd8e1bc5)

    lib-http: server - Don't disconnect client before payload is fully sent


M	src/lib-http/http-server-response.c

2023-01-12 17:17:29 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ec90c65b92)

    lib-storage: Add mail_storage_service_input.unexpanded_set_parser


M	src/lib-storage/mail-storage-service.c
M	src/lib-storage/mail-storage-service.h

2022-11-23 09:21:10 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (90ac2496ca)

    NEWS: Update news


M	NEWS

2022-12-28 12:19:11 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (ed402ee9a7)

    auth: Fix auth_request_password_verify() result handling

    Pass the result directly to caller, as auth_request_password_verify() 
    returns passdb result already.

M	src/auth/auth-worker-client.c
M	src/auth/passdb-cache.c
M	src/auth/passdb-dict.c
M	src/auth/passdb-ldap.c
M	src/auth/passdb-lua.c
M	src/auth/passdb-passwd-file.c
M	src/auth/passdb-passwd.c
M	src/auth/passdb-sql.c
M	src/auth/passdb-static.c

2022-12-28 12:05:39 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (65d5b77f0e)

    auth: Change auth_request_password_verify() to return enum passdb_result

    This does not break anything, because PASSDB_RESULT_OK is 1 and mismatch is
    0.

M	src/auth/auth-request.c
M	src/auth/auth-request.h

2022-12-26 23:48:27 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8832f6c002)

    lib-storage: Fix unnecessary data stack growth when iterating mailboxes

    When listing mailbox list indexes, it was possible that each iteration 
    increased the data stack memory usage. It was all freed at the end though, 
    so this didn't cause any permanent leaks.

    Broken by 4fdb040d2471c6e5006579bef1dd0586f89c8570

M	src/lib-storage/list/mailbox-list-index-iter.c

2022-12-14 15:07:38 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (1fc7d5465f)

    lib-lua: http - Use correct dns-client path

    The current code tries to look it up from user homedir sometimes.

    Broken in 5b56debd31800ec45fc0c6529b138d1ce943b0aa

M	src/lib-lua/dlua-dovecot-http.c

2022-12-01 10:54:38 +0100 Markus Valentin <markus.valentin@open-xchange.com> (ea3859fd59)

    lib-sql: Add sql_statement_set_no_log_expanded_values()

    This allows to store no_log_expanded_values to sql_statement.

M	src/lib-dict-backend/dict-sql.c
M	src/lib-sql/sql-api-private.h
M	src/lib-sql/sql-api.c
M	src/lib-sql/sql-api.h

2022-12-01 11:13:16 +0100 Markus Valentin <markus.valentin@open-xchange.com> (dd7f5beff9)

    dict: Implement DICT_PROTOCOL_CMD_HIDE_LOG_VALUES for dict and dict-proxy


M	src/dict/dict-commands.c
M	src/lib-dict/dict-client.c
M	src/lib-dict/dict-client.h

2022-12-01 11:03:26 +0100 Markus Valentin <markus.valentin@open-xchange.com> (b94b31d5a9)

    lib-dict: Add .set_hide_log_values() to dict vfuncs

    This is used to set hide_log_values in dict op settings.

M	src/lib-dict/dict-private.h
M	src/lib-dict/dict.c
M	src/lib-dict/dict.h

2022-12-05 11:58:31 +0100 Markus Valentin <markus.valentin@open-xchange.com> (0f5980d01e)

    cassandra: Rename query to log_query and initialize it with
    sql_statement_get_log_query()

    Also add sql_statement_get_log_query() to sql-api.

M	src/lib-sql/driver-cassandra.c
M	src/lib-sql/sql-api-private.h
M	src/lib-sql/sql-api.c

2022-12-05 11:50:30 +0100 Markus Valentin <markus.valentin@open-xchange.com> (ec9f878128)

    lib-event: Add event_unset_log_message_callback()


M	src/lib/lib-event.c
M	src/lib/lib-event.h

2022-11-28 11:17:11 +0100 Markus Valentin <markus.valentin@open-xchange.com> (74bbb6b0e9)

    fs-api: Add fs_get_event()


M	src/lib-fs/fs-api.c
M	src/lib-fs/fs-api.h

2022-12-01 12:37:17 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (f23ca5016f)

    pop3: Fix assert-crash when POP3 command name contained ':'

    The cmd_<name> reason code now only uses valid command names.

    Broken by d2ab26be6038bd53b13a3ff18c403d6c192c1d91 with incomplete fix in 
    1309137812424c80e63d3c1052795b43d6e19803.

    Fixes: Panic: event_reason_code_prefix(): name has ':'

M	src/pop3/pop3-client.c
M	src/pop3/pop3-commands.c
M	src/pop3/pop3-commands.h

2022-12-01 12:32:28 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (cdd778233d)

    pop3: Move pop3 commands to array and add pop3_command_find()


M	src/pop3/pop3-commands.c
M	src/pop3/pop3-commands.h

2022-11-23 09:21:10 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (1f127c8a59)

    NEWS: Update news


M	NEWS

2022-11-14 23:27:33 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (88150e0bb8)

    lmtp: Fix restoring global log prefix after session is finished

    Broken by 069dfd657fd91a0e2a3a9307a0cf499d795f27f2

    This change also slightly changes the lmtp log prefixes in some places. It
    removes "conn $ip:$port [$idx]: rcpt $user:" from some of the log messages
    (but that wasn't in all of the log messages anyway), but it now always
    includes mail_log_prefix in these log messages, which previously wasn't
    always set at that point yet.

M	src/lmtp/main.c

2022-10-21 13:32:48 +0000 Marco Bettini <marco.bettini@open-xchange.com> (805db6b027)

    fts: struct fts_user - Drop data_languages


M	src/plugins/fts/fts-user.c
M	src/plugins/fts/fts-user.h

2022-10-21 09:15:04 +0000 Marco Bettini <marco.bettini@open-xchange.com> (74d8e389bf)

    fts: fts-search-args - Fix stopwords expansion (only on multiple languges
    and with stopword filter enabled)


M	src/plugins/fts/fts-search-args.c

2022-10-20 14:07:23 +0000 Marco Bettini <marco.bettini@open-xchange.com> (07ec8339ee)

    lib-storage: enum mail_search_arg_type - Add SEARCH_NIL


M	src/lib-storage/index/imapc/imapc-search.c
M	src/lib-storage/index/index-search.c
M	src/lib-storage/mail-search-args-cmdline.c
M	src/lib-storage/mail-search-args-imap.c
M	src/lib-storage/mail-search-args-simplify.c
M	src/lib-storage/mail-search-register-imap.c
M	src/lib-storage/mail-search.c
M	src/lib-storage/mail-search.h
M	src/lib-storage/test-mail-search-args-simplify.c

2022-11-09 15:29:39 +0000 Marco Bettini <marco.bettini@open-xchange.com> (f41286b8f1)

    lib-storage: mail_search_args_simplify_drop_redundant_args() - Apply
    Absorptive law versus all terms, not just the 1st


M	src/lib-storage/mail-search-args-simplify.c
M	src/lib-storage/mail-search.c
M	src/lib-storage/mail-search.h
M	src/lib-storage/test-mail-search-args-simplify.c

2022-11-03 17:40:28 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8fb6b9e1b8)

    dsync: Skip autocreated mailboxes that haven't been created yet


M	src/doveadm/dsync/dsync-mailbox-tree-fill.c

2022-11-04 14:01:14 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b05564d157)

    imapc: Fix listing INBOX when INBOX is already the namespace prefix

    This especially caused problems when using dsync with imapc, resulting in
    "Remote lost mailbox GUID" errors.

M	src/lib-storage/index/imapc/imapc-list.c

2022-11-01 11:21:34 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (142c054f85)

    replicator: Fix crash when importing user not listed by userdb iteration

    Broken by 31545b4f38ea85615f0111a33d630a03d92d22ab

M	src/replication/replicator/replicator-queue.c

2022-08-16 23:42:51 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (7286076402)

    replicator: Add unit test to replicator-queue


M	src/replication/replicator/Makefile.am
A	src/replication/replicator/test-replicator-queue.c

2022-10-28 17:57:03 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (95ec1043e0)

    replicator: Add replicator_queue_count() and replicator_queue_peek()

    These will be useful for the following unit test.

M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2022-10-25 15:39:39 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8190571703)

    replicator: Add "next sync secs" field to doveadm replicator status


M	src/doveadm/doveadm-replicator.c
M	src/replication/replicator/doveadm-connection.c

2022-10-25 13:27:23 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (390e5a4c3d)

    replicator: Make sure to prevent request starvation

    This synchronizes how priority queue is ordered vs what 
    replicator_queue_want_sync_now() returns. The mismatch might have caused 
    request starvation in some situations because they behaved differently.

    Also this change makes sure that higher priority requests don't infinitely 
    block lower priority requests. Instead, they get a temporary boost time
    (hardcoded 15-45 minutes). Afterwards lower priority requests are started to
    be handled as well.

M	src/replication/replicator/doveadm-connection.c
M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2022-10-25 13:11:37 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (97bf10e1da)

    replicator: Don't update user's last_update if priority doesn't change

    This didn't actually matter, since it was only used to check if importing 
    should update an existing user. However, importing is only run at startup 
    when all users have last_update=0 anyway.

    The following changes bring new use cases for last_update.

M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2022-10-25 13:08:36 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5c9f252471)

    replicator: Change replicator_queue_add_sync_callback() to take user struct

    This is just to clean up the API to match the previous change.

M	src/replication/replicator/notify-connection.c
M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2022-10-25 12:49:03 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (278d4a08f2)

    replicator: Fix user placement in replication queue

    Especially replicator queue importing and NOTIFY command could have placed
    the user to wrong place in the queue, because they modified the last sync
    timestamps afterwards.

    Fixed by splitting replicator_queue_add() into get/update/add(), so all the
    necessary changes can be done before replicator_queue_add() is used to place
    the user into the queue.

M	src/replication/replicator/doveadm-connection.c
M	src/replication/replicator/notify-connection.c
M	src/replication/replicator/replicator-queue-auth.c
M	src/replication/replicator/replicator-queue.c
M	src/replication/replicator/replicator-queue.h

2022-10-28 00:56:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (94f620c4da)

    maildir: If mailbox create fails, don't try to apply mailbox_update changes

    This was especially causing problems with mailbox GUID mismatches in dsync. 
    The mismatch wasn't automatically fixed, because mailbox_create()
    incorrectly kept updating the mailbox GUID for the already existing mailbox.

    Fixes errors such as: Remote lost mailbox GUID ... (maybe it was just
    deleted?)

M	src/lib-storage/index/maildir/maildir-storage.c

2022-10-27 02:56:45 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (29c982fe52)

    lib-storage: mailbox_attribute_get*() - Fail early on with empty key lookup

    This fixes using mail_attribute_dict with dict-sql.

M	src/lib-storage/mailbox-attribute.c

2022-03-03 14:21:00 +0100 Markus Valentin <markus.valentin@open-xchange.com> (2aa632260b)

    imapc: imapc_connection_disconnect_full() - Only conditionally abort

    Only abort commands if there are no reconnect commands. Otherwise these 
    still will be handled and the commands memory will be freed after handling 
    them.

    Broken by 6d16e82fa2c352974558e1415d06f07d8962fe09

M	src/lib-imap-client/imapc-connection.c

2022-02-28 15:50:05 +0100 Markus Valentin <markus.valentin@open-xchange.com> (e91916ad57)

    imapc: imapc_connection_disconnect_full() - Prevent leaking cmd->pool

    If the imapc connection was already disconnected when calling 
    imapc_connection_disconnect() it didn't clean up the commands and especially
    the command pools.

M	src/lib-imap-client/imapc-connection.c

2022-10-12 13:26:03 +0200 Markus Valentin <markus.valentin@open-xchange.com> (b0f19c117a)

    imapc: imapc_mailbox_get_status() - Implement STATUS_UNSEEN with INDEXPVT


M	src/lib-storage/index/imapc/imapc-storage.c

2022-10-19 09:26:55 +0300 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (410acf8760)

    lib-storage: mail-storage-list-index-rebuild - Don't use continue inside
    T_BEGIN..T_END

    Coverity doesn't like using continue there.

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-10-05 15:42:25 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (ef26f7d1ef)

    lib-storage: LAYOUT=index rebuild - Fix detecting duplicate mailbox GUIDs in
    index

    Otherwise duplicate folders are not properly cleared out.

    Broken in 2fc8d7024bb161aab08031b8212a736301844858

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-10-05 15:27:31 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (ce65fc1fc9)

    lib-storage: LAYOUT=index rebuild - Remove existence check

    It's not needed.

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-09-27 15:03:37 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (8dbd0d79cc)

    lib-storage: LAYOUT=index rebuild - Sort mailbox tree before creating

    Try to load the mailbox original name already from storage so we can sort &
    create the mailbox tree in correct order.

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-09-27 13:01:29 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (1ff6f0948a)

    lib-storage: LAYOUT=index rebuild - Remove first_list usage

    Instead, keep track of the list where box was found.

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-10-05 15:15:17 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (b5b41c5410)

    lib-storage: LAYOUT=index rebuild - Remove useless check for LAYOUT=index

    This is already done when collecting namespaces.

    Simplifies next change.

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-09-21 11:14:40 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (7c2176d18e)

    lib-storage: LAYOUT=index rebuild - Fix rebuilds when using multiple
    namespaces

    The old code did not properly populate the mailbox list for each namespace,
    but only for the first namespace. This caused mailbox storage existence
    checks to always fail.

    This applies for LAYOUT=index only.

    Broken in 2fc8d7024bb161aab08031b8212a736301844858

M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2022-10-18 11:35:22 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (bcdf913eb8)

    lib-storage: list - Add separators to mailbox names when decoding from index

    Mailbox name header decode did not add separators to name, producing only
    FooBarBar, when it was supposed to give Foo/Bar/Baz.

    Broken in 8216a079d8aac93e2537ed79485e301350ff3887

M	src/lib-storage/list/mailbox-list-index.c

2022-10-11 11:17:11 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (efafbfaad6)

    lib-storage: Store mailbox names unescaped in box-name header

    This header is used when rebuilding mailbox list indexes with LAYOUT=index. 
    The escape character is currently hardcoded for LAYOUT=index, so this 
    couldn't have broken anything unless the hardcoded separator was changed. 
    Still, this was wrong/confusing behavior.

M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/list/mailbox-list-index.h

2022-06-15 12:19:55 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (27131bdfa3)

    dict-redis: Fix crash when using synchronous commit

    Redis is usually used via dict proxy process, which always uses async 
    commit, so this didn't matter so much.

M	src/lib-dict/dict-redis.c

2022-02-10 17:12:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a8f52eb73f)

    director: Fix handling auth_master_user_separator setting

    It was actually using a separate master_user_separator setting, causing 
    logins based on auth_master_user_separator to be hashed to wrong backends.

M	src/director/director-settings.c
M	src/director/director-settings.h
M	src/director/login-connection.c

2022-09-27 14:28:38 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4a1b25a1c0)

    doveadm: Fix assert-crash on secondary service_user failures

    This mainly affected dsync when imapc authentication failed, but could have 
    also happened with copy and import commands.

    Fixes: Panic: file lib-event.c: line 506 (event_pop_global): assertion
    failed: (event == current_global_event)

M	src/doveadm/doveadm-mail.c

2022-09-28 16:21:26 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (069dfd657f)

    lib-storage: Fix MAIL_STORAGE_SERVICE_FLAG_NO_LOG_INIT to not change log
    prefix in ioloop context changes

    This didn't appear to cause any visible bugs with the current code, but is 
    required by the next commit.

    Broken by ad13ab0702141065b79a1b7e8f2833e5b93871a4

M	src/lib-storage/mail-storage-service.c

2022-08-25 09:20:40 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (62f388b03e)

     doc/example-config: Document submissions/465 for submission-login


M	doc/example-config/conf.d/10-master.conf

2022-02-22 17:47:55 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (08bf01a739)

    lib-storage: Avoid calling mail_set_attachment_keywords() recursively

    It doesn't break, but it's unnecessary work.

M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mail.h

2022-02-22 17:44:02 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (73962c1f59)

    lib-imap: imap_bodystructure_parse*() - Reset parts.data on failure

    Having the data filled only to some message_parts can confuse the callers, 
    thinking that all the parts were successfully filled.

    Fixes: Panic: file message-part-data.c: line 579
    (message_part_is_attachment): assertion failed: (data != NULL)

M	src/lib-imap/imap-bodystructure.c
M	src/lib-imap/test-imap-bodystructure.c

2022-06-16 10:57:15 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (300b5c257b)

    dsync: Add more debug logging


M	src/doveadm/dsync/dsync-mailbox-import.c

2022-06-16 10:55:42 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8609825d4e)

    dsync: Fix dsync_features=no-header-hashes to match UIDs

    Mails were previously assumed to be the same, even if their UIDs didn't 
    match. This caused the sync to misbehave in some situations.

M	src/doveadm/dsync/dsync-mailbox-import.c

2022-02-04 09:33:34 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (4c56bab522)

    lib: ioloop-kqueue - Include time-util.h

    Needed to compile on MacOS

M	src/lib/ioloop-notify-kqueue.c

2022-05-16 11:04:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7accb09647)

    util: dovecot-sysreport - Add timestamps before/after "ps" output

    Sometimes running "ps" can take a while, so make it clear in the output if 
    this has happened.

M	src/util/dovecot-sysreport

2022-05-16 10:52:54 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (fe8710dde7)

    util: dovecot-sysreport - Wait 3 seconds between "ps" outputs

    This allows showing more clearly in ps_output file whether a process is 
    using 100% CPU.

M	src/util/dovecot-sysreport

2022-06-13 09:56:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a5ffdc8deb)

    doveadm deduplicate: Allocate memory properly for keys in hash table

    This caused wrong mails to be deleted somewhat randomly. Broken by
    320844f50cd669b602d30210e2e5216f65d2050f

M	src/doveadm/doveadm-mail-deduplicate.c

2022-06-07 09:40:10 +0300 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (f0a9cbfb9d)

    auth: db_oauth2_have_all_fields() - Fix auth field existence check

    The correct pointer to pass on there is field, since ptr is the original 
    which still includes the ending }.

    Broken in 9b670175445a75987a713ff899d1a945255b0b5b and incorrectly fixed in
    5c2f3d0b85830d18dbb8b45b348da091e24d1b3b.

M	src/auth/db-oauth2.c

2022-05-24 15:52:26 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (c4086c78a8)

    lib-compression: istream-decompress - Copy parent stream name

    This is needed, because istream-decompress doesn't actually use the parent 
    stream as the istream parent.

M	src/lib-compression/istream-decompress.c

2022-05-19 12:39:55 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (8b3b959d0c)

    stats: stats-service-openmetrics - Always clear the stack before next metric
    body

    If the attempt of generating output for the previous metric doesn’t
    completely consume the stack, the next metric will start with a non-empty
    stack, which breaks the metrics output.

M	src/stats/stats-service-openmetrics.c

2022-05-19 11:24:23 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (9708531c04)

    doveadm: Add dsync_features=no-header-hashes

    When this setting is enabled and one dsync side doesn't support mail GUIDs, 
    there is no fallback to using header hashes. Instead, dsync assumes that all
    mails with identical IMAP UIDs contains the same mail contents. This can
    significantly improve dsync performance with some IMAP servers that don't
    support caching Date/Message-ID headers.

M	src/doveadm/doveadm-dsync.c
M	src/doveadm/doveadm-settings.c
M	src/doveadm/doveadm-settings.h
M	src/doveadm/dsync/dsync-brain-mailbox.c
M	src/doveadm/dsync/dsync-brain-private.h
M	src/doveadm/dsync/dsync-brain.c
M	src/doveadm/dsync/dsync-brain.h
M	src/doveadm/dsync/dsync-mailbox-import.c
M	src/doveadm/dsync/dsync-mailbox-import.h

2022-05-18 11:31:44 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (30e6947179)

    auth: Fix assert-crash in iterating multiple userdbs

    Broken by 501e17ba6b448ba3c88338596e0e8f99f0693f79

    Fixes: Panic: file userdb-blocking.c: line 125 (userdb_blocking_iter_next):
    assertion failed: (ctx->conn != NULL)

M	src/auth/auth-master-connection.c

2022-05-02 13:12:26 +0000 Marco Bettini <marco.bettini@open-xchange.com> (e56bb5e361)

    lib: Fix for clang Wstrict-bool pragma failing on unpatched clang

    Note that clang recognises GCC diagnostic pragmas too, so there is no need
    for distinct pragmas in this case

M	src/lib/event-filter-lexer.l
M	src/lib/event-filter-parser.y

2022-05-02 11:14:10 +0000 Marco Bettini <marco.bettini@open-xchange.com> (fdf4cf0d01)

    quota: Fix for clang -Wstrict-bool clashing with #include <rpc/rpc.h>


M	src/plugins/quota/Makefile.am
A	src/plugins/quota/rquota-pragmas.h

2022-05-02 11:13:41 +0000 Marco Bettini <marco.bettini@open-xchange.com> (2f8682fc0d)

    m4: adding check for clang -Wstrict-bool availability


M	configure.ac
M	m4/dovecot.m4

2022-05-17 09:05:20 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (39abdd9343)

    submission: Don't log write() errors that fail due to ECONNRESET

    These happen only if client initialization fails.

M	src/submission/main.c

2022-05-17 09:03:47 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (06e883ec95)

    imap: Don't log write() errors that fail due to ECONNRESET

    These happen only before the client is fully initialized.

M	src/imap/main.c

2022-05-03 00:27:47 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a91f361d84)

    fts: Fix optimizing searches in virtual mailboxes without up-to-date indexes

    This could have caused header searches in virtual mailboxes to not return 
    all results when fts_enforced!=yes

    Broken by 9705b81fb51b5bdeaba12932a390ced2cc9dcad7

M	src/plugins/fts/fts-storage.c

2022-04-25 10:43:45 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (97f19460a9)

    lib-lua: dlua-dovecot-http - Support more settings with HTTP client


M	src/lib-lua/dlua-dovecot-http.c

2022-04-25 14:27:12 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (3eddd5eba5)

    lib-http: Rename max_auto_retry_delay to max_auto_retry_delay_secs


M	src/lib-http/http-client-request.c
M	src/lib-http/http-client.c
M	src/lib-http/http-client.h

2022-04-19 11:42:05 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1c6c3c320d)

    auth: auth_worker_call() - Return void instead of the connection

    The return value is no longer necessary, and it most likely would just be 
    used wrong.

M	src/auth/auth-worker-server.c
M	src/auth/auth-worker-server.h

2022-04-19 11:40:52 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (94577c4450)

    auth: Fix crash when user iteration request is queued

    auth_worker_call() returns NULL when the request couldn't be handled 
    immediately, which would result in NULL pointer dereference later on.

M	src/auth/userdb-blocking.c

2022-04-19 11:39:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f89c9e587e)

    auth: Add connection parameter to auth_worker_callback_t


M	src/auth/auth-worker-server.c
M	src/auth/auth-worker-server.h
M	src/auth/passdb-blocking.c
M	src/auth/passdb-cache.c
M	src/auth/userdb-blocking.c

2022-04-14 13:46:59 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (865fb4f3c1)

    doveadm: Fix hang when flushing a corked print-ostream

    This could have happened at least with doveadm sync/backup command, i.e.
    causing replication to hang until timeout is reached:

    Error: write(<local>) failed: Timed out after 60 seconds

M	src/doveadm/doveadm-print-server.c

2022-04-08 15:59:59 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (0dd36a73e4)

    lib-index: Always write tail offset the same as head offset

    The mail_index_write() must not be called unless this is safe to do. This
    prevents unnecessarily reading through dovecot.index.log between tail..head
    offsets, which can be expensive due to modseq calculation.

M	src/lib-index/mail-index-write.c

2022-04-08 15:10:53 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (aa7d67e6d6)

    lib-index: Optimize modseq scanning by using the modseq header in index

    View is very commonly set to start reading new changes since dovecot.index 
    was last written. When reading the newer records in dovecot.index.log, the 
    modseq of each change is needed to be known. However, the initial modseq 
    calculation was usually done inefficiently by reading the whole 
    dovecot.index.log from the beginning of the file. This change prevents that
    by using instead the "modseq" header in dovecot.index to get the initial
    modseq.

M	src/lib-index/mail-index-map-read.c
M	src/lib-index/mail-index-modseq.c
M	src/lib-index/mail-index-modseq.h
M	src/lib-index/mail-index-private.h
M	src/lib-index/mail-transaction-log-modseq.c

2022-04-08 13:42:55 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (40e2a21f83)

    lib-index: Handle 0-sized dovecot.index.log record properly

    The previous behavior was to just silently ignore it and have the next write 
    to the transaction log silently truncate away the trailing garbage.

    Now if the log file isn't locked the issue is still ignored, since it's 
    possible that this is just a race condition. But if the log is locked, it's
    handled as corruption.

M	src/lib-index/mail-transaction-log-file.c

2022-04-12 10:12:11 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (36cbfb8e2b)

    lib: test-event-flatten - Use __FILE__ to get correct expected filename

    Fixes out of tree buids

    Broken in 4f752d381c8e19dd07d1e593996d02294668c8b6

M	src/lib/test-event-flatten.c

2022-03-01 10:01:06 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (5c2f3d0b85)

    auth: db-oauth2 - Fix off by one in oauth2 variable handling

    Broken in 9b670175445a75987a713ff899d1a945255b0b5b

M	src/auth/db-oauth2.c

2022-03-21 11:03:03 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (dc40c6dbcf)

    dsync: Properly terminate escape_chars when escaping mailbox names

    Broken by 596c5a52e7e554571285e90063712cb0d37b34eb

M	src/doveadm/dsync/dsync-brain-mailbox-tree.c

2022-03-02 09:39:30 -0500 Timo Sirainen <timo.sirainen@open-xchange.com> (9e7503d439)

    dsync: Fix hierarchical mailbox name parts individually

    For example with filesystem-based mailbox formats it's not allowed to create
    "box/../child" mailbox. With previous code dsync just gave up and created 
    the mailbox name based on its GUID. This is now improved to instead try to 
    insert '_' character after each hierarchy separator so the newly fixed 
    mailbox name is "box/_../child".

M	src/doveadm/dsync/dsync-brain-mailbox-tree.c

2022-03-01 08:37:57 -0500 Timo Sirainen <timo.sirainen@open-xchange.com> (801aae4bd5)

    dsync: Escape and unescape mailbox names as needed

    This should fix various issues with syncing local and remote mailbox names. 
    It especially avoids changing the escape character to alt_char.

M	src/doveadm/dsync/dsync-brain-mailbox-tree.c
M	src/doveadm/dsync/dsync-mailbox-tree.c
M	src/doveadm/dsync/test-dsync-mailbox-tree-sync.c

2022-03-01 11:51:04 -0500 Timo Sirainen <timo.sirainen@open-xchange.com> (cfd1b0687f)

    dsync: Track whether escape character was added just for dsync

    Will be used by the following commit

M	src/doveadm/doveadm-dsync.c
M	src/doveadm/dsync/dsync-brain.c
M	src/doveadm/dsync/dsync-brain.h

2022-03-01 08:36:55 -0500 Timo Sirainen <timo.sirainen@open-xchange.com> (60ae30dd9e)

    dsync: Add clarifying comment about mailbox_log_record.maibox_guid contents


M	src/doveadm/dsync/dsync-mailbox-tree-fill.c

2022-03-01 08:06:14 -0500 Timo Sirainen <timo.sirainen@open-xchange.com> (3864ecbfc7)

    dsync: Add escape_char to dsync-mailbox-tree

    This will be used by the following changes.

M	src/doveadm/dsync/dsync-brain-mailbox-tree.c
M	src/doveadm/dsync/dsync-brain-private.h
M	src/doveadm/dsync/dsync-ibc-pipe.c
M	src/doveadm/dsync/dsync-ibc-private.h
M	src/doveadm/dsync/dsync-ibc-stream.c
M	src/doveadm/dsync/dsync-ibc.c
M	src/doveadm/dsync/dsync-ibc.h
M	src/doveadm/dsync/dsync-mailbox-tree-private.h
M	src/doveadm/dsync/dsync-mailbox-tree.c
M	src/doveadm/dsync/dsync-mailbox-tree.h
M	src/doveadm/dsync/test-dsync-mailbox-tree-sync.c

2022-03-18 09:41:37 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (f95da1fa2f)

    lib-test: test-subprocess - Free subprocess before forking

    Otherwise it'll leak memory.

    Broken in 34bdfdcbc7e3b374a219732329b6ce6d84a7666e

M	src/lib-test/test-subprocess.c

2021-10-25 12:23:56 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (25ae16cb40)

    lib-lua: Add a minimal interface to lib-http

    Adds the ability to
    - Creating http clients
    - Creating http requests
    - Adding arbitrary headers and payload to the http request
    - Submitting the request to remote server and getting the response

M	src/lib-lua/Makefile.am
A	src/lib-lua/dlua-dovecot-http.c
M	src/lib-lua/dlua-dovecot.c
M	src/lib-lua/dlua-script-private.h

2022-03-14 10:18:58 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (e5ae6b26e9)

    doveadm-who: Do not parse numbers as IP addresses

    Fixes doveadm kick as well.

    Broken in 381daab1e3b56a0bc94d2191cf62beba0df51af9

M	src/doveadm/doveadm-who.c

2022-03-01 12:06:20 +0100 Markus Valentin <markus.valentin@open-xchange.com> (6026905b7a)

    lib: test-seqset-builder - Add missing seqset_builder_deinit()

    Fixes leaking memory when running tests.

M	src/lib/test-seq-set-builder.c

2022-03-01 13:49:39 +0100 Markus Valentin <markus.valentin@open-xchange.com> (4540884c46)

    imapc: imapc_transaction_save_rollback() - Fix NULL-check for ctx->src_mbox

    Assert that unfinished context implies that ctx->src_mbox is non-NULL. Also
    check for ctx->src_mbox being non-NULL before deinitializing it.

M	src/lib-storage/index/imapc/imapc-save.c

2022-02-28 13:15:06 +0100 Markus Valentin <markus.valentin@open-xchange.com> (e5a07bd1c4)

    imapc: imapc_mailbox_msgmap_update() - Set new_message_r

    In case a message has not yet been keep the reply till syncing and do not
    discard it right away.

M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-02-24 15:31:39 +0100 Markus Valentin <markus.valentin@open-xchange.com> (f5fc15b1b1)

    imapc: Delay fetching state after untagged exists reply


M	src/lib-storage/index/imapc/imapc-mailbox.c
M	src/lib-storage/index/imapc/imapc-storage.h
M	src/lib-storage/index/imapc/imapc-sync.c

2021-12-16 09:11:55 +0100 Markus Valentin <markus.valentin@open-xchange.com> (173cc696f8)

    imapc: imapc_copy() - Make sure capabilities are known before copying


M	src/lib-storage/index/imapc/imapc-save.c

2021-11-11 16:17:35 +0100 Markus Valentin <markus.valentin@open-xchange.com> (09bfbb4cb1)

    imapc: Implement rollback for failed copies


M	src/lib-storage/index/imapc/imapc-save.c
M	src/lib-storage/index/imapc/imapc-storage.c
M	src/lib-storage/index/imapc/imapc-storage.h

2021-11-11 18:31:54 +0100 Markus Valentin <markus.valentin@open-xchange.com> (95baaaf454)

    imapc: imapc_save_copyuid() deduplicate code


M	src/lib-storage/index/imapc/imapc-save.c

2021-11-11 16:18:09 +0100 Markus Valentin <markus.valentin@open-xchange.com> (1e888011d0)

    imapc: Enable bulk copying if remote backend has UIDPLUS capability


M	src/lib-storage/index/imapc/imapc-save.c

2021-11-11 14:52:54 +0100 Markus Valentin <markus.valentin@open-xchange.com> (79b5dc6024)

    imapc: Implement bulk copying for imapc


M	src/lib-storage/index/imapc/imapc-save.c
M	src/lib-storage/index/imapc/imapc-storage.c
M	src/lib-storage/index/imapc/imapc-storage.h

2021-11-11 16:10:53 +0100 Markus Valentin <markus.valentin@open-xchange.com> (d8ac772071)

    imapc: Extract imapc_copy_simple() from imapc_copy()

    Keep the old one by one copying functionality as simple call. This will be
    used if the remote backend does not have the UIDPLUS capability.

M	src/lib-storage/index/imapc/imapc-save.c

2022-01-12 15:09:16 +0100 Markus Valentin <markus.valentin@open-xchange.com> (dd9923ed99)

    lib-storage: index_save_context_free() - Add assertion on non-NULL
    ctx->dest_mail


M	src/lib-storage/index/index-storage.c

2021-12-08 17:17:56 +0100 Markus Valentin <markus.valentin@open-xchange.com> (ed093cb058)

    lib: Add seq-set-builder and tests for it


M	src/lib/Makefile.am
A	src/lib/seq-set-builder.c
A	src/lib/seq-set-builder.h
M	src/lib/test-lib.inc
A	src/lib/test-seq-set-builder.c

2022-02-10 17:37:59 +0100 Marco Bettini <marco.bettini@open-xchange.com> (0b8d22e109)

    lib-storage: imapc_mailbox_close() - Remove unprocessed
    untagged_fetch_contexts


M	src/lib-storage/index/imapc/imapc-storage.c

2022-02-10 16:26:10 +0100 Marco Bettini <marco.bettini@open-xchange.com> (589f8b1eba)

    lib-storage: Remove trainling spaces


M	src/lib-storage/index/imapc/imapc-mailbox.c
M	src/lib-storage/index/imapc/imapc-sync.c

2022-02-02 16:58:24 +0100 Markus Valentin <markus.valentin@open-xchange.com> (6b7a40bd5d)

    imapc: imapc_sync_handle_untagged_fetches() - Commit after adding the
    untagged fetch messages

    The absence of the commit could have caused issues when imapc_sync_finish()
    was not called as it left mbox->delayed_sync_trans initialized but
    mbox->delayed_sync_view was NULL.

    Broken by 55a8c2d294bb2f764209c7ce455d258b2b7506f5

M	src/lib-storage/index/imapc/imapc-sync.c

2022-01-18 09:46:32 +0100 Markus Valentin <markus.valentin@open-xchange.com> (4b517a91b4)

    imapc: Start to handle new untagged fetch messages in imapc_sync()


M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-01-18 09:22:24 +0100 Markus Valentin <markus.valentin@open-xchange.com> (6d505f1b39)

    imapc: Add imapc_sync_handle_untagged_fetches()


M	src/lib-storage/index/imapc/imapc-mailbox.c
M	src/lib-storage/index/imapc/imapc-storage.c
M	src/lib-storage/index/imapc/imapc-storage.h
M	src/lib-storage/index/imapc/imapc-sync.c

2022-01-17 15:41:25 +0100 Markus Valentin <markus.valentin@open-xchange.com> (aa26f7a231)

    imapc: imapc_untagged_fetch_handle() - Change return type to bool

    When calling imapc_untagged_fetch_handle() also retrieve new_message_r from
    it which allows imapc_mailbox_msgmap_update() to determine if the message
    just handled was already in index or not.

M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-01-27 08:06:16 +0100 Markus Valentin <markus.valentin@open-xchange.com> (235f491ffe)

    imapc: imapc_untagged_fetch_update_flags() - Reduce indentation


M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-01-27 07:56:32 +0100 Markus Valentin <markus.valentin@open-xchange.com> (ea5eb228c7)

    imapc: Split off imapc_untagged_fetch_update_flags() for handling flag
    updates


M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-01-17 15:00:41 +0100 Markus Valentin <markus.valentin@open-xchange.com> (4656356f1e)

    imapc: Introduce imapc_untagged_fetch_ctx


M	src/lib-storage/index/imapc/imapc-mailbox.c
M	src/lib-storage/index/imapc/imapc-storage.h

2022-01-17 13:57:56 +0100 Markus Valentin <markus.valentin@open-xchange.com> (332c4ef1a4)

    imapc: Decouple imapc_untagged_fetch parsing and handling


M	src/lib-storage/index/imapc/imapc-mailbox.c

2022-03-09 02:30:12 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a987d6b01f)

    submission-login: Add workaround for SMTP backend that is not Dovecot.

    Adds workaround called "exotic-backend".

M	src/submission-login/client-authenticate.c
M	src/submission-login/submission-login-settings.c
M	src/submission-login/submission-login-settings.h
M	src/submission/submission-settings.c

2022-03-02 15:40:16 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (f703acd4a2)

    auth: auth-cache - Always use translated_username as cache key

    This fixes auth cache when passdb/userdb changes the user field.

M	src/auth/auth-cache.c

2022-03-02 14:57:20 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (020f8d5cff)

    auth: Set translated_user to requested_login_user in master login

    Fixes caching issues with master logins.

M	src/auth/auth-request-fields.c

2021-07-06 14:02:41 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (2e5b63175d)

    auth: Include cache hit/miss information in passdb/userdb lookup end events


M	src/auth/auth-request.c
M	src/auth/auth-request.h
M	src/auth/passdb-cache.c

2022-02-28 17:12:32 +0100 Marco Bettini <marco.bettini@open-xchange.com> (9a355e8aa7)

    fts: Parse mail header before checking whether to index it

    Fixes an issue where mime parts Content-type wasn't properly set, causing
    binary mime parts to be fed to the indexes.

    Broken in ddb85f3533842aa7c4e943c10bbd3dcb745c2eae

M	src/plugins/fts/fts-build-mail.c

2022-02-18 18:31:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1133504c52)

    dsync: Log reason why mailbox is synced with debug logging


M	src/doveadm/dsync/dsync-brain-mailbox.c
M	src/doveadm/dsync/dsync-brain-mails.c
M	src/doveadm/dsync/dsync-brain-private.h

2022-02-21 23:07:11 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (8bc0825d97)

    dsync: If modseqs aren't permanent, assume HIGHESTMODSEQ=0

    Otherwise the HIGHESTMODSEQ is just whatever happens to be in the in-memory 
    view of the index, which most likely isn't the true HIGHESTMODSEQ. Using 0 
    makes it clear that the HIGHESTMODSEQ isn't valid and can't be used.

M	src/doveadm/dsync/dsync-brain-mailbox.c
M	src/doveadm/dsync/dsync-mailbox-import.c

2022-02-12 15:07:39 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (9da4834ad0)

    submission-login: submission-proxy - Do not include initial response in AUTH
    command if it is too long.


M	src/submission-login/client.h
M	src/submission-login/submission-proxy.c

2022-02-21 21:36:55 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (9a16de7aad)

    submission-login: submission-proxy - Rename local variable in
    proxy_send_login().


M	src/submission-login/submission-proxy.c

2022-02-21 21:32:45 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (7a79eba26e)

    lib-smtp: smtp-client - Move SMTP_BASE_LINE_LENGTH_LIMIT definition to
    smtp-common.h.


M	src/lib-smtp/smtp-client-private.h
M	src/lib-smtp/smtp-common.h

2022-02-21 21:29:23 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (10b0d57967)

    lib-smtp: smtp-client-connection - Rename SMTP_CLIENT_BASE_LINE_LENGTH_LIMIT
    to SMTP_BASE_LINE_LENGTH_LIMIT.


M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/smtp-client-private.h

2022-02-23 14:21:02 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (84fe9d12fc)

    lib-smtp: smtp-client-connection - Fix typo in comment.


M	src/lib-smtp/smtp-client-connection.c

2022-02-22 14:14:20 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (d5d8b69aa7)

    director: Fix crashes caused by changing host tag

    Fixes: Panic: file director.c: line 1175 (director_move_user): assertion
    failed: (user->host->tag == host->tag) Panic: file director-request.c: line
    303 (director_request_continue_real): assertion failed: (user->host->tag ==
    mail_tag)

M	src/director/mail-host.c

2022-02-22 14:10:02 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (44b7eda458)

    director: Prevent loops where directors keep changing host tags


M	src/director/director-connection.c

2022-02-21 12:47:29 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (7a64ec1ef8)

    lib: If log prefix update can't be sent to log, exit with FATAL_LOGERROR


M	src/lib/failures.c

2022-02-21 12:39:02 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (1bf3963714)

    lib: Fix losing log prefix or IP change when log process is busy

    The fd for writing to log process is non-blocking. When sending options to
    log process, it was done with write_full(), which stopped whenever EAGAIN
    was returned. This error was simply ignored, and the logging code thought
    that the prefix was successfully changed (or the IP was sent).

    This mainly caused a problem when processes were reused and log process was
    busy. The prefix update could have failed, and the following logging would
    be using the previous session's log prefix, i.e. log lines could have been
    logged for the wrong user/session.

    Broken by 9372e48b702a3af5705785e08fbf47b0e37f2047

M	src/lib/failures.c

2022-02-06 14:20:08 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (3e8befe6b5)

    dict: Fix potential timeout leak at deinit

    The deinit code could still trigger proctitle refresh.

M	src/dict/main.c

2022-02-22 11:23:33 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (17118d5970)

    dict: Make sure proctitle refresh timeout goes to the main ioloop

    In some situations it could have gone to dict_wait() ioloop, causing timeout
    leaks or crashes.

M	src/dict/main.c

2021-10-25 15:43:00 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (974e970889)

    lib-storage: Don't use cached message_parts while message is being parsed

    Finish the parsing instead. Otherwise there can be some confusion about 
    parsed_bodystructure* fields, which indicate that data->parts have the 
    bodystructure info while in reality data->parts came from cached fields and
    they have no bodystructure info.

M	src/lib-storage/index/index-mail.c

2021-10-25 12:22:06 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6b6d61e9d1)

    lib-storage: Reset bodystructure parsing state when reseting message_parts

    Fixes: Panic: file message-part-data.c: line 28
    (message_part_data_is_plain_7bit): assertion failed: (data != NULL)

M	src/lib-storage/index/index-mail-headers.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mail.h
M	src/lib-storage/test-mail.c

2022-02-09 23:12:19 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d31af56e9a)

    dict-sql: Fix assert-crash if trying to rollback an open set/inc transaction

    Fixes: Panic: file dict-sql.c: line 911 (sql_dict_transaction_free):
    assertion failed: (!array_is_created(&ctx->prev_set))

M	src/lib-dict-backend/dict-sql.c

2022-02-04 04:30:48 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (b743c13533)

    anvil: connect_limit_deinit() - Free ident_pid_hash elements


M	src/anvil/connect-limit.c

2022-02-11 09:17:58 +0100 Marco Bettini <marco.bettini@open-xchange.com> (feebfa572a)

    indexer: indexer_client_status_callback() - Fix accessing freed memory

    Broken by a9683d7b3

M	src/indexer/indexer-client.c

2022-02-07 16:04:41 +0100 Marco Bettini <marco.bettini@open-xchange.com> (e65b925b86)

    indexer: Fix memory leak on indexer timeout


M	src/indexer/indexer-client.c

2022-02-04 01:28:45 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (ff258ecea5)

    stats: stats_metrics_remove_dynamic() - Free the removed metric


M	src/stats/stats-metrics.c

2022-02-04 01:32:18 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (8437a9224f)

    stats: stats_metric_alloc() - Fix indentation on p_new() call


M	src/stats/stats-metrics.c

2022-01-31 12:42:46 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (c5ef0ce4b7)

    replication: aggregator - Free replicator_connection content


M	src/replication/aggregator/replicator-connection.c

2022-02-01 14:22:31 +0100 Marco Bettini <marco.bettini@open-xchange.com> (12a751615b)

    mail-crypt: Fix for mail being wrongly storing encrypted via LMTP

    If 1st recipient has mail_crypt_save_version=2, and 2nd recipient has
    mail_crypt_save_version=0, the mail for 2nd recipient is wrongly stored
    encrypted.

    Same happens if 2nd recipient has mail_crypt disabled

M	src/plugins/mail-crypt/mail-crypt-plugin.c

2020-03-31 13:51:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a707e6907c)

    mail-crypt: Remove "plugin disabled" texts from errors

    The plugin isn't just disabled, the user initialization fails entirely.

M	src/plugins/mail-crypt/mail-crypt-plugin.c

2020-03-31 13:49:28 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4514e72dd7)

    mail-crypt: Fix crash when plugin is already initialized, but not used for
    another user

    Fixes: Panic: Module context mail_crypt_user_module missing

M	src/plugins/mail-crypt/mail-crypt-plugin.c

2021-04-29 21:09:01 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (41e439f993)

    doveadm deduplicate: Simplify code by using doveadm_mail_iter_deinit_sync()


M	src/doveadm/doveadm-mail-deduplicate.c

2021-04-29 21:05:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d60ca6eaac)

    doveadm deduplicate: Optimize by deduplicating in a single transaction


M	src/doveadm/doveadm-mail-deduplicate.c

2022-02-14 13:50:02 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (70a924bd84)

    pop3: Fix empty command handling

    If empty command is given, error out instead of trying to create event. This
    fixes a crash caused by d2ab26be6038bd53b13a3ff18c403d6c192c1d91.

M	src/pop3/pop3-client.c

2022-02-02 17:01:49 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (6b66c7694e)

    lib-master: Fix deinit memory leak with process_shutdown_filter


M	src/lib-master/master-service.c

2021-12-17 09:27:07 +0100 Marco Bettini <marco.bettini@open-xchange.com> (3b05ece496)

    plugins/fts: Allow plugins to carry state across calls during search session


M	src/plugins/fts/fts-api.h
M	src/plugins/fts/fts-search.c
M	src/plugins/fts/fts-storage.h

2022-01-26 16:09:29 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d6f90fc69e)

    auth: ldap: Drop partially saved results before retrying request

    Fixes "LDAP search returned multiple entries" happening after reconnects.

M	src/auth/db-ldap.c

2022-01-26 16:03:27 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c870c58f3f)

    auth: ldap: If any requests were lost, reconnect to LDAP server


M	src/auth/db-ldap.c

2022-01-26 16:00:45 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (30325b92b7)

    auth: ldap: If LDAP connection appears to be hanging, abort all old requests

    Retrying the reconnect might fix them, but since this situation isn't 
    supposed to happen in the first place, it's safer to just remove them 
    entirely to guarantee that it's not trying to keep retrying them for a long
    time.

M	src/auth/db-ldap.c

2022-01-26 14:46:55 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (6360d26c8a)

    auth: ldap: Reconnect to server if receiving unknown msgid

    It's unclear why this happens. Is it a bug on server or client side? Either
    way, this situation doesn't now fix itself automatically, so reconnecting
    should help.

M	src/auth/db-ldap.c

2022-01-26 14:43:01 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (88d55b93ba)

    auth: ldap: Stop re-sending request after 3 disconnect+reconnects

    This prevents retrying the same LDAP request forever in situations where the 
    request causes LDAP server to become disconnected. This might fix some real 
    issues, but it was mainly implemented because testing the following commit 
    caused infinite looping.

M	src/auth/db-ldap.c
M	src/auth/db-ldap.h

2022-02-01 14:57:16 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (342c872791)

    lmtp: proxy - Add per-connection counter to session_id

    This way connections to two different backends don't try to use the same 
    session_id. Add 'P' letter before the counter to clarify that it's the proxy
    connection counter.

M	src/lmtp/lmtp-proxy.c

2022-02-01 14:40:48 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (84ebee8902)

    lmtp: Simplify/clarify per-recipient session ID

    The session ID is the transaction ID followed by an increasing recipient 
    count (number of RCPT commands) in the SMTP transaction. Clarify this by 
    adding 'R' letter before the counter. Also don't add the counter suffix at 
    all for the first recipient, since most transactions only have a single 
    recipient.

M	src/lmtp/lmtp-recipient.c

2022-02-01 14:35:05 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (edf91ac779)

    lib-smtp: server-transaction - Simplify/clarify transaction ID

    The transaction ID is the session ID followed by an increasing transaction 
    count (number of MAIL commands) in the SMTP server connection. Clarify this
    by adding 'T' letter before the counter. Also don't add the counter suffix
    at all for the first session, since most sessions only have a single
    transaction.

M	src/lib-smtp/smtp-server-transaction.c

2022-02-01 14:29:43 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (f26b7d3c13)

    lib-smtp, lmtp: Add brackets to <session-id> in logging

    This makes it clearer where the session-id stops. It's also similar to how
    it is in mail_log_prefix.

M	src/lib-smtp/smtp-server-transaction.c
M	src/lmtp/lmtp-proxy.c

2022-02-01 15:03:15 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (7a168bb5b5)

    lmtp: proxy - Use recipient-specific session-id when logging the result

    Instead of transaction ID, which is shared between recipients.

M	src/lmtp/lmtp-proxy.c

2022-02-01 16:00:36 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (d107539524)

    lmtp: struct lmtp_recipient - Change all strings to const


M	src/lmtp/lmtp-recipient.h

2022-01-27 21:40:25 +0100 Markus Valentin <markus.valentin@open-xchange.com> (9e151e0fd9)

    lib-storage: LAYOUT=index: Fix accessing freed memory when deleting
    \Noselect parents

    Broken by f5328d6f7e4a8e460c736fa0336f5766aa58abda

M	src/lib-storage/list/mailbox-list-index-backend.c

2022-01-28 10:54:53 +0100 Markus Valentin <markus.valentin@open-xchange.com> (dc5e01c2b2)

    lib-http: http_server_resource_create() - Remove unnecessary pool allocation

    Fixes leaking the memory pool created in stats_http_resource_add()

M	src/lib-http/http-server-resource.c

2022-01-26 04:00:32 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (4a4a4cf02b)

    lib-smtp: test-smtp-client-errors - Add test for succesful authentication
    with large initial response.


M	src/lib-smtp/test-smtp-client-errors.c

2022-01-26 03:58:49 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (3de3cd5987)

    lib-smtp: smtp-client-connection - Fix authentication with multi-roundtrip
    SASL mechanisms.

    Before, it would fail with an unexpected reply error.

M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/smtp-client-private.h

2022-01-24 01:39:19 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (1a09d82bee)

    lib-smtp: test-smtp-client-errors - Add test for successful authentication.


M	src/lib-smtp/test-smtp-client-errors.c

2022-01-24 01:41:15 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (20d406b91c)

    lib-smtp: test-smtp-client-errors - Rename "authentication failed" test to
    "authentication".


M	src/lib-smtp/test-smtp-client-errors.c

2022-01-28 03:14:16 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (5ad9c03dc4)

    lib-smtp: smtp-client - Fix maximum line length to include CRLF.


M	src/lib-smtp/smtp-client-private.h

2022-01-21 01:08:31 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (c8671f74ee)

    lib-smtp: smtp-client-connection - Do not include initial response in AUTH
    command if it is too long.


M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/smtp-client-private.h

2022-01-21 02:26:18 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (02e43414e0)

    lib-smtp: smtp-client-connection - Move auth cleanup to separate function.


M	src/lib-smtp/smtp-client-connection.c

2022-01-28 03:17:59 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (76810027a5)

    lib-sasl: dsasl-client - Make dsasl_client_free(&NULL) a no-op.


M	src/lib-sasl/dsasl-client.c
M	src/lib-smtp/smtp-client-connection.c
M	src/login-common/client-common-auth.c
M	src/login-common/client-common.c

2022-01-21 02:28:23 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (94c8febccc)

    lib-smtp: smtp-client-connection - Reformat comment.


M	src/lib-smtp/smtp-client-connection.c

2022-01-26 19:28:33 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (3e0a147292)

    indexer: Fix memory leak - worker_requests were never freed

    Broken by 141766b24f885259508ae39f2e18811018373bc7

M	src/indexer/indexer.c
M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h

2022-01-25 23:31:34 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (8e0763ac32)

    indexer: Fix memory leak - session IDs were never freed

    Broken by a8dcd4e2332c73087e9b148d34259230a77edb28

M	src/indexer/indexer-queue.c

2021-12-01 12:21:48 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7b96f6cbf5)

    lib-storage: Fix search query that only contains SEARCH_MAILBOX_GUID

    Fixes assert-crash in virtual mailbox:

    Panic: file virtual-search.c: line 77 (virtual_search_get_records):
    assertion failed: (result != 0)

M	src/lib-storage/index/index-search-private.h
M	src/lib-storage/index/index-search.c

2021-12-16 11:49:24 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (a97162ccc6)

    lib-master: Add process_shutdown_filter setting


M	src/lib-master/master-service-private.h
M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service-settings.h
M	src/lib-master/master-service.c
M	src/lib-master/master-service.h

2021-12-16 11:44:38 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (14f8d9c734)

    lib-master: Refactor parsing event filters from settings.


M	src/lib-master/master-service-settings.c

2021-12-16 11:38:53 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (623a7b2be8)

    lib-master: Remove check for client->filter == NULL before
    event_filter_match().


M	src/lib-master/stats-client.c

2021-12-16 11:38:08 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (8e99dae094)

    lib: Add check for NULL to event_filter_match().


M	src/lib/event-filter.c

2021-12-15 15:19:04 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (181f1456d6)

    lib-master: Whitespace cleanup.


M	src/lib-master/master-service-private.h
M	src/lib-master/master-service.c
M	src/lib-master/master-service.h

2021-12-01 13:35:12 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (1425e94b93)

    lib-storage: Emit event with process stat in mail_user_deinit().


M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h

2021-12-07 16:58:43 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (d8c4013cdc)

    lib: Add event_add_int_non_zero()


M	src/lib/lib-event.c
M	src/lib/lib-event.h

2021-12-01 13:34:22 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (0ba13e8e70)

    lib: Add functionality for acquiring process stat.


M	src/lib/Makefile.am
A	src/lib/process-stat.c
A	src/lib/process-stat.h

2021-12-21 10:47:54 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (3a25648a1d)

    lib: add timeval_to_usecs()


M	src/lib/time-util.h

2021-12-20 16:17:54 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (578c5f4b8c)

    lib: Whitespace cleanup


M	src/lib/lib-event.c

2022-01-14 08:07:50 +0100 Markus Valentin <markus.valentin@open-xchange.com> (1e0870724b)

    lib-storage: mailbox-list: index_list_rename_mailbox() - Support NO-NOSELECT

    When NO-NOSELECT is configured delete parent mailboxes which are not 
    selectable or existant when renaming child mailboxes.

M	src/lib-storage/list/mailbox-list-index-backend.c

2022-01-14 08:04:09 +0100 Markus Valentin <markus.valentin@open-xchange.com> (964fe86c5c)

    lib-storage: mailbox-list: index_list_delete_mailbox() - Support NO-NOSELECT

    When NO-NOSELECT is configured delete parent mailboxes which are not 
    selectable or not existant when deleting child mailboxes.

M	src/lib-storage/list/mailbox-list-index-backend.c

2022-01-21 16:31:04 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (77239a25c5)

    doveadm fetch/search: Use DOVEADM_MAIL_ITER_FLAG_STOP_WITH_CLIENT

    These commands only write output to the client, so it's safe to stop them if
    the client disconnects.

M	src/doveadm/doveadm-mail-fetch.c
M	src/doveadm/doveadm-mail-search.c

2022-01-21 16:29:48 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (4eb82acbc3)

    doveadm: doveadm_mail_iter_init() - Add
    DOVEADM_MAIL_ITER_FLAG_STOP_WITH_CLIENT

    When this flag is used, the iteration is stopped if print ostream has 
    reported an error, i.e. doveadm-client has disconnected.

M	src/doveadm/doveadm-mail-iter.c
M	src/doveadm/doveadm-mail-iter.h

2022-01-21 16:24:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (2b2cdb719b)

    doveadm: doveadm_mail_iter_init() - Change bool parameter to flags


M	src/doveadm/doveadm-mail-altmove.c
M	src/doveadm/doveadm-mail-copymove.c
M	src/doveadm/doveadm-mail-deduplicate.c
M	src/doveadm/doveadm-mail-expunge.c
M	src/doveadm/doveadm-mail-fetch.c
M	src/doveadm/doveadm-mail-flags.c
M	src/doveadm/doveadm-mail-import.c
M	src/doveadm/doveadm-mail-iter.c
M	src/doveadm/doveadm-mail-iter.h
M	src/doveadm/doveadm-mail-mailbox-cache.c
M	src/doveadm/doveadm-mail-rebuild.c
M	src/doveadm/doveadm-mail-search.c

2022-01-20 14:16:51 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (aacaf65d7f)

    doveadm-server: Fix hang when flushing print output and client disconnects


M	src/doveadm/doveadm-print-server.c

2022-01-20 14:13:48 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (8f34eb952d)

    lib: ostream-multiplex - Call flush callbacks also when stream has failed

    It may be important for the flush callbacks to know when ostream has been 
    closed. This is a partial fix to prevent doveadm-server hanging when it's 
    printing lots of output and doveadm client disconnects.

M	src/lib/ostream-multiplex.c

2022-01-20 13:34:50 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (d902430e43)

    doveadm: Fix assert-crash when proxying causes print buffer to be flushed

    Fixes: Panic: file ioloop.c: line 865 (io_loop_destroy): assertion failed:
    (ioloop == current_ioloop)

M	src/doveadm/doveadm-print-server.c

2021-12-22 12:12:51 +0100 Markus Valentin <markus.valentin@open-xchange.com> (d02a022d73)

    imapc: Fix doveadm copy with imapc

    When copying to a mailbox with imapc it does not sync the destination 
    mailbox when opening. This created "Error: Syncing mailbox '$mailboxname' 
    failed: Internal error occurred." Prevent this error by checking for the 
    MAILBOX_FLAG_SAVEONLY flag which is used by doveadm to create the 
    destination mailbox. If that flag is set ignore that there was no initial 
    fetching done.

M	src/lib-storage/index/imapc/imapc-mail-fetch.c
M	src/lib-storage/index/imapc/imapc-sync.c

2022-01-21 12:12:52 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (2088e0917e)

    configure.ac: Set dovecot version to 2.3.100.devel

    This helps with version comparisons.

M	configure.ac

2022-01-14 04:02:09 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (bcdc6ef0ec)

    submission: submission-backend-relay - Make sure QUIT command yields 221
    when relay connection is closed normally.

    Before, it would sometimes erroneously treat the closing connection as a
    "connection lost" 421 situation.

M	src/submission/submission-backend-relay.c

2022-01-14 04:01:29 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (9f05ce1758)

    submission: submission-backend-relay - Fix segfault in QUIT command
    client-side destruction.


M	src/submission/submission-backend-relay.c

2020-11-09 02:29:04 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a53380c353)

    lib-smtp: smtp-server-cmd-rset - Stop processing pipeline until RSET is
    complete.

    A subsequent MAIL command could get reset in the middle otherwise. Before,
    it only blocked input until a reply was submitted, but the transaction isn't
    reset until the RSET command is complete (just before actually sending the
    reply) which can cause issues when the subsequent MAIL command is already
    being processed.

M	src/lib-smtp/smtp-server-cmd-rset.c

2020-11-09 00:02:51 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (5a7616f93b)

    lib-smtp: smtp-server-cmd-helo - Stop processing pipeline until HELO/EHLO is
    complete.

    A subsequent MAIL command could get reset in the middle otherwise. Before,
    it only blocked input until a reply was submitted, but the transaction isn't
    reset until the EHLO/HELO command is complete (just before actually sending
    the reply) which can cause issues when the subsequent MAIL command is
    already being processed.

M	src/lib-smtp/smtp-server-cmd-helo.c

2020-11-08 03:58:06 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (5aeca06ad6)

    lib-smtp: smtp-server-command - Add
    smtp_server_command_pipeline_block/unblock().


M	src/lib-smtp/smtp-server-command.c
M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server-private.h
M	src/lib-smtp/smtp-server.h

2022-01-10 03:54:13 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (d79841aa34)

    lib-smtp: smtp-client-transaction - Plug the command pipeline while
    transaction is pending.

    This prevents commands submitted after creating the transaction from being 
    exectuted out-of-order before the transaction's MAIL command.

M	src/lib-smtp/smtp-client-transaction.c

2022-01-10 03:53:41 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (ffbf4efea2)

    lib-smtp: smtp-client-transaction - Add
    smtp_client_command_mail_submit_after().


M	src/lib-smtp/smtp-client-command.c
M	src/lib-smtp/smtp-client-command.h

2022-01-10 01:18:56 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (2ccec52a52)

    lib-smtp: smtp-client-transaction - Prevent recursion for
    smtp_client_transaction_fail*().


M	src/lib-smtp/smtp-client-transaction.c

2022-01-11 02:05:26 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (c40e19df16)

    lib-smtp: Reformat smtp-server-cmd-quit.c.


M	src/lib-smtp/smtp-server-cmd-quit.c

2022-01-20 12:42:57 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (6f703021eb)

    lib-storage: Don't delay setting mail event's log prefix

    This caused crashes if the mail event was kept referenced and used for 
    logging after struct mail was already freed. With the delayed mail event 
    creation the log prefix shouldn't be much of a performance problem, so just 
    set the prefix immediately.

    Partially reverts bc68e1c368db746557829f67556f3c72943b7956.

M	src/lib-storage/mail.c

2022-01-19 15:07:58 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (6b6465700f)

    configure: Update version to 2.3.devel


M	configure.ac

2021-11-30 12:47:52 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (51bb266887)

    NEWS: Add news for 2.3.17.1


M	NEWS

2021-09-28 12:40:29 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (3330f8f631)

    NEWS: Add news for 2.3.17


M	NEWS

2022-01-10 19:46:12 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (26c5c2aa2b)

    lib-storage: Remove reason_code=mailbox:search

    Continues the slow per-mail event removals started in 
    f3c568e3cbc113920bc029e07e56619589c6a26d.

    Reverts 87cd6570a14b3f572fc6000f710df409371a4bcb

M	src/lib-storage/index/index-search.c

2021-12-13 12:54:19 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (c043787771)

    lmtp: lmtp-proxy - Add session ID to backend connection error replies.


M	src/lmtp/lmtp-proxy.c

2021-12-13 04:08:32 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (b29d0df2ef)

    submssion: submission-backend-relay - Avoid logging two errors about a
    connection problem.

    Earlier commit changed lib-smtp to consistently log an error for connection 
    problems, which causes a second error to occur for submission relay backend. 
    This is undesirable.

M	src/submission/submission-backend-relay.c

2021-12-07 01:51:45 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (08d650cb81)

    lmtp: lmtp-proxy - Add lmtp_verbose_replies setting.

    It causes the proxy to return errors with full details in replies to the
    LMTP client.

M	src/lmtp/lmtp-proxy.c
M	src/lmtp/lmtp-settings.c
M	src/lmtp/lmtp-settings.h

2021-12-27 11:35:05 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a0cd85f004)

    lmtp: lmtp-proxy - Split off lmtp_proxy_handle_connection_error().


M	src/lmtp/lmtp-proxy.c

2022-01-04 21:20:22 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (1d88bdfdf8)

    lmtp: lmtp-proxy - Change proxy connection failure message make more sense.


M	src/lmtp/lmtp-proxy.c

2021-12-07 01:58:32 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (11b6ccdfce)

    lib-smtp: smtp-client - Add verbose_user_errors setting.

    It returns the detailed administrator errors as user error in the reply
    returned to the calling application.

M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/smtp-client.c
M	src/lib-smtp/smtp-client.h

2021-12-07 01:51:18 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (40d49a038b)

    lib-smtp: smtp-client-connection - Log administrator connection failures at
    a single place.


M	src/lib-smtp/smtp-client-command.c
M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/smtp-client-private.h

2021-12-23 00:59:45 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (f436df8709)

    lib-smtp: smtp-client-connection - Consistently log an error for connection
    failures.


M	src/lib-smtp/smtp-client-connection.c
M	src/lib-smtp/test-smtp-client-errors.c

2021-12-07 02:44:58 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (5ef51c52ef)

    lib-smtp: smtp-client-connection - Add definition for repeatedly used
    connection error.


M	src/lib-smtp/smtp-client-connection.c

2021-12-27 11:24:36 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (06f838091b)

    lmtp: Reformat lmtp-proxy.c.


M	src/lmtp/lmtp-proxy.c

2021-12-07 01:23:13 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (2e82fdb706)

    lib-smtp: Reformat smtp-client-connection.c.


M	src/lib-smtp/smtp-client-connection.c

2022-01-05 01:27:48 +0000 Stephan Bosch <stephan.bosch@dovecot.fi> (3575639fc4)

    lib-compression: ostream-zlib - Fix signed vs unsigned comparison.


M	src/lib-compression/ostream-zlib.c

2022-01-05 01:25:34 +0000 Stephan Bosch <stephan.bosch@dovecot.fi> (5108d7bddd)

    lib: test-event-flatten - Fix format string specifier for usec time


M	src/lib/test-event-flatten.c

2021-12-28 09:37:42 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (f3c568e3cb)

    lib-storage: Remove most reason_code=mail:*

    Event reasons create events internally. This is rather expensive if it's 
    done for operations that access all emails in a large folder, e.g. SORT. The
    per-mail reason_codes also didn't seem to be hugely helpful, so best to just
    remove them.

    Some of the mail:* reasons were left where they are causing mail stream to 
    be opened anyway. In these cases the extra CPU used by event reasons is 
    relatively little.

    Reverts ce517f8323fa4a60b230f29712b207139badb3f0

M	src/lib-storage/index/index-mail.c
M	src/lib-storage/mail.c

2021-12-20 11:05:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ac4d66e25e)

    maildir: maildir_filename_base_hash() - Disable ubsan integer wrapping
    checks


M	src/lib-storage/index/maildir/maildir-filename.c

2021-12-09 18:06:11 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (ac7bcc31c9)

    lib-fts: Reuse textcat handle between sessions

    textcat initialization is rather CPU intensive. Its configuration is 
    normally always the same between sessions, so we can keep the latest textcat 
    handle cached.

M	src/lib-fts/fts-language.c

2021-11-29 17:05:18 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (fd7248b707)

    lib-storage: Remove index_mail_data.seq

    The seq already exists in struct mail, so this unnecessarily duplicated it.

M	src/lib-storage/index/index-mail-headers.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mail.h

2021-11-29 16:21:29 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (767b689cfb)

    lib-storage: Minor optimization - Use mail_index_lookup_full() to avoid two
    index lookups

    mail_index_is_expunged() was already internally doing the full lookup.

M	src/lib-storage/index/index-mail.c

2021-11-29 16:16:30 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (526a0f5b18)

    lib-index: mail_index_lookup_full() - Add expunged_r parameter


M	src/lib-index/mail-index-modseq.c
M	src/lib-index/mail-index-view.c
M	src/lib-index/mail-index.h

2021-11-29 13:26:25 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (bc68e1c368)

    lib-storage: Optimize setting mail event log prefix

    This was much more important before mail event creation was delayed. In one 
    installation the t_strdup_printf() call itself took about 4% of the total
    CPU usage. Now that mail events are delayed, this is likely much less of an
    issue. Still, this is easy enough of an optimization that might as well do
    it.

M	src/lib-storage/mail.c

2021-11-29 15:46:04 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (165be3edb6)

    lib-storage: Delay creating mail event until mail_event() is called

    Mails can be accessed a lot. The event handling code takes up a lot of CPU, 
    but most of the time the created event wasn't actually used for anything.

M	src/lib-storage/index/index-mail.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.h
M	src/lib-storage/mail.c

2021-11-29 15:43:29 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (a24e4a14f9)

    lib-storage: Make sure mail event is created before accessing streams or
    metadata

    This is in preparation for the next commit which delays the mail event 
    creation. The event duration behaves better if the event is created before 
    any potentially slow access is done.

M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail.c

2021-11-29 15:36:58 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (58eef6713e)

    lib-storage: Move struct mail.event to mail_private


M	src/lib-storage/index/index-mail.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.h
M	src/lib-storage/mail.c

2021-11-29 15:32:28 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (b0596718ab)

    lib-lda, lib-storage: Use mail_event()


M	src/lib-lda/mail-send.c
M	src/lib-storage/mail.c

2021-11-29 15:31:17 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (4b3775baf0)

    lib-storage: Add mail_event()


M	src/lib-storage/mail-storage.h
M	src/lib-storage/mail.c

2021-11-29 18:39:22 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (13fd3c3256)

    lib-storage: Add and use mail_metadata_access_start()


M	src/lib-storage/index/maildir/maildir-mail.c
M	src/lib-storage/index/raw/raw-mail.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail.c

2021-11-29 18:32:09 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (988a575c35)

    lib-storage: Add and use mail_stream_access_start()

    This replaces setting mail_stream_accessed directly.

M	src/lib-storage/index/dbox-multi/mdbox-mail.c
M	src/lib-storage/index/dbox-single/sdbox-mail.c
M	src/lib-storage/index/imapc/imapc-mail-fetch.c
M	src/lib-storage/index/imapc/imapc-save.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/maildir/maildir-mail.c
M	src/lib-storage/index/mbox/mbox-mail.c
M	src/lib-storage/index/pop3c/pop3c-mail.c
M	src/lib-storage/index/raw/raw-mail.c
M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail.c

2021-11-29 18:35:31 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (e06ee029f6)

    lib-storage: raw: get_stream() - Add missing lookup_abort and
    mail_stream_accessed handling


M	src/lib-storage/index/raw/raw-mail.c

2021-11-29 18:34:43 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (2f2e3b3d37)

    pop3c: Add missing lookup_abort and mail_stream_accessed handling


M	src/lib-storage/index/pop3c/pop3c-mail.c

2021-11-29 20:44:05 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (5b97f3af04)

    maildir: get_stream() - Add missing lookup_abort and mail_stream_accessed
    handling


M	src/lib-storage/index/maildir/maildir-mail.c

2021-11-29 18:24:30 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (d7b8c40971)

    lib-storage: Rename mail.mail_stream_opened to mail_stream_accessed

    It is set to TRUE even if the mail stream couldn't successfully be opened, 
    so this describes it better. Also it's now consistent with 
    mail_metadata_accessed.

M	src/lib-storage/index/dbox-multi/mdbox-mail.c
M	src/lib-storage/index/dbox-single/sdbox-mail.c
M	src/lib-storage/index/imapc/imapc-mail-fetch.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mailbox-size.c
M	src/lib-storage/index/index-sort.c
M	src/lib-storage/index/mbox/mbox-mail.c
M	src/lib-storage/mail-storage.h

2021-12-03 10:44:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (74b94e02e5)

    lib-index: Remove mail_cache_lookup_finished event

    This event was using too much CPU with commands that accessed lots of mails
    (e.g. IMAP SORT). It also wasn't especially useful.

    Reverts 0d252dccb3013fea4d9a28bd5fafb5ea6e847d0e

M	src/lib-index/mail-cache-lookup.c

2021-12-02 11:35:20 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1fb3dda9ac)

    lib-index: Use ATTR_COLD for error/corruption handling functions

    This could reduce CPU usage due to better branch prediction.

M	src/lib-index/mail-cache-private.h
M	src/lib-index/mail-cache.h
M	src/lib-index/mail-index-private.h
M	src/lib-index/mail-index-strmap.h
M	src/lib-index/mail-index-sync-private.h
M	src/lib-index/mail-index.h
M	src/lib-index/mail-transaction-log-private.h
M	src/lib-index/mail-transaction-log.h

2021-11-23 15:00:02 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (4a74574d39)

    lib: pool_alloconly_destroy() optimization - Don't clear the last block
    before free

    The block is going to be freed, so there's no need to clear it.
    (The clearing still happens if clean_frees=TRUE.)

M	src/lib/mempool-alloconly.c

2021-11-23 14:59:28 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (40666e3bca)

    lib: pool_alloconly_destroy() - Deduplicate code


M	src/lib/mempool-alloconly.c

2021-11-23 14:58:39 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (7c9ee911cf)

    lib: Split off pool_alloconly_free_block()


M	src/lib/mempool-alloconly.c

2021-11-23 14:56:10 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (333bd2e628)

    lib: Split off pool_alloconly_free_blocks_until_last()


M	src/lib/mempool-alloconly.c

2021-11-23 15:17:49 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (0bcc6897de)

    lib: Minor optimization - Avoid zeroing a newly created empty event field


M	src/lib/lib-event.c

2021-11-22 17:36:21 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (9fc6965de1)

    lib: Remove copy of event_passthrough from struct event

    There was no need for it. This saves some memory and CPU.

    This change now prevents modifications to the event_passthrough, but nothing 
    was doing it before either.

M	src/lib/lib-event-private.h
M	src/lib/lib-event.c

2021-11-22 17:23:28 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (a2ea3df64f)

    lib: Grow initial event pool size to 1024 bytes

    The old 64 bytes size wasn't enough to allocate even the struct event
    itself.

M	src/lib/lib-event.c

2021-12-15 09:19:40 +0100 Karl Fleischmann <karl.fleischmann@open-xchange.com> (793cae8549)

    login-common: Explicitly null client auth fields on proxy pool unref

    Explicitly setting `client_id` and `forward_fields` to null in the client
    may reveal use-after-free issues when trying to access these fields on a
    client proxy.

M	src/login-common/client-common.c

2021-12-10 11:04:06 +0100 Karl Fleischmann <karl.fleischmann@open-xchange.com> (7ad1a92aa5)

    login-common: Use base index for aliases

    Define a base index for aliases in the login variable table. Assign values
    via offset of that base index. This allows adding more values later without
    updating any subsequent index.

M	src/login-common/client-common.c

2021-12-10 11:32:37 +0100 Marco Bettini <marco.bettini@open-xchange.com> (ddb85f3533)

    fts: Add headers filters


M	src/plugins/fts/fts-api-private.h
M	src/plugins/fts/fts-api.c
M	src/plugins/fts/fts-build-mail.c

2021-12-10 11:30:08 +0100 Marco Bettini <marco.bettini@open-xchange.com> (24b66ca063)

    fts: fts-build-mail - Remove stray line


M	src/plugins/fts/fts-build-mail.c

2020-11-10 00:11:15 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a92209788d)

    auth: mech-scram - Amend comments.


M	src/auth/mech-scram.c

2020-11-10 00:11:11 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (49b5780c29)

    auth: mech-scram - Fix handling of authzid.

    The gs2-header field was not recreated correctly for the final verification. 
    Fixed by storing the complete gs2-header value instead.

M	src/auth/mech-scram.c

2020-11-10 00:11:07 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a164ea3786)

    auth: mech-scram - Properly size temporary string buffers.


M	src/auth/mech-scram.c

2020-11-10 00:11:03 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (1ee7d0d807)

    auth: mech-scram - Restructure message parsing in
    parse_scram_client_first().


M	src/auth/mech-scram.c

2020-11-10 00:10:57 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (6678648cfb)

    auth: Reformat mech-scram.c.


M	src/auth/mech-scram.c

2021-08-20 17:43:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (15f25bf7ad)

    lib-storage: Return reason string in mailbox_vfuncs.list_index_has_changed()

    The callers can use it to log why the list index had changed.

M	src/lib-storage/index/index-storage.h
M	src/lib-storage/index/index-sync.c
M	src/lib-storage/index/maildir/maildir-sync-index.c
M	src/lib-storage/index/maildir/maildir-sync.h
M	src/lib-storage/index/mbox/mbox-sync-list-index.c
M	src/lib-storage/index/mbox/mbox-sync-private.h
M	src/lib-storage/list/mailbox-list-index-status.c
M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/mail-storage-private.h
M	src/plugins/virtual/virtual-storage.c

2021-08-20 19:09:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e13768d2ee)

    lib-storage: Don't call mailbox_vfuncs.list_index_has_changed() in data
    stack frame

    This will be required by the next change.

M	src/lib-storage/list/mailbox-list-index-iter.c
M	src/lib-storage/list/mailbox-list-index-status.c
M	src/lib-storage/list/mailbox-list-index.c

2021-08-20 17:26:42 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6fb3e493e2)

    lib-storage: mailbox_list_index_view_open() - Log a debug line why index
    isn't up-to-date


M	src/lib-storage/list/mailbox-list-index.c

2021-08-20 17:20:01 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (49d2d1d9ba)

    lib-storage: mailbox_list_index_status() - Return failure reason string

    Log a debug line if mailbox list index couldn't be used to get the wanted 
    status information.

M	src/lib-storage/list/mailbox-list-index-backend.c
M	src/lib-storage/list/mailbox-list-index-notify.c
M	src/lib-storage/list/mailbox-list-index-status.c
M	src/lib-storage/list/mailbox-list-index.h
M	src/lib-storage/list/mailbox-list-notify-tree.c

2021-12-06 11:54:16 +0100 Marco Bettini <marco.bettini@open-xchange.com> (7751299dee)

    auth: userdb-ldap - Avoid early dereferencing

    userdb_ldap_iterate_callback() is still invoked after dereferencing 
    auth_request in userdb_ldap_iterate_deinit().

    Normally this happens only on teardown, but it may happens also in case of
    auth disconnecting from auth-worker during iteration.
    (which shouldn't happen unless the auth process crashes)

M	src/auth/userdb-ldap.c

2021-12-09 17:31:04 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (2302fcd607)

    var-expand-crypt: Remove dead code

    It's correct that dcrypt library shouldn't be deinitialized at plugin 
    deinit.

M	src/plugins/var-expand-crypt/var-expand-crypt-plugin.c

2021-12-03 17:23:35 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (82be40f65c)

    login-common: Add more fields to proxy_session_finished

    Added disconnect_side, disconnect_reason, idle_secs, bytes_in, bytes_out.

M	src/login-common/login-proxy.c

2021-12-03 17:54:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (da379cfc29)

    login-common: Split off proxy disconnection prefix to
    LOGIN_PROXY_KILL_PREFIX


M	src/login-common/login-proxy.c

2021-12-03 17:47:50 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d36139fc22)

    login-common: login_proxy_free_*() - Rename reason to log_msg

    This better describes it, since it's the full log message.

M	src/login-common/login-proxy.c

2021-12-01 14:46:04 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (203147d0fc)

    dsync: Fix -I max-size to actually be the max-size rather than min-size

    The -I max-size parameter was supposed to be used to skip mails that are 
    larger than max-size. Instead, it skipped mails that were smaller.

M	src/doveadm/dsync/dsync-mailbox-import.c

2021-11-09 13:42:24 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (34f2fdeed5)

    man: Add missing parameters to doveadm-sync


M	doc/man/doveadm-sync.1.in

2021-11-30 18:02:14 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e6a5cb57d1)

    dsync: Remove -D parameter that disables syncing mailbox renames

    It hasn't been necessary for a long time, and its behavior seems to be 
    broken.

M	src/doveadm/doveadm-dsync.c
M	src/doveadm/dsync/dsync-brain-mailbox-tree.c
M	src/doveadm/dsync/dsync-brain-private.h
M	src/doveadm/dsync/dsync-brain.c
M	src/doveadm/dsync/dsync-brain.h
M	src/doveadm/dsync/dsync-ibc-stream.c

2021-11-09 13:41:37 +0100 Timo Sirainen <timo.sirainen@open-xchange.com> (96f9651c98)

    dsync: Add back various missing parameters

    Also add them to the usage string.

    Broken by 5676c510bfa9217df05e9b7cb000ae3554d66f22

M	src/doveadm/doveadm-dsync.c

2021-09-22 14:50:50 -0600 Michael M Slusarz <michael.slusarz@open-xchange.com> (2beae65898)

    fts: Don't overwrite INUSE error if indexing times out


M	src/plugins/fts/fts-indexer.c
M	src/plugins/fts/fts-storage.c

2021-11-11 12:31:49 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (61d9023523)

    lib-storage/index: If mail stream was already opened, do not count it as
    slow vsize access

    imapc storage driver will open the mail stream in some circumstances during
    search, so do not consider this as slow vsize.

M	src/lib-storage/index/index-mailbox-size.c

2021-11-16 15:08:47 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (73475e1ea6)

    lib-storage: Split off index_mailbox_vsize_finish_bg()

    Simplifies next commit

M	src/lib-storage/index/index-mailbox-size.c

2021-08-10 12:22:08 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1ee84ba065)

    lib-index: Fix storing cache fields' last_used with 64bit big endian CPUs


M	src/lib-index/mail-cache-fields.c

2019-01-17 12:13:38 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (616684a8fe)

    maildir: Fix crash at error handling

    At this point dest_mail is already NULL. Mainly could happen when running 
    out of disk space.

M	src/lib-storage/index/maildir/maildir-save.c

2021-11-30 09:51:25 +0000 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (ea41bf7db1)

    login-proxy: Don't send proxying start event for reconnects

    Send the event only for the beginning of proxying and add the reconnect
    counts as a field for _established and _finished events.

M	src/login-common/login-proxy.c

2021-11-26 14:45:47 +0100 Marco Bettini <marco.bettini@open-xchange.com> (2f7254a6af)

    lib: str_parse_intmax() - Replace signed expression with UNSIGNED_MINUS()

    Found by code analysis tool

M	src/lib/strnum.c

2021-11-26 15:48:04 +0100 Marco Bettini <marco.bettini@open-xchange.com> (5297d4862f)

    lib: switch i_rand_limit() - Replace signed expression with UNSIGNED_MINUS()

    Found by code analysis tool

M	src/lib/rand.c

2021-11-26 14:15:07 +0100 Marco Bettini <marco.bettini@open-xchange.com> (4a3ef239b4)

    lib: buffer_truncate_rshift_bits() - Replace signed expression with an
    unsigned equivalent

    Found by code analysis tool

M	src/lib/buffer.c

2021-11-29 15:05:29 +0100 Marco Bettini <marco.bettini@open-xchange.com> (668bdc6838)

    lib: bits_rotXYY() - Replace signed expression with UNSIGNED_MINUS() macro
    for unsigned 2's complement

    Found by code analysis tool

M	src/lib/bits.h
M	src/lib/test-bits.c

2021-11-29 15:00:41 +0100 Marco Bettini <marco.bettini@open-xchange.com> (bf9c2cb8b5)

    bits_is_power_of_two() Replace signed expression with __builtin_popcountl()

    Found by code analysis tool

M	src/lib/bits.h
M	src/lib/test-bits.c

2021-11-29 14:58:33 +0100 Marco Bettini <marco.bettini@open-xchange.com> (f7cbaac8ff)

    lib: test-bits.c - Removing stray spaces at end of lines


M	src/lib/test-bits.c

2021-01-15 17:43:19 +0100 Fabrice Bellet <fabrice@bellet.info> (9211e803f2)

    raw-storage: copy the envelope sender instead of referencing it


M	src/lib-storage/index/raw/raw-storage.c

2019-10-14 16:43:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4a58d467b6)

    lib-fs: Add test-fs utility for testing fs drivers

    It performs random read/write/delete/iter operations.

M	src/util/Makefile.am
A	src/util/test-fs.c

2021-06-18 15:19:48 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (051d39ee45)

    replicator: doveadm replicator replicate -f didn't always start full sync

    The full sync happened only if the dsync queue was already full. If it 
    wasn't, dsync was called too early before user->force_full_sync was set.

M	src/replication/replicator/replicator-brain.c

2021-07-28 11:52:01 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d0c28bba8b)

    replicator: Move replicator_brain_timeout(()


M	src/replication/replicator/replicator-brain.c

2021-04-19 18:48:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (21880fac08)

    lib-storage: Optimize behavior when building THREAD tree with empty cache

    Although it's possible that Date, Subject or received-date isn't actually 
    needed for all mails, it's much more efficient behavior to add all of these 
    to cache at the same time if they're not there already. Otherwise the same 
    mail could be opened and parsed up to 3 times.

M	src/lib-storage/index/index-thread.c

2020-04-02 11:06:36 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8abebfe9a4)

    dsync: Improve checking if source and destination are the same location

    Prefer checking using the first -n parameter's namespace. Next try prefix=""
    if it's created and last fallback to inbox=yes namespace.

M	src/doveadm/doveadm-dsync.c

2021-11-22 18:17:52 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (27e371af06)

    dsync: Improve bad namespace configuration related error messages


M	src/doveadm/doveadm-dsync.c

2021-11-24 16:01:08 +0100 Marco Bettini <marco.bettini@open-xchange.com> (5519de5749)

    submission: smtp_server_command_execute() Remove check for null pointer
    confusing coverity


M	src/lib-smtp/smtp-server-command.c

2021-11-22 16:04:11 +0000 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (c36969fee5)

    imapc: Do not include the root node in list if it's the namespace prefix

    Otherwise namespace prefix is added to the mailbox tree as a separate node.
    Fixes duplicated shared namespace root in mailbox list.

M	src/lib-storage/index/imapc/imapc-list.c

2021-11-23 15:56:45 +0100 Marco Bettini <marco.bettini@open-xchange.com> (5cf012bad9)

    acl: acl_mailbox_exists() - Add missing error handling

    Set mailbox storage error to "internal error" when
    acl_object_get_my_rights() fails (as per contract).

M	src/plugins/acl/acl-mailbox.c

2021-11-23 16:03:07 +0100 Marco Bettini <marco.bettini@open-xchange.com> (a672d83152)

    lib-storage: fail_mailbox_exists() - Return not found as a success instead
    of an error

    GETMETADATA sometimes responds with “NO [SERVERBUG] BUG: Unknown internal
    error returned”, instead of “NO Mailbox doesn't exist”, depending on the
    actual configuration. This can happen with the shared namespace.

M	src/lib-storage/fail-mailbox.c

2021-11-23 17:55:43 +0200 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (13ed86bbf3)

    login-common: Default director_username_hash to %Lu like everywhere else

    This setting has many places where the default is set, and this syncs it 
    with the others.

M	src/login-common/login-settings.c

2021-11-12 11:16:47 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (d36d2c595a)

    lib-storage: mail-duplicate - Fix segfault occurring when user has no
    configured home directory

    Occurred only when a duplicate DB transaction was created.

M	src/lib-storage/mail-duplicate.c

2021-11-12 10:43:16 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (98f709deac)

    lib-storage: mail-duplicate - Fix panic occurring when user has no
    configured home directory.

    Panic was:

    Panic: file imem.c: line 65 (i_strconcat): assertion failed: (str1 != NULL)

M	src/lib-storage/mail-duplicate.c

2021-11-11 09:57:07 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (476990fffa)

    stats: Whitespace cleanup.


M	src/stats/stats-metrics.c

2021-11-09 14:12:18 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (e41cd77f96)

    doveadm: Fix processing of group-by parameter of doveadm stats add.


M	src/doveadm/doveadm-stats.c

2020-09-25 03:48:09 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (6341cfc57a)

    lib-smtp: smtp-client-transaction - Always drop MAIL/RCPT state data before
    calling callbacks.

    This prevents problems with callbacks destroying the transaction, the 
    connection, or commands involved in the transaction. This at least fixes a 
    segmentation fault occurring in the submission service when STARTTLS fails 
    during login.

M	src/lib-smtp/smtp-client-transaction.c

2021-11-08 23:29:35 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (0037fb7bad)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_rcpt_fail_reply(NULL, reply) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:31:07 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (30f0154b78)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_rcpt_abort(NULL) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:29:53 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (53b3b9f55b)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_rcpt_replied(NULL) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:27:39 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (f4c5ab773a)

    lib-smtp: smtp-client-transaction - Assert that
    smtp_client_transaction_rcpt_approved/denied() has non-NULL parameter.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:24:29 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (5e68870131)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_rcpt_free(NULL) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:22:45 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (da73aac321)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_mail_fail_reply(NULL, reply) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:21:06 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (86debae8fe)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_mail_abort(NULL) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:18:56 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (8f2751f53d)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_mail_replied(NULL, reply) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:17:57 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (02079622d1)

    lib-smtp: smtp-client-transaction - Make
    smtp_client_transaction_mail_free(NULL) a no-op.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 02:45:27 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (c588b55541)

    lib-smtp: smtp-client-command - Drop callback before call in
    smtp_client_command_input_reply().


M	src/lib-smtp/smtp-client-command.c

2020-09-25 02:38:54 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (34e5a418c1)

    lib-smtp: smtp-client-command - Make smtp_client_command_fail_reply(NULL,
    reply) a no-op.


M	src/lib-smtp/smtp-client-command.c

2020-09-25 02:33:33 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (ed211d21b0)

    lib-smtp: smtp-client-command - Make smtp_client_command_abort(NULL) a
    no-op.


M	src/lib-smtp/smtp-client-command.c

2020-09-25 03:00:31 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (15c98d994b)

    lib-smtp: Reformat smtp-client-transaction.c.


M	src/lib-smtp/smtp-client-transaction.c

2020-09-25 03:14:16 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (ec3cdb2168)

    lib-smtp: Reformat smtp-client-command.c.


M	src/lib-smtp/smtp-client-command.c

2021-10-28 09:19:37 +0200 Marco Bettini <marco.bettini@open-xchange.com> (1863b1c535)

    lib-fts: Don't index inline base64 encoded content


M	src/lib-fts/fts-tokenizer-generic.c
M	src/lib-fts/test-fts-tokenizer.c

2021-11-14 23:27:00 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (771ebaf961)

    lib-smtp: smtp-server-command - Emit smtp_server_command_started event a
    little later.

    This way cmd_*args fields are available for the event.

M	src/lib-smtp/smtp-server-command.c

2021-10-27 00:48:28 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (6687627b15)

    lib-smtp: smtp-server-command - Add cmd_args and cmd_human_args fields.

    This mirrors the identically named fields for the imap service. For SMTP, 
    though, cmd_human_args == cmd_args.

M	src/lib-smtp/smtp-server-command.c

2021-07-19 11:53:41 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (f0e2299322)

    lib-http: http-client-connection - Fix crash in
    http_client_connection_server_close().

    The conn->peer member is only not NULL when the connection is associated
    with a peer object. If it is not, http_client_connection_server_close() will
    crash. Fixed by doing the peer->client operations only when there is an
    associated peer.

M	src/lib-http/http-client-connection.c

2020-06-27 17:55:58 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (9032716e00)

    lib-http: Reformat http-client-connection.c.


M	src/lib-http/http-client-connection.c

2021-10-29 11:42:40 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (f572de72f4)

    lib: Add unit tests for named events only optimization.


M	src/lib/event-filter-private.h
M	src/lib/event-filter.c
M	src/lib/test-event-filter.c

2021-10-29 14:06:39 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (5a69a67fb8)

    lib: Fix event filtering for unnamed events with optional event name

    For example event filter "event=ev_name OR field1=value1" wouldn't
    previously match if the event didn't have any name, even if it did have
    field1=value1.

M	src/lib/event-filter-parser.y
M	src/lib/event-filter.c

2021-10-22 12:09:24 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (f01aec1f96)

    lib-master: Whitespace cleanup.


M	src/lib-master/master-service.c

2021-11-09 14:37:07 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (f083562f92)

    auth: passdb-cache - Preserve cached fields when verifying password with
    worker


M	src/auth/passdb-cache.c

2021-11-05 17:11:49 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (533ef6c62d)

    lib-smtp: smtp-server-command - Hold a command reference while sending
    replies.

    Fixes segfault at smtp-server-reply.c:652.

M	src/lib-smtp/smtp-server-command.c

2021-11-05 16:53:48 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (2275fc4d51)

    lib-smtp: smtp-server-command - Split off
    smtp_server_command_send_more_replies().


M	src/lib-smtp/smtp-server-command.c

2021-11-05 16:46:15 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (9ae95cb884)

    lib-smtp: smtp-server-command - Split off
    smtp_server_command_send_replies().


M	src/lib-smtp/smtp-server-command.c
M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server-private.h

2021-11-08 14:36:57 +0200 sergey.kitov <sergey.kitov@open-xchange.com> (083570cb73)

    plugins/fts: Fix memory leak when searching mail in virtual folder with fts.


M	src/plugins/fts/fts-storage.c

2021-11-08 14:04:07 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (5afea22757)

    configure: Fix version macros to work with devel version


M	configure.ac

2021-11-08 15:24:30 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (318f566fc4)

    SECURITY.md: Add initial security policy


A	SECURITY.md

2021-10-26 16:59:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e188435026)

    lib-fts: Fix address tokenizer to handle large input properly

    Previously it could have used excessive amounts of memory if the input 
    didn't contain separator characters.

    The fix changes a bit how the address-tokenizer works: Previously large 
    email addresses were saved as truncated tokens. Now they're skipped entirely
    by the address tokenizer. Similarly when searching long email addresses
    they're no longer searched as truncated tokens, but instead simply fed to
    the parent tokenizer which (likely) searches them in smaller pieces.

    Note that this also sometimes changes the order in which tokens are 
    returned, e.g. "foo", "example", "foo@example.com", "com" instead of 
    returning "com" before the email address. This isn't ideal, but fixing it 
    seems annoyingly complicated and practically it doesn't matter right now.

M	src/lib-fts/fts-tokenizer-address.c
M	src/lib-fts/test-fts-tokenizer.c

2021-10-26 16:34:25 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2af8437d1d)

    lib-fts: Implement support for parent tokenizer "streaming"

    By default parent tokenizer is further tokenizing the token strings returned 
    by child tokenizer. When streaming is enabled, the parent tokenizers are 
    instead tokenizing a stream of data sent by the child tokenizer. This 
    effectively makes the parent tokenizer return the same tokens as if the 
    child tokenizer didn't exist (assuming child tokenizer feeds the parent all
    the same input).

    Arguably this should be the only way tokenizers work, but at least for now 
    lets keep both ways.

M	src/lib-fts/fts-tokenizer-private.h
M	src/lib-fts/fts-tokenizer.c

2021-10-26 12:33:50 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (782d806db2)

    lib-fts: fts-tokenizer - Add comments explaning how it works


M	src/lib-fts/fts-tokenizer.c

2021-10-26 11:52:22 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2e91a13fe9)

    lib-fts: test-fts-tokenizer - Add more uniqueness to the long email address

    This helps at least with debugging problems.

M	src/lib-fts/test-fts-tokenizer.c

2021-09-14 18:21:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (31c24137c2)

    lib: DOVECOT_PREREQ() - Add micro version

    Nowadays APIs can change between micro versions as well.

M	src/lib/macros.h

2021-09-14 18:23:41 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (cb5968f451)

    lib: DOVECOT_PREREQ() - Remove surrounding if checks

    The DOVECOT_VERSION_* macros are expected to always exist.

M	src/lib/macros.h

2021-09-14 18:21:03 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d199125cc5)

    configure: Add DOVECOT_VERSION_MICRO


M	configure.ac

2021-11-02 16:06:55 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e95f985635)

    lib: Fix building with --disable-asserts

    The #endif location was wrong.

M	src/lib/macros.h

2021-01-27 02:20:53 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (17efe7a404)

    submission-login: Implicitly login using EXTERNAL mechanism upon MAIL if
    enabled.

    This is a workaround for TLS clients that present a valid client
    certificate, yet don't authenticate explicitly. This is enabled by setting:

    submission_client_workarounds = implicit-auth-external

M	src/submission-login/client-authenticate.c
M	src/submission-login/client-authenticate.h
M	src/submission-login/client.c
M	src/submission-login/submission-login-settings.c
M	src/submission-login/submission-login-settings.h
M	src/submission/main.c
M	src/submission/submission-client.c
M	src/submission/submission-client.h
M	src/submission/submission-settings.c

2021-10-14 12:47:23 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (1236352801)

    submission-login: client-authenticate - Split off
    cmd_auth_set_master_data_prefix().


M	src/submission-login/client-authenticate.c

2021-01-27 13:51:03 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (14b6f813e0)

    login-common: sasl-server - Add support for implicit login.


M	src/login-common/client-common-auth.c
M	src/login-common/sasl-server.c
M	src/login-common/sasl-server.h

2021-01-27 13:43:23 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (d4321dd910)

    login-common: sasl-server - Turn private argument of
    sasl_server_auth_begin() into flag.


M	src/login-common/client-common-auth.c
M	src/login-common/client-common.h
M	src/login-common/sasl-server.c
M	src/login-common/sasl-server.h

2021-01-27 13:39:23 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (d5588935bf)

    lib-master: master-auth - Add support for MAIL_AUTH_REQUEST_FLAG_IMPLICIT
    flag.

    It signals that this login is implicit; no command reply is expected. This
    is going to be used by the Submission service to implicitly login a user
    using the EXTERNAL SASL mechanism when the first MAIL command is issued. In
    that case sending a reply for the implicit AUTH command would break the
    protocol and this new flag is used to signal the post-login submission
    service to not send an initial reply.

M	src/lib-master/master-auth.h

2021-01-27 13:40:43 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (a0eeeb6c76)

    lib-smtp: smtp-server - Add support for suppressing the inital greeting
    reply.


M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server.c
M	src/lib-smtp/smtp-server.h

2021-01-27 02:22:10 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (eef32e87e4)

    lib-smtp: smtp-server - Make default command functions public.


M	src/lib-smtp/smtp-server-private.h
M	src/lib-smtp/smtp-server.h

2021-01-27 02:21:50 +0100 Stephan Bosch <stephan.bosch@open-xchange.com> (6b380d6072)

    lib-smtp: smtp-server-command - Allow overriding commands.


M	src/lib-smtp/smtp-server-command.c
M	src/lib-smtp/smtp-server.h

2021-10-30 00:43:55 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (73b1ed4e82)

    submission-login: client - Explicitly set SMTP server command and auth line
    limits.

    This way, it will always use the same limits as all other login services.

M	src/submission-login/client.c

2021-10-29 20:41:42 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (056aeb0748)

    lib-smtp: smtp-command-parser - Make parser suitable for input stream with
    small buffer.


M	src/lib-smtp/smtp-command-parser.c
M	src/lib-smtp/test-smtp-server-errors.c

2021-10-29 23:44:01 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (d982aaadf1)

    lib-smtp: smtp-command - Use size_t for command line limits.


M	src/lib-smtp/smtp-command-parser.c
M	src/lib-smtp/smtp-command.h

2021-10-29 19:37:16 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (12eb20fc0d)

    lib-smtp: test-smtp-server-errors - Add tests for very long AUTH response
    lines.


M	src/lib-smtp/test-smtp-server-errors.c

2021-10-29 19:36:18 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (eb22a35feb)

    lib-smtp: test-smtp-command-parser - Add test for very long AUTH response
    line.


M	src/lib-smtp/test-smtp-command-parser.c

2021-10-29 23:52:05 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (e0fa1375e2)

    lib-smtp: Reformat smtp-command-parser.c.


M	src/lib-smtp/smtp-command-parser.c

2021-10-29 23:47:57 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (f47cc80a24)

    lib-smtp: Reformat smtp-command-parser.h.


M	src/lib-smtp/smtp-command-parser.h

2021-11-01 08:33:49 -0400 Timo Sirainen <timo.sirainen@open-xchange.com> (6fff8d5819)

    master: Use MASTER_SERVICE_FLAG_DISABLE_SSL_SET

    This prevents startup failures if ssl_ca has a large number of certificates.

    Broken by 36ff43f1a9aff8594d08f791e77ea13390fd569f

M	src/master/main.c

2021-11-01 08:33:14 -0400 Timo Sirainen <timo.sirainen@open-xchange.com> (ca2237e067)

    lib-master: Add MASTER_SERVICE_FLAG_DISABLE_SSL_SET


M	src/lib-master/master-service-settings.c
M	src/lib-master/master-service.h

2021-10-27 12:06:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7fc901f370)

    lib-ssl-iostream: Fix assert-crash when OpenSSL returns syscall error
    without errno

    Incomplete fix in f41874b3dec541478a85275698a91f089f537df2

    Fixes: Panic: file istream-openssl.c: line 51 (i_stream_ssl_read_real):
    assertion failed: (errno != 0)

M	src/lib-ssl-iostream/iostream-openssl.c

2021-10-14 18:31:19 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (84d3bc8e21)

    lib-storage: Improve mailbox_vfuncs.search_next_update_seq() comment


M	src/lib-storage/mail-storage-private.h

2019-08-08 15:35:03 -0600 Michael M Slusarz <michael.slusarz@open-xchange.com> (d1e1e346a8)

    example-config: Remove outdated object-storage conf.d file


D	doc/example-config/conf.d/11-object-storage.conf

2021-10-28 17:07:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (0407978a8f)

    dsync: Add back missing -T parameter

    Broken by 5676c510bfa9217df05e9b7cb000ae3554d66f22

M	src/doveadm/doveadm-dsync.c

2021-09-16 11:24:31 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (9705b81fb5)

    fts: Keep track of every backend mailbox fts index status for virtual
    folders.


M	src/plugins/fts/fts-search.c
M	src/plugins/fts/fts-storage.c
M	src/plugins/fts/fts-storage.h

2021-10-22 12:07:17 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (392d79bbd2)

    fts: Whitespace cleanup.


M	src/plugins/fts/fts-storage.c

2021-10-14 17:33:30 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (356b36fc52)

    lib-storage: Move search matching into
    mailbox_vfuncs.search_next_match_mail()


M	src/lib-storage/fail-mailbox.c
M	src/lib-storage/index/dbox-multi/mdbox-deleted-storage.c
M	src/lib-storage/index/dbox-multi/mdbox-storage.c
M	src/lib-storage/index/dbox-single/sdbox-storage.c
M	src/lib-storage/index/imapc/imapc-storage.c
M	src/lib-storage/index/index-search.c
M	src/lib-storage/index/index-storage.h
M	src/lib-storage/index/maildir/maildir-storage.c
M	src/lib-storage/index/mbox/mbox-storage.c
M	src/lib-storage/index/pop3c/pop3c-storage.c
M	src/lib-storage/index/raw/raw-storage.c
M	src/lib-storage/mail-storage-private.h
M	src/plugins/virtual/virtual-storage.c

2021-01-08 11:21:20 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (547c07bdd3)

    lib: Use data stack frame with IO switch and destroy callbacks


M	src/lib/ioloop.c

2021-01-08 11:28:26 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (0a9123d94c)

    lib: Use data stack frame with IO context activate/deactive callbacks

    These were running outside the regular ioloop data stack frames, so if the 
    callback used any data stack it kept increasing memory usage.

    This fixes excessive memory usage with old_stats plugin when used with 
    long-running imap sessions. The memory got filled with UPDATE-SESSION 
    commands.

M	src/lib/ioloop.c

2021-09-29 00:04:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2cea75b7f5)

    lib-storage: When search parses message headers, deinitialize the parsing
    properly

    index_mail_parse_header() was being called only for the actual headers. This
    prevented it from being called with hdr=NULL to indicate that the parsing is
    finished and should be deinitialized. Move the index_mail_parse_header() to
    be called earlier so it's called also with hdr=NULL.

    Not deinitilizing the parsing could have caused assert-crashes later on in 
    some situations.

    Fixes: Panic: file index-mail-headers.c: line 667
    (index_mail_get_raw_headers): assertion failed:
    (mail->mail.mail.lookup_abort >= MAIL_LOOKUP_ABORT_NOT_IN_CACHE) Panic: file
    ../../../src/lib/array.h: line 244 (array_idx_i): assertion failed: (idx <
    array->buffer->used / array->element_size) Panic: file index-mail.c: line
    1203 (index_mail_parse_body_finish): assertion failed: (!success)

M	src/lib-storage/index/index-search.c

2021-10-21 15:45:56 +0200 Marco Bettini <marco.bettini@open-xchange.com> (be55b9a4e0)

    doveadm: Route help/usage messages on stderr rather than stdout.


M	src/doveadm/doveadm.c

2021-09-30 16:19:58 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (dbf7ed69c3)

    login-common: Add proxying events

    - proxy_session_started: Emitted before connecting to remote
    - proxy_session_established: Emitted after connection to remote is
    established and user is successfully logged in to the backend.
    - proxy_session_finished: Emitted when proxying has ended. Either
    successfully or with error.

M	src/login-common/client-common-auth.c
M	src/login-common/login-proxy.c

2021-09-30 12:49:31 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (32e57666dc)

    login-common: Change login proxy message to include IP address

    Will be in format "<IP> (<host>)". Host part is optional and not added if
    proxy target is an IP address.

M	src/login-common/client-common-auth.c

2021-10-05 11:33:06 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (313b96cd9a)

    login-proxy: Add source_port to proxy event after connection is established


M	src/login-common/login-proxy.c

2021-10-05 15:17:50 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (ac4089115b)

    login-common: Add more fields to login proxy event

    Adds
    - source_ip
    - dest_ip
    - dest_port
    - dest_host
    - master_user

M	src/login-common/login-proxy.c

2021-10-07 22:52:47 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (574ad02a47)

    login-common: Start proxying after client fields are set

    Allows adding more event fields in login_proxy_new().

M	src/login-common/client-common-auth.c

2021-09-30 12:48:09 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (e202252702)

    login-proxy: Add login_proxy_get_ip_str()

    Returns proxy IP address as string.

M	src/login-common/login-proxy.c
M	src/login-common/login-proxy.h

2021-10-07 10:29:04 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (9ed1cdecee)

    client-common: Add service field to client event


M	src/login-common/client-common.c

2021-10-13 14:49:43 +0300 Marco Bettini <marco.bettini@open-xchange.com> (351b424a37)

    imap: list_send_status() - Fixes LIST-EXTENDED doesn't return STATUS for all
    folders

    Sending LIST .. RETURN (SUBSCRIBED STATUS (...)) did not return STATUS for
    folders that are not subscribed when they have a child folder that is
    subscribed as mandated by IMAP RFC

M	src/imap/cmd-list.c

2021-10-13 11:45:05 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b3f32368aa)

    lib-index: Add mail_index_alloc_cache_find()


M	src/lib-index/mail-index-alloc-cache.c
M	src/lib-index/mail-index-alloc-cache.h

2021-10-07 18:11:00 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (55338455ae)

    maildir: Fix crash when closing a mailbox that isn't open

    This could have happened at least with virtual plugin.

M	src/lib-storage/index/maildir/maildir-storage.c

2021-10-08 16:32:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2555d374c0)

    master: test-auth-client - Check that authorization ID is as expected


M	src/master/test-auth-client.c

2021-10-07 20:18:21 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b314a81a69)

    master: test-auth-client - Fix authenid check to be assert

    It can never be NULL at this point.

M	src/master/test-auth-client.c

2021-10-07 19:59:52 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (859529c802)

    lib-dict: dict-lua - Throw Lua error if dict key is invalid or username is
    missing

    This prevents assert-crashes in the C code.

M	src/lib-dict/dict-iter-lua.c
M	src/lib-dict/dict-lua.c
M	src/lib-dict/dict-lua.h
M	src/lib-dict/dict-txn-lua.c

2021-10-07 19:54:41 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e26cebc652)

    lib-dict: dict_lookup_async() - Add missing assert to check for key prefix
    and username


M	src/lib-dict/dict.c

2021-10-07 19:42:41 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5ed33ba11b)

    lib-master: Prevent read buffer overflow with invalid haproxy header size

    This could have happened only for connections from haproxy_trusted_networks, 
    so it's unlikely to cause any real security issues.

M	src/lib-master/master-service-haproxy.c

2021-10-07 19:36:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1ed470aa2d)

    lib-dcrypt: dcrypt_openssl_decrypt_point_password_v1() - Fix crash if pbkdf2
    generation fails


M	src/lib-dcrypt/dcrypt-openssl.c

2021-10-06 15:38:55 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1e12cf4be0)

    imap: Fix handling client initialization error

    It should send "OK Logged in" + BYE, not PREAUTH.

    Broken by 714ff4342e39e309ff184905cd2f714def6177a3

M	src/imap/main.c

2021-10-08 16:02:04 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5a26f6160b)

    imap: Move client_add_input() content to calling functions


M	src/imap/main.c

2021-10-08 15:57:50 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8f5d8d9e13)

    imap: Move IMAPLOGINTAG environment handling

    It can only happen with stdio clients when they don't have CLIENT_INPUT, so
    it makes more sense to exist in the calling function.

M	src/imap/main.c

2021-10-06 15:43:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (29471bf743)

    imap-login: proxy: Don't forward untagged BYE responses to the client

    It will just cause confusion, especially when connections are retried. It
    could end up looking like:

    x login user pass
    * BYE Internal error occurred. Refer to server log for more information.
    * BYE Internal error occurred. Refer to server log for more information.
    * BYE Internal error occurred. Refer to server log for more information.
    * BYE Internal error occurred. Refer to server log for more information. x
    NO [UNAVAILABLE] Account is temporarily unavailable.

M	src/imap-login/imap-proxy.c

2021-10-08 15:53:21 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f4da884f67)

    lib-storage: mail_storage_service_lookup() - Fix memory leak when returning
    -2

    This was also visible as event leaks.

M	src/lib-storage/mail-storage-service.c

2021-09-28 20:46:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f29786350e)

    lib-index: Fix potential crash with debug logging when looking up cache


M	src/lib-index/mail-cache-lookup.c

2021-09-28 20:45:47 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a016ac6a3e)

    lib-index: mail_cache_lookup_iter_next() - Add a warning comment about
    re-reading fields


M	src/lib-index/mail-cache-private.h

2021-10-07 15:52:28 +0200 Marco Bettini <marco.bettini@open-xchange.com> (08656f3aad)

    mail-crypt: mail_crypt_load_global_private_key() - Drop unnecessary NULL
    check


M	src/plugins/mail-crypt/mail-crypt-global-key.c

2021-09-28 18:13:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b4217b8d36)

    lib, global: i_stream_create_chain() - Add max_buffer_size

    This makes sure that the istream size can't grow too large and waste memory.

    Previously the istream max_buffer_size was dynamically changed to be the 
    smallest seen max_buffer_size in chained istreams. This mostly worked, but 
    sometimes the istream-chain's max_buffer_size was requested before even the 
    first istream was added to it.

    Having an explicit max_buffer_size avoids all the problems of it being 
    dynamic, and there's not really any need for it anyway.

M	src/imap/cmd-append.c
M	src/lib-http/test-http-client-errors.c
M	src/lib-smtp/smtp-server-cmd-data.c
M	src/lib-storage/index/pop3c/pop3c-client.c
M	src/lib/istream-chain.c
M	src/lib/istream-chain.h
M	src/lib/test-istream-chain.c

2021-10-07 14:52:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2aa531b4a4)

    virtual: Fix assert-crash when backend mbox mailbox is deleted while virtual
    mailbox is open

    The code wrongly thought that metadata lookup couldn't fail because it was 
    already successfully looked up. But the backend storage could still try to 
    refresh the mailbox to verify whether it still exists or not, and fail if it
    was deleted.

    This seems to have affected only the mbox mailbox format.

    Broken by 710346bcb884b464c8ed128870fdc1999c13dfd3

M	src/plugins/virtual/virtual-sync.c

2021-10-05 02:03:00 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5050000f5d)

    lib: istream-concat - Add a comment about explicit snapshot function


M	src/lib/istream-concat.c

2021-10-05 01:39:50 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e830aca4ef)

    lib: test-istream-concat - Unref child istreams immediately

    This doesn't currently make a difference, since istream-concat keeps them 
    internally referenced. In case this changes and snapshot handling isn't 
    fixed similarly to istream-chain, the unit test should now fail.

M	src/lib/test-istream-concat.c

2021-10-04 18:25:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9507dcba9f)

    lib: istream-concat - Fix snapshot handling when combining two istreams

    Snapshotting wasn't handled correctly when two (or more) istreams' contents 
    were combined into the same buffer.

M	src/lib/istream-concat.c
M	src/lib/test-istream-concat.c

2021-10-05 00:55:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4614c27f68)

    lib: istream-chain - Optimize snapshot handling


M	src/lib/istream-chain.c

2021-10-05 01:32:22 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (539a052672)

    lib: istream-chain - Fix snapshot handling when link istream is destroyed


M	src/lib/istream-chain.c
M	src/lib/istream-private.h
M	src/lib/istream.c
M	src/lib/test-istream-chain.c

2021-10-04 18:17:49 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (504c0e6424)

    lib: istream-chain - Fix snapshot handling when combining two istreams

    Snapshotting wasn't handled correctly when two (or more) istreams' contents 
    were combined into the same buffer.

M	src/lib/istream-chain.c
M	src/lib/test-istream-chain.c

2021-10-05 01:00:38 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (39642d6b49)

    lib: Add i_stream_memarea_detach()


M	src/lib/istream-private.h
M	src/lib/istream.c

2021-10-04 17:41:27 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (67324622b6)

    lib: test-istream-chain - Use more unique strings for testing

    DEBUG checks don't work well if the input repeats the same character.

M	src/lib/test-istream-chain.c

2019-09-15 00:08:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (43d7f354c4)

    lib: istream-seekable - Fix crash after write to temp file failed

    Fixes: Panic: file istream-seekable.c: line 230 (read_from_buffer):
    assertion failed: (*ret_r > 0)

M	src/lib/istream-seekable.c

2019-09-15 00:06:58 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (66fc9ffd4c)

    lib: istream-seekable - Don't double-close temp file fd on errors

    Closing the fd_input stream already auto-closes the fd.

M	src/lib/istream-seekable.c

2019-09-14 23:53:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (eb15b02121)

    lib: istream-seekable - Fix crash if writing to temp file fails


M	src/lib/istream-seekable.c
M	src/lib/test-istream-seekable.c

2021-09-29 13:13:53 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (7f752d77be)

    lib: i_stream_try_alloc() - Add sanity check asserts


M	src/lib/istream.c

2021-10-06 17:37:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (baf3e985c0)

    lib-imap-client: test-imapc-client - Increase connect timeout for most tests

    The 500ms timeout could have been too short when running with valgrind on an 
    overloaded system. Increase it to 5 seconds, but keep 500ms for the tests 
    that expect a timeout.

M	src/lib-imap-client/test-imapc-client.c

2021-10-06 05:03:08 -0400 Marco Bettini <marco.bettini@open-xchange.com> (313ce3e709)

    lib-master: master_login_auth_callback() - Add assert to guard for both
    errormsg and auth_args being NULL


M	src/lib-master/master-login.c

2021-10-07 03:55:59 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e7754572e6)

    auth: db-passwd-file - Fix using paths with %% escaped characters but no
    %variables

    full_key might not have been NULL, causing var_expand() to read past the 
    array and possibly crash.

M	src/auth/db-passwd-file.c

2021-10-07 03:46:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (687bc05ad0)

    lib: t_get_bytes_available() - Move code inside DEBUG to avoid dead code
    warning


M	src/lib/data-stack.c

2021-10-07 03:44:46 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6e02a7ba64)

    lib-index: mail_index_sync_init_expunge_handlers() - Simplify and remove
    dead code


M	src/lib-index/mail-index-sync-ext.c

2021-10-07 03:37:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1bf116c7a6)

    lib-index: test-mail-index-write - Fix initializing map.hdr_copy_buf


M	src/lib-index/test-mail-index-write.c

2021-10-07 03:29:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a08c2213af)

    lib-settings: test-settings-parser - Check settings_parser_check() return
    value


M	src/lib-settings/test-settings-parser.c

2021-10-07 03:28:56 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a3b12700a6)

    auth: Make sure auth_request_import() doesn't unexpectedly fail


M	src/auth/auth-master-connection.c

2021-10-07 03:10:28 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4327b55f45)

    lib: Change i_unreached() to be a function

    This allows overriding the function in a Coverity model, so it can 
    understand that i_unreached() is intended to be unreachable code.

M	src/lib/failures.c
M	src/lib/failures.h
M	src/lib/macros.h

2021-10-07 02:32:26 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (44bd159679)

    lib: base64 - Add asserts to check max_line_len is in valid range


M	src/lib/base64.c

2021-10-04 13:32:51 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1f0fad9044)

    ipc: Disable connecting to stats

    This avoids reconnect errors if stats process crashes.

M	src/ipc/main.c

2021-10-01 01:44:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (dec257fb78)

    master: Use relative path for stats_writer_socket_path for chrooted services

    This allows login process to reconnect to stats-writer if it gets 
    disconnected.

M	src/master/service-process.c

2021-10-01 01:42:43 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f08703dae8)

    stats: Add login/stats-writer socket


M	src/stats/stats-settings.c

2021-10-04 02:58:15 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (53b018722b)

    lmtp: lmtp-proxy - Use the per-recipient session ID for the "Saved" message.


M	src/lmtp/lmtp-proxy.c

2021-10-04 02:57:25 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (0daefe8937)

    lmtp: Move session_id field to generic recipient struct.


M	src/lmtp/lmtp-commands.c
M	src/lmtp/lmtp-local.c
M	src/lmtp/lmtp-recipient.c
M	src/lmtp/lmtp-recipient.h

2021-10-02 00:21:40 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (47c7166b91)

    lmtp: lmtp-proxy - Forward session ID towards backend.


M	src/lmtp/lmtp-proxy.c

2021-10-02 00:21:06 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (e67d8cdb88)

    lmtp: lmtp-local - Always add RCPT index to session ID for delivery.

    Even when it is 1.

M	src/lmtp/lmtp-local.c

2021-10-02 00:36:09 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (c8423c354b)

    lib-smtp: smtp-server-transaction - Base transaction ID on connection
    session ID.

    Composed as "<connection session ID>:<trasaction sequence>".

M	src/lib-smtp/smtp-server-private.h
M	src/lib-smtp/smtp-server-transaction.c

2021-10-02 00:32:05 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (e6451151f5)

    lib-smtp: smtp-server-connection - Manage session ID for the connection.


M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server-private.h

2021-10-02 00:29:29 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (8fb86c24be)

    lib-smtp: smtp-server-cmd-xclient - Parse XCLIENT SESSION field.


M	src/lib-smtp/smtp-server-cmd-xclient.c
M	src/lib-smtp/smtp-server-reply.c
M	src/submission-login/client.c

2021-10-02 00:16:22 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (8c6d07276b)

    lib-smtp: smtp-client-connection - Send new SESSION field with XCLIENT
    command.


M	src/lib-smtp/smtp-client-connection.c

2021-10-04 02:02:21 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (2d4587d13a)

    lib-smtp: smtp-client - Use smtp_proxy_data_merge() to copy proxy data in
    smtp_client_init().


M	src/lib-smtp/smtp-client.c

2021-10-02 00:15:07 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b1497466f2)

    lib-smtp: smtp-common - Add SESSION field to proxy data.


M	src/lib-smtp/smtp-common.c
M	src/lib-smtp/smtp-common.h

2021-10-02 00:25:50 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (66d9b71ad4)

    lib: connection - Add debug message for when property label (peer address)
    changes.


M	src/lib/connection.c

2021-10-02 00:26:28 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (4a84440f53)

    lib: connection - Make connection_update_properties() public.


M	src/lib/connection.c
M	src/lib/connection.h

2021-10-02 00:24:35 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (44819f897c)

    lib: connection - Drop useless newlines.


M	src/lib/connection.c

2019-02-21 18:50:10 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (1b13ee113b)

    lib-program-client: test-program-client-local - Use dd instead of head

    `head -c n` is only guaranteed to print n bytes, but it may consume more. 
    FreeBSD's implementation of head(1) uses buffered stdio, which did just
    that.

    `dd` consumes exactly the specified number of bytes.

M	src/lib-program-client/test-program-client-local.c

2021-08-10 13:38:39 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1489e6378c)

    login-proxy: Fix potential memory leak if backend login fails

    It also needs an abnormal way of destroying the client for the leak to 
    happen. For example if the login process is being killed.

M	src/login-common/client-common.c

2021-04-19 17:36:02 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (350600f984)

    lib-test: fuzzer - Disable error handling for output stream towards program.

    Fixes:

    Panic: output stream  is missing error handling

M	src/lib-test/fuzzer.c

2021-04-19 17:34:58 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b41e7198ad)

    lib-test: fuzzer - Provide names for fuzzer streams.


M	src/lib-test/fuzzer.c

2021-04-18 12:33:01 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (860e5e3a83)

    lib-smtp: smtp-server-cmd-helo - Fix crash occurring upon pipelined EHLO
    with invalid domain.

    Failed to check for NULL in domain value for a pipelined EHLO/HELO command.

M	src/lib-smtp/smtp-server-cmd-helo.c

2021-10-06 13:20:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2e06ce6c98)

    lib: Fix data_stack_get_alloc_size() and data_stack_get_used_size()

    It only worked correctly if data stack hadn't been grown. This resulted in
    wrong numbers in the data_stack_grow event.

M	src/lib/data-stack.c

2021-10-01 15:08:45 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (bdf4474ed8)

    virtual: Fix leaking mailboxes if virtual mailbox can't be opened

    Fixes also a crash at deinit: Panic: file mail-user.c: line 232
    (mail_user_deinit): assertion failed: ((*user)->refcount == 1)

M	src/plugins/virtual/virtual-storage.c

2021-10-04 17:25:05 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (79ebaf7b14)

    mdbox: Avoid calling container_of() with a NULL pointer


M	src/lib-storage/index/dbox-multi/mdbox-save.c

2021-10-04 15:20:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6275be1981)

    sdbox: Avoid calling container_of() with a NULL pointer


M	src/lib-storage/index/dbox-single/sdbox-save.c

2021-10-04 14:42:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a037ede37f)

    lib: buffer_free() - Check for buf==NULL before using container_of()

    Helps with static analyzer complaints.

M	src/lib/buffer.c

2021-10-04 14:42:14 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (ecaaa728c7)

    lib: lib-event - Assert-crash if attempting to use NULL passthrough event

    Fixes also complaints from static analyzer.

M	src/lib/lib-event.c

2021-10-04 14:22:22 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (bb5048cda0)

    lib: container_of() - Don't check for NULL after all

    Adding the explicit NULL checks for container_of() caused caused static 
    analyzers to think that NULL could be returned at any time. This caused 
    unnecessary warnings in various places.

    Reverts b178d0792b6335277f7fa831fd7e5403105abd04

M	src/lib/macros.h

2021-10-04 14:35:03 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5de8349891)

    lib: macros.h - Fix #endif position


M	src/lib/macros.h

2021-09-24 16:36:41 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6baff5b2d4)

    lib-index: Add more mail_index_ext_name_is_valid() asserts


M	src/lib-index/mail-index-map.c
M	src/lib-index/mail-index-sync-ext.c

2021-09-24 16:35:39 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f81779845a)

    lib-index: Handle invalid extension header names without assert-crashing

    Fixes: Panic: mail_index_ext_register(...): Invalid name

M	src/lib-index/mail-index-map.c

2021-09-24 16:27:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (05e570be12)

    lib-index: Add and use mail_index_ext_name_is_valid()

    Use it in mail_index_ext_register() instead of the more relaxed 
    str_sanitize() check.

M	src/lib-index/mail-index-private.h
M	src/lib-index/mail-index.c

2021-09-24 16:32:26 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4896364107)

    lib-index: Remove unused mail_index_sync_ext_init()

    It doesn't look like this was ever used for anything. The initial commit 
    used only mail_index_sync_ext_init_new().

M	src/lib-index/mail-index-sync-ext.c
M	src/lib-index/mail-index-sync-private.h

2021-07-29 11:37:23 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d7dc02bbb0)

    zlib: Handle empty zlib_save_level the same as if it doesn't exist


M	src/plugins/zlib/zlib-plugin.c

2021-07-29 11:29:37 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (42457ff2eb)

    zlib: Fix crash when zlib_save_level is set, but zlib_save is unset


M	src/plugins/zlib/zlib-plugin.c

2021-10-04 11:14:04 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (4cd6999dd5)

    driver-pgsql: Fix error leak


M	src/lib-sql/driver-pgsql.c

2021-10-04 12:37:11 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1e56bbb41b)

    lib-compression: ostream-zlib - Fix non-blocking gz header write

    Broken by 373dc6a93da1f6a0ad0c80dbb72566c2b3a295f2

M	src/lib-compression/ostream-zlib.c

2021-08-03 20:38:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1efd4a1765)

    lib-storage: mailbox_get_expunge*() - Fix assert-crash on index corruption

    This happened in the very unlikely situation that indexes became corrupted 
    between two mail_transaction_log_view_set() calls.

    Fixes: Panic: file mailbox-get.c: line 112 (mailbox_get_expunges_init):
    assertion failed: (ret != 0)

M	src/lib-storage/mailbox-get.c

2021-10-01 15:21:38 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (088783cdaa)

    lib: str_hash() - Ignore integer wrapping with ubsan

    ATTR_NO_SANITIZE_INTEGER was already set for other hash functions, but 
    forgotten for this one.

    Fixes e.g.: Error: hash.c:529:16: runtime error: unsigned integer overflow:
    4294967200 + 115 cannot be represented in type ‘unsigned int’

M	src/lib/hash.c

2021-09-28 00:51:03 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (3c05dcfa58)

    lib: ostream-wrapper - Make sure o_stream_finish() has stream_errno != 0
    when -1 is to be returned.

    Fixes:

    Panic: file ostream.c: line 209 (o_stream_flush): assertion failed:
    (stream->stream_errno != 0)

M	src/lib/ostream-wrapper.c

2021-10-01 10:42:16 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (a1729a72e8)

    driver-cassandra: Fix prepared statement pool leak


M	src/lib-sql/driver-cassandra.c

2021-09-30 18:42:08 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (ebd5223c8d)

    stats: Remove metric from stats dump, when removing dynamically.


M	src/stats/stats-metrics.c

2020-09-23 23:35:53 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (d16a69f7e2)

    lib-ssl-iostream: istream-openssl - Remove assert() in i_stream_ssl_read().


M	src/lib-ssl-iostream/istream-openssl.c

2020-09-23 23:35:30 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (50b7231aab)

    lib-ssl-iostream: iostream-openssl - Allow plain_input buffer to remain
    filled in openssl_iostream_bio_input().


M	src/lib-ssl-iostream/iostream-openssl.c

2020-09-23 22:02:41 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b4d477a50b)

    lib-ssl-iostream: iostream-openssl - Use o_stream_uncork_flush() to uncork
    the plain output.

    This flushes the stream after uncorking it, fixing I/O hang with nested SSL 
    layers.

M	src/lib-ssl-iostream/iostream-openssl.c

2021-09-30 00:17:47 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (f42c0637ac)

    lib-ssl-iostream: iostream-openssl - Return immediately from
    openssl_iostream_bio_output() upon error.


M	src/lib-ssl-iostream/iostream-openssl.c

2020-09-23 23:58:12 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (3200480ecf)

    lib-ssl-iostream: iostream-openssl - Move error handling out of
    openssl_iostream_bio_output().

    Makes the next commit clearer.

M	src/lib-ssl-iostream/iostream-openssl.c

2021-04-16 13:55:06 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (aa8a39557b)

    lib-ssl-iostream: test-iostream-ssl - Make finishing the ssl streams more
    robust.

    Fixes:

    Panic: file ostream.c: line 59 (o_stream_close_full): assertion failed:
    (stream->real_stream->error_handling_disabled)

M	src/lib-ssl-iostream/test-iostream-ssl.c

2021-04-16 18:18:07 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (2816a2525b)

    lib-ssl-iostream: test-iostream-ssl - Properly mark client endpoints.


M	src/lib-ssl-iostream/test-iostream-ssl.c

2021-04-16 18:21:01 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (7738cb723b)

    lib-ssl-iostream: test-iostream-ssl - Move small_packets_flush_callback().


M	src/lib-ssl-iostream/test-iostream-ssl.c

2021-04-16 18:19:55 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (3e53f67a65)

    lib-ssl-iostream: test-iostream-ssl - Move bufsize_flush_callback().


M	src/lib-ssl-iostream/test-iostream-ssl.c

2021-04-16 14:52:34 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (0f4a532bd1)

    lib-ssl-iostream: ostream-openssl - Call SSL_shutdown() once stream is
    finished and buffer is empty.


M	src/lib-ssl-iostream/ostream-openssl.c

2021-04-16 12:31:13 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (46970690e9)

    lib: istream - Remove try_alloc_limit.


M	src/lib/istream-private.h
M	src/lib/istream.c

2021-04-16 12:27:48 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b44c5504ff)

    lib-ssl-iostream - iostream-openssl - Use i_stream_read_limited().


M	src/lib-ssl-iostream/iostream-openssl.c

2021-04-16 12:25:43 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (377f1cbe88)

    lib: istream - Add i_stream_read_limited().


M	src/lib/istream-private.h
M	src/lib/istream.c
M	src/lib/istream.h

2020-09-27 15:19:05 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (00df102e56)

    lib-ssl-iostream: istream-openssl - Simplify i_stream_ssl_read().

    Avoid using a stack buffer. Just fill the stream to the maximum buffer size.

M	src/lib-ssl-iostream/istream-openssl.c

2021-04-16 18:08:50 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b4a2da442d)

    lib-ssl-iostream: iostream-openssl - Add OPENSSL_IOSTREAM_SYNC_TYPE_NONE.

    This is useful for calling openssl_iostream_handle_error() while avoiding 
    processing more I/O.

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h

2021-09-24 19:16:43 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8a9d1aa7b6)

    lib-ssl-iostream: Fix error handling if parent iostream fails

    Expand out and remove openssl_iostream_more(). It could have returned errors
    to two different locations depending on whether the failure came from SSL
    handshake or parent iostream.

M	src/lib-ssl-iostream/iostream-openssl.c
M	src/lib-ssl-iostream/iostream-openssl.h
M	src/lib-ssl-iostream/istream-openssl.c
M	src/lib-ssl-iostream/ostream-openssl.c

2021-09-24 19:15:22 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (75a6da0a1e)

    lib-ssl-iostream: ostream-ssl - Add ssl_io helper variable


M	src/lib-ssl-iostream/ostream-openssl.c

2021-09-24 18:59:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6289334552)

    lib: o_stream_copy_error_from_parent() - Assert-crash if source stream_errno
    is 0

    This can help debug situations where error is missing.

M	src/lib/ostream.c

2021-09-24 18:59:21 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8f22f0ab6e)

    global: Call o_stream_copy_error_from_parent() only on errors


M	src/lib-http/http-transfer-chunked.c
M	src/lib-mail/ostream-dot.c

2021-09-24 18:58:02 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (373dc6a93d)

    lib-compression: ostream-zlib - Fix sending partial gz header to parent
    ostream

    This practically wouldn't happen.

M	src/lib-compression/ostream-zlib.c

2021-09-30 15:38:23 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1545fadb3d)

    lib-http: test-http-client-errors - Revert previous retry changes

    The real bug is found now, so the previous fix attempt isn't useful. Reverts
    ed1264368a5435c3080871380156978a8951fe26

M	src/lib-http/test-http-client-errors.c

2021-09-30 15:32:24 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (37f4f27114)

    lib-http: test-http-client-errors - Reset USR1 notification signal between
    tests

    The "connection refused" test already set the signal as being received, 
    which caused the "connection refused backoff" test to randomly fail since it 
    thought the signal was immediately received.

M	src/lib-http/test-http-client-errors.c

2021-09-25 00:48:12 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (ddb173aa3d)

    lib: istream-concat - Prevent inheriting SIZE_MAX max buffer size from
    parent streams.

    Only when all parent streams have SIZE_MAX for max buffer size, the concat
    stream will follow suit.

M	src/lib/istream-concat.c

2021-09-27 20:35:19 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f5c1baf2cd)

    lib-storage: Add mailbox_list.disable_rebuild_on_corruption

    If set, don't try to rebuild the mailbox list index even if corruption is 
    detected.

M	src/lib-storage/list/mailbox-list-index.c
M	src/lib-storage/mailbox-list-private.h

2021-09-24 17:59:06 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (462d9b6ea6)

    lib-dcrypt: Fix istream-decrypt snapshotting

    This is mostly copy&pasted from istream-header-filter.

M	src/lib-dcrypt/istream-decrypt.c
M	src/lib-dcrypt/test-stream.c

2021-09-23 18:02:17 -0600 Michael M Slusarz <michael.slusarz@open-xchange.com> (9bf48f34bf)

    lib-storage: hide mail_cache_min_mail_count setting


M	src/lib-storage/mail-storage-settings.c

2021-09-26 01:16:53 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (ccb0579b3b)

    master: Avoid leaking master client fds to forked processes


M	src/master/master-client.c

2021-09-29 14:58:22 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (231105a825)

    stats: Improve error message for doveadm stats add.


M	src/stats/client-reader.c

2021-09-29 14:57:34 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (22bc379024)

    stats: Check if metric already exists when adding dynamically.


M	src/stats/stats-metrics.c

2021-09-28 15:35:05 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1ad80be9a6)

    driver-pglsqlpool: Implement sql_get_flags() reliably

    Try to use one of the already connected databases. If none were found, 
    create a new database.

M	src/lib-sql/driver-sqlpool.c

2021-09-28 15:32:56 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a55f18c67f)

    driver-pgsql: Implement sql_get_flags() reliably

    Some of the flags aren't known until server is connected to, so wait for the 
    connect to finish if necessary before returning the flags.

M	src/lib-sql/driver-pgsql.c

2021-09-28 15:33:47 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a90663e588)

    driver-sqlpool: Implement sql_wait()


M	src/lib-sql/driver-sqlpool.c

2021-09-27 11:59:09 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (8146312f9c)

    driver-cassandra: Add wait() implementation


M	src/lib-sql/driver-cassandra.c

2021-09-27 11:58:21 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (8981a97398)

    driver-pgsql: Add wait() implementation


M	src/lib-sql/driver-pgsql.c

2021-09-27 11:48:34 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (beca893733)

    dict-sql: Add "sql_dict_wait()" implementation

    lib-sql now has sql_wait().

M	src/lib-dict-backend/dict-sql.c

2021-09-27 11:46:07 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (3e717dd730)

    lib-sql: Add "wait" vfunc

    To be used in backends that support async operations. On deinit dicts should
    wait for results and then exit.

M	src/lib-sql/sql-api-private.h
M	src/lib-sql/sql-api.c
M	src/lib-sql/sql-api.h

2021-09-27 19:43:54 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (d5bf78e2da)

    driver-pgsql: Keep a list of pending query results

    To be used in wait() to determine if there are pending operations.

M	src/lib-sql/driver-pgsql.c

2021-09-22 20:57:06 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a660f544ea)

    dict: Wait for all dicts to finish pending operations at shutdown

    This also changes the dict process to exit cleanly instead of early via 
    lib_exit().

M	src/dict/dict-init-cache.c
M	src/dict/dict-init-cache.h
M	src/dict/main.c

2019-07-11 12:05:37 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d571a13586)

    dict: Unref dict connection immediately when connection is destroyed

    The delayed unrefing is needed when calling from dict command callbacks to 
    avoid calling dict_deinit() too early. But the connection's destroy() vfunc 
    can't be called directly from dict command callbacks, so there's no need to
    add further delays. Especially when this happens at deinit where there is no
    possibility of calling the delayed callback anymore.

M	src/dict/dict-connection.c

2021-09-27 11:42:07 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (60f20b00b9)

    driver-pgsql: Fix escaped blob prefix

    Escaped strings must be prefixed with double backslash.

M	src/lib-sql/driver-pgsql.c

2021-09-27 11:35:38 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (103a99d531)

    driver-pgsql: Fix assert-crash when using binary fields

    array_idx_modifiable() changed behavior in 
    1d4e5de8414ed93d1c810b30a91ad83d6d954861 and doesn't allocate space anymore.

    Fixes: Panic: file array.c: line 10 (array_idx_modifiable_i): assertion
    failed: (idx < array->buffer->used / array->element_size)

M	src/lib-sql/driver-pgsql.c

2021-09-29 18:04:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (f318731eac)

    doveadm mail batch: Fix run() return value on errors

    The function always returned 0, even when there was an error. This
    practically doesn't fix anything, but makes it work the way it was intended.
    It also makes scan-build happier.

    Broken by fd4360e30b695e596a5081a6080152188a12852a

M	src/doveadm/doveadm-mail-batch.c

2021-09-22 19:34:32 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d10bc56592)

    mdbox: Add assert to help static analyzers

    mdbox_sync_begin() can return 0 with sync_ctx=NULL, but not with the 
    parameters given here.

M	src/lib-storage/index/dbox-multi/mdbox-save.c

2021-09-22 19:02:24 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (67c96d89f3)

    lib-smtp: smtp_client_transaction_get_state_name() - Fix return value

    Only the "new" state was returned correctly, while everything else was 
    wrong. This didn't really cause problems, because it was used only by 
    imaptest.

M	src/lib-smtp/smtp-client-transaction.c
M	src/lib-smtp/smtp-client-transaction.h

2021-09-22 18:46:39 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (37ab021b41)

    lib: Ignore COMPILE_ERROR_IF_TRUE() with --enable-static-checker


M	src/lib/macros.h

2021-09-28 01:24:24 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b178d0792b)

    lib: container_of() - Always return NULL if input pointer is NULL


M	src/lib/macros.h

2021-09-22 18:40:11 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (71d3f9a4c0)

    lib: container_of() - Avoid uintptr_t

    Using uintptr_t confused Coverity, but char* works fine.

M	src/lib/macros.h

2021-09-29 00:21:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e47c4a3ff7)

    indexer: Abort requests if indexer-worker disconnects unexpectedly


M	src/indexer/worker-connection.c

2021-04-19 21:43:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1e14dd0f49)

    lib-storage: Add reason_code=mail:header_fields


M	src/lib-storage/index/index-mail-headers.c

2021-04-19 21:38:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (034597d2fe)

    lib-storage: Add more specific mail:* reason_codes in when prefetching

    Added:
    * mail:attachment_keywords
    * mail:date
    * mail:snippet
    * mail:mime_parts
    * mail:imap_envelope
    * mail:imap_bodystructure

M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mail.h

2021-03-11 23:38:01 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (88c2ee58f1)

    fts: Add reason_code=fts:index and fts:lookup

    Note that fts:index won't be used for email opening events, because the 
    emails are already opened by the indexer precache searching code due to 
    wanted_fields.

M	src/plugins/fts/fts-search.c
M	src/plugins/fts/fts-storage.c

2021-09-09 16:45:23 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1279e1bd00)

    lib-storage: Add reason_code=mailbox:*

    Added:
    * mailbox:create
    * mailbox:update
    * mailbox:delete
    * mailbox:rename
    * mailbox:subscribe
    * mailbox:unsubscribe
    * mailbox:attributes_changed

M	src/lib-storage/mail-storage.c

2021-03-17 15:15:00 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (87cd6570a1)

    lib-storage: Add reason_code=mailbox:search


M	src/lib-storage/index/index-search.c

2021-03-17 14:49:24 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (858da66efb)

    lib-storage: Add reason_code=mailbox:thread

    This is split into a few different locations in the code.

M	src/lib-storage/index/index-thread-finish.c
M	src/lib-storage/index/index-thread.c

2021-03-17 17:48:57 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (eedf4a3f22)

    lib-storage: Add reason_code=mailbox:vsize*

     * mailbox:vsize - mailbox vsize is asked
    * mailbox:vsize_update - mailbox vsize is updated (append/expunge)

M	src/lib-storage/index/index-mailbox-size.c

2021-03-17 17:48:33 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d4b3fcee59)

    lib-storage: Add reason_code=mailbox:sort


M	src/lib-storage/index/index-sort.c

2021-03-11 19:43:22 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ce517f8323)

    lib-storage: Add reason_code=mail:*

     * mail:virtual_size
    * mail:physical_size
    * mail:snippet
    * mail:prefetch
    * mail:mime_parts
    * mail:date
    * mail:received_date
    * mail:save_date
    * mail:storage_id
    * mail:pop3_uidl
    * mail:pop3_order
    * mail:guid
    * mail:refcount
    * mail:refcount_id

M	src/lib-storage/index/index-mail.c
M	src/lib-storage/mail.c

2021-03-11 19:07:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (962efef5f7)

    lib-storage: Remove mailbox_set_reason()

    Event reason_codes should be used instead. Keep the "Mailbox opened" debug
    message mainly because it's often used in CI tests.

M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mail-storage.h

2021-03-11 19:06:00 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (f1db5fbfb3)

    global: Remove mailbox_set_reason() calls

    These ones that are left are all rather unnecessary.

M	src/lib-imap-storage/imap-metadata.c
M	src/lib-imap-storage/imap-msgpart-url.c
M	src/lib-imap-urlauth/imap-urlauth-backend.c
M	src/lib-lda/mail-deliver.c
M	src/lib-storage/mail-storage.c
M	src/lmtp/lmtp-local.c
M	src/plugins/quota/quota-status.c
M	src/plugins/virtual/virtual-storage.c

2021-03-17 17:40:46 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d2ab26be60)

    pop3: Add reason_code=pop3:cmd_<command name> to events


M	src/pop3/pop3-client.c

2021-03-11 19:04:36 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (641d0bd3bd)

    pop3: Replace mailbox_set_reason() with reason_code=pop3:initialize


M	src/pop3/main.c
M	src/pop3/pop3-client.c

2021-03-11 17:29:59 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (bf1b124e0d)

    virtual: Replace mailbox_set_reason() with reason_code=virtual:config_read


M	src/plugins/virtual/virtual-config.c

2021-03-11 17:27:54 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d31e44e66c)

    trash: Replace mailbox_set_reason() with reason_code=trash:clean


M	src/plugins/trash/trash-plugin.c

2021-03-09 16:49:12 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (459f9eeeac)

    quota: Replace mailbox_set_reason() with reason_code=quota:recalculate and
    quota:count


M	src/plugins/quota/quota-count.c
M	src/plugins/quota/quota-dict.c
M	src/plugins/quota/quota-maildir.c

2021-03-11 17:22:31 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b0d8db1bb3)

    pop3-migration: Replace mailbox_set_reason() with
    reason_code=pop3_migration:uidl_sync


M	src/plugins/pop3-migration/pop3-migration-plugin.c

2021-03-11 17:03:49 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (d2af1066c4)

    lazy_expunge: Replace mailbox_set_reason() with
    reason_code=lazy_expunge:expunge


M	src/plugins/lazy-expunge/lazy-expunge-plugin.c

2021-03-17 18:23:11 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (bc85909b45)

    lazy-expunge: Split off lazy_expunge_mail_expunge_move()


M	src/plugins/lazy-expunge/lazy-expunge-plugin.c

2021-03-11 16:56:32 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (2ec30d083b)

    lib-storage: Replace mailbox_set_reason() with
    reason_code=storage:autoexpunge and storage:mailbox_list_rebuild


M	src/lib-storage/list/mail-storage-list-index-rebuild.c
M	src/lib-storage/mail-autoexpunge.c

2021-03-11 16:53:35 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a20d06d4b3)

    mdbox: Replace mailbox_set_reason() with reason_code=mdbox:rebuild


M	src/lib-storage/index/dbox-multi/mdbox-storage-rebuild.c

2021-03-16 19:02:06 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1a30dc1b43)

    mdbox: Split off mdbox_storage_rebuild_scan_prepare()


M	src/lib-storage/index/dbox-multi/mdbox-storage-rebuild.c

2021-03-11 15:46:11 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e3dc046996)

    indexer: Replace mailbox_set_reason() with reason_code=indexer:index_mailbox


M	src/indexer/master-connection.c

2021-03-17 17:28:03 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (bb1df67719)

    imap: Add reason_code=imap:fetch_*

    The main reason for these is to allow understanding why mails are being 
    opened. The possibilities:

     * imap:fetch_body
    * imap:fetch_header
    * imap:fetch_header_fields
    * imap:fetch_bodystructure
    * imap:fetch_size

M	src/imap/cmd-fetch.c
M	src/imap/imap-fetch-body.c
M	src/imap/imap-fetch.h

2021-03-11 15:44:47 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b41063291e)

    imap: Remove mailbox_set_reason() calls

    They are now unnecessary because of the new reason_code field.

M	src/imap/cmd-create.c
M	src/imap/cmd-delete.c
M	src/imap/cmd-getmetadata.c
M	src/imap/cmd-notify.c
M	src/imap/cmd-rename.c
M	src/imap/cmd-resetkey.c
M	src/imap/cmd-select.c
M	src/imap/cmd-setmetadata.c
M	src/imap/cmd-subscribe.c
M	src/imap/imap-commands-util.c
M	src/imap/imap-notify.c
M	src/imap/imap-state.c
M	src/imap/imap-status.c

2021-03-11 15:44:10 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (61685f7b7a)

    imap: Add reason_code=imap:unhibernate for events during unhibernation.


M	src/imap/imap-master-client.c

2021-03-11 15:39:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (4eb305cccc)

    imap: Add reason_code=imap:notify_update for events during NOTIFY updates


M	src/imap/imap-notify.c

2021-03-09 16:37:18 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ad5ef653eb)

    imap: Add and use client_command_context.global_event

    This way all the (potentially large) IMAP command parameters won't be 
    included in all the events. This change might be reverted in the future if
    the performance worries go away.

    The global event also contains reason_code=imap:cmd_<command name> field.

M	src/imap/cmd-append.c
M	src/imap/cmd-create.c
M	src/imap/cmd-delete.c
M	src/imap/cmd-getmetadata.c
M	src/imap/cmd-rename.c
M	src/imap/cmd-resetkey.c
M	src/imap/cmd-select.c
M	src/imap/cmd-setmetadata.c
M	src/imap/cmd-status.c
M	src/imap/cmd-subscribe.c
M	src/imap/imap-client.c
M	src/imap/imap-client.h
M	src/imap/imap-commands-util.c
M	src/imap/imap-commands.c

2021-03-11 15:26:56 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (cfc7b74425)

    doveadm: Remove mailbox_set_reason() calls

    They are now unnecessary because of the new reason_code field.

M	src/doveadm/doveadm-mail-copymove.c
M	src/doveadm/doveadm-mail-import.c
M	src/doveadm/doveadm-mail-index.c
M	src/doveadm/doveadm-mail-iter.c
M	src/doveadm/doveadm-mail-mailbox-metadata.c
M	src/doveadm/doveadm-mail-mailbox-status.c
M	src/doveadm/doveadm-mail-mailbox.c
M	src/doveadm/doveadm-mail-save.c
M	src/doveadm/doveadm-mail.c

2021-03-11 15:26:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (fd4360e30b)

    doveadm: Add reason_code=doveadm:cmd_<command name> to events


M	src/doveadm/doveadm-mail-batch.c
M	src/doveadm/doveadm-mail.c

2021-04-20 00:05:23 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (82f0d7bf81)

    dsync: ioloop context shouldn't deactivate after ioloop has run

    Normally that is wanted, but dsync reuses the same ioloop as the parent 
    doveadm connection, so after the inner io_loop_run() it's still running in
    the doveadm connection's io callback.

    Without this all the global events will be popped out, and the following 
    global event change commit will cause crashes.

M	src/doveadm/doveadm-dsync.c

2021-04-20 00:28:02 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a9ffa98ac7)

    doveadm copy: Don't permanently activate source user's ioloop


M	src/doveadm/doveadm-mail-copymove.c

2021-04-20 00:24:39 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (23c1983be1)

    doveadm import: Don't permanently activate source user's ioloop

    After the source user is initialized, the original user's ioloop should be 
    activated back.

M	src/doveadm/doveadm-mail-import.c

2021-03-17 18:48:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (19779828ea)

    submission: Add reason_code=submission:cmd_<name>


M	src/submission-login/client.c
M	src/submission/main.c

2021-03-17 18:48:24 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ebd660c594)

    lmtp: Add reason_code=lmtp:cmd_<name>


M	src/lmtp/main.c

2021-03-17 18:44:09 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (750f14dae0)

    lib-smtp: Add reason_code=<reason_code_module>:cmd_*

    This requires caller to set smtp_server_settings.reason_code_module. For now
    only cmd_mail, cmd_rcpt and cmd_data are implemented. The other commands are
    likely not very useful.

M	src/lib-smtp/smtp-server-cmd-data.c
M	src/lib-smtp/smtp-server-cmd-mail.c
M	src/lib-smtp/smtp-server-cmd-rcpt.c
M	src/lib-smtp/smtp-server-connection.c
M	src/lib-smtp/smtp-server-private.h
M	src/lib-smtp/smtp-server.c
M	src/lib-smtp/smtp-server.h

2021-04-22 20:27:45 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (7b6e14ce5e)

    lib-http: http-client-request - Preserve global events' reason_code in
    request events

    Since HTTP requests are asynchronous, it's possible that the global events 
    go away before the HTTP request is finished. This way the reason_code will 
    be preserved in http_request_finished event.

M	src/lib-http/http-client-request.c

2021-03-11 17:54:18 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (fbcb1dafbf)

    lib: Add event_reason_code() for building reason codes easily


M	src/lib/lib-event.c
M	src/lib/lib-event.h
M	src/lib/test-lib-event.c
M	src/lib/test-lib.inc

2021-03-09 16:45:20 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c0a3b73732)

    lib: Add event_reason_begin/end() API

    This can be used to easily add reason_code to all events being emitted 
    within the begin..end calls. The reasons can also be nested. For example:

    reason = event_reason_begin("reason1");
    // ... reason2 = event_reason_begin("reason2");
    // .. event_reason_end(&reason2); event_reason_end(&reason);

    This results in having reason_code=["reason1", "reason2"] for all events 
    emitted while reason2 exists.

M	src/lib/lib-event.c
M	src/lib/lib-event.h

2021-04-21 16:55:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2bba7f1f34)

    lib: event_pop_global() - Assert-crash if trying to pop ioloop context's
    global root event

    This makes it easier to debug bugs.

M	src/lib/ioloop-private.h
M	src/lib/ioloop.c
M	src/lib/lib-event.c

2021-03-11 02:19:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c633d08bf2)

    lib: Push/pop global event stack automatically when ioloop contexts are
    switched


M	src/lib/ioloop-private.h
M	src/lib/ioloop.c
M	src/lib/lib-event.h
M	src/lib/test-ioloop.c

2021-04-21 17:11:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (75285a3169)

    lib-storage: mail_storage_service_next*() - On failure don't leave user's io
    context activated


M	src/lib-storage/mail-storage-service.c

2021-03-11 02:18:55 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (340e961cfe)

    lib-storage: Remove global event stack tracking

    This will be implemented by ioloop contexts directly in the next commit.

M	src/lib-storage/mail-storage-service.c

2021-03-09 16:33:15 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (c822238604)

    lib: Fix global events to actually work

    Also add comments to clarify how exactly it works.

M	src/lib/event-filter.c
M	src/lib/lib-event.c
M	src/lib/lib-event.h
M	src/lib/test-event-filter.c

2021-04-20 00:08:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (16fca42dec)

    lib: event_push_global() - Assert that event is not NULL


M	src/lib/lib-event.c

2021-09-09 13:46:24 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e2995d85c2)

    lib-master: Fix sending events recursively

    The event sending itself may recursively trigger more events (e.g. 
    data_stack_grow). The previous BEGINs must have been flushed by that time or
    the recursive events might be pointing to event IDs that haven't even been
    sent to the stats process yet.

    Fixes: stats: Error: Client sent invalid input for UPDATE: Unknown event ID

M	src/lib-master/stats-client.c

2021-03-09 16:29:49 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (9d93a24824)

    lib-master, stats: Send global events to stats process


M	src/lib-master/stats-client.c
M	src/lib-master/test-event-stats.c
M	src/stats/client-writer.c
M	src/stats/test-client-writer.c

2021-03-19 13:13:45 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (0a57bd650e)

    stats: Support group_by for string lists


M	src/stats/stats-metrics.c

2021-01-27 13:10:07 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (5f8775fc40)

    stats: Support exporting event string lists


M	src/stats/event-exporter-fmt-json.c
M	src/stats/event-exporter-fmt-tab-text.c

2021-03-19 13:02:54 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (775ddf19ed)

    stats: Split off stats_metric_get_sub_metric()


M	src/stats/stats-metrics.c

2021-03-19 13:05:35 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (a1623b5e44)

    stats: Rename stats_metric_get_sub_metric() to
    stats_metric_find_sub_metric()


M	src/stats/stats-metrics.c

2021-03-19 12:59:53 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (81d50807bf)

    stats: Split off stats_metric_group_by_value_label()


M	src/stats/stats-metrics.c

2021-03-19 12:52:13 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (add670d598)

    stats: stats_metric_group_by_*() - Add _r suffix to returned value parameter


M	src/stats/stats-metrics.c

2020-12-15 09:17:57 +0200 Aki Tuomi <aki.tuomi@open-xchange.com> (4f752d381c)

    lib: lib-event - Add support for string lists

    Provide API to create string lists. These are particularly useful if you
    need to provide list of causes for an event, such as why some mail was
    opened.

M	src/lib/Makefile.am
M	src/lib/event-filter.c
M	src/lib/lib-event.c
M	src/lib/lib-event.h
M	src/lib/test-event-filter.c
M	src/lib/test-event-flatten.c
A	src/lib/test-lib-event.c
M	src/lib/test-lib.inc
M	src/stats/event-exporter-fmt-json.c
M	src/stats/event-exporter-fmt-tab-text.c
M	src/stats/stats-metrics.c

2021-08-23 17:21:58 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9a4d33f893)

    lib: test-event-filter - Improve "override parent fields" test


M	src/lib/test-event-filter.c

2021-08-23 17:15:47 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e670cb1468)

    lib: test-event-filter - Fix parent/child events to actually be parent/child


M	src/lib/test-event-filter.c

2021-03-16 19:22:25 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1411aaf4a4)

    lib: Split off event_import_arg()


M	src/lib/lib-event.c

2021-03-16 19:19:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (bb602382b9)

    lib: Split off event_import_field()


M	src/lib/lib-event.c

2021-09-24 18:21:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a12796fd66)

    lib-index: Allow ignoring index corruption checks with --enable-devel-checks

    If DEBUG_IGNORE_INDEX_CORRUPTION environment is set, don't check if index
    contains internal corruption. This is useful for CI tests that intentionally
    test corrupted indexes.

M	src/lib-index/mail-index-sync-update.c

2021-09-28 00:28:35 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (c92afe67a1)

    lib-http: http-server: Add request events

    Adds http_server_request_started and http_server_request_finished.

M	src/lib-http/http-server-connection.c
M	src/lib-http/http-server-private.h
M	src/lib-http/http-server-request.c

2021-08-26 13:13:55 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (12229f5e61)

    lib-http: http-server-request - Add request_id and status_code fields to
    event


M	src/lib-http/http-server-request.c
M	src/lib-http/http-server-response.c

2021-09-28 15:35:21 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (e8d9838485)

    stats: Use duplicated metric settings in stats_metrics_add_dynamic().


M	src/stats/stats-metrics.c

2021-09-15 14:44:42 +0200 Markus Valentin <markus.valentin@open-xchange.com> (b04cb5ea03)

    imapc: Add MAIL_STORAGE_CLASS_FLAG_SECONDARY_INDEX storage class flag

    Add SECONDARY_INDEX storage class flag to enable storing shared private 
    indexes in obox user root bundle.

M	src/lib-storage/index/imapc/imapc-storage.c

2021-09-24 17:33:38 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e399436c15)

    lib-storage: mail_get_binary_stream() - Add comment about having to unref
    returned istream


M	src/lib-storage/mail-storage.h

2021-09-22 15:58:55 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1ce928c75f)

    lib: test-cpu-limit - Remove dead code

    No longer needed after 6d902507c24fca4f64e3e9bf7d79ae5a48281cd8

M	src/lib/test-cpu-limit.c

2021-09-27 11:49:05 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (0a70b02bbb)

    lib: test-strfuncs - Avoid testing p_strndup() with overlong max_chars
    parameter

    This ended up in memchr() call with n=SIZE_MAX-1, which sometimes doesn't 
    work right with old glibc versions.

    Fixes: Panic: Trying to allocate 18446744073709551615 bytes

M	src/lib/test-strfuncs.c

2021-09-08 10:39:36 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (211040d836)

    lib-mail: Add test for empty header value


M	src/lib-mail/test-message-header-parser.c

2021-09-02 17:10:11 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (d0e0b22b6b)

    lib-mail: Limit header length to 1000 bytes


M	src/lib-mail/message-header-parser.c
M	src/lib-mail/test-message-header-parser.c

2021-09-02 17:12:55 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (44c43133a4)

    lib-mail: If message header has no colon, store it as value only

    If the header is missing :, it is not valid header. Storing it as value only
    ensures it will be kept by mbox rewrite, but will not be processed as a
    header.

M	src/lib-mail/message-header-parser.c
M	src/lib-mail/test-message-header-parser.c
M	src/plugins/pop3-migration/pop3-migration-plugin.c

2021-09-02 16:46:19 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (ac65213384)

    lib-mail: test-message-header-parser - Add NAME10, 100, 1000 macros for
    testing


M	src/lib-mail/test-message-header-parser.c

2021-09-07 14:37:34 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (0009fd1edf)

    lib: Add i_memspn() and i_memcspn()

    Binary data safe variants of strspn() and strcspn()

M	src/lib/strfuncs.c
M	src/lib/strfuncs.h
M	src/lib/test-strfuncs.c

2021-09-16 13:32:37 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8af2bd8640)

    virtual: Log a debug message why backend mailbox has changed


M	src/plugins/virtual/virtual-sync.c

2021-09-24 10:39:43 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (801405d49f)

    lib-storage: mail-duplicate - Restructure mail_duplicate_read_db_file() to
    make sure fd is closed.

    Found by Coverity.

M	src/lib-storage/mail-duplicate.c

2021-09-24 10:22:28 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (99d129cd50)

    lib-storage: mail-duplicate - Fix segfault occurring upon failure to lock
    and open DB file.

    Found by Coverity.

M	src/lib-storage/mail-duplicate.c

2021-08-18 16:54:00 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (26284cf6f7)

    indexer-worker: Fix event leak on error handling


M	src/indexer/master-connection.c

2021-07-13 04:15:14 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (2d32ee8b54)

    lib-storage: mail-duplicate - Implement separate error code for deadlock.


M	src/lib-storage/mail-duplicate.c
M	src/lib-storage/mail-duplicate.h

2021-09-16 01:49:57 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (dcee43b54c)

    lib-storage: mail-duplicate - Update records from duplicate DB file after
    acquirement of per-ID lock.

    The process previously holding the per-ID lock may have updated the DB.

M	src/lib-storage/mail-duplicate.c

2021-09-17 11:11:21 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (a27a97f49d)

    lib-storage: mail-duplicate - Move acquirement of dotlock for DB file into
    mail_duplicate_read().


M	src/lib-storage/mail-duplicate.c

2021-09-20 11:58:12 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (9cb56c3b28)

    lib-storage: mail-duplicate - Implement per-ID locking.


M	src/lib-storage/mail-duplicate.c
M	src/lib-storage/mail-duplicate.h

2021-09-17 11:16:39 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (9bd8fff3b0)

    lib-storage: mail-duplicate - Allow calling mail_duplicate_read() more than
    once in a transaction.


M	src/lib-storage/mail-duplicate.c

2021-07-13 23:22:52 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (b3d183d81d)

    lib-storage: mail-duplicate - Record an entry for both checked and marked
    IDs.

    Still only write the marked IDs to the file. The in-memory record is needed
    for the locking introduced in a later commit.

M	src/lib-storage/mail-duplicate.c

2021-07-13 05:03:02 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (711f05f3d1)

    lib-storage: mail-duplicate - Add debug messages for transaction.


M	src/lib-storage/mail-duplicate.c

2021-07-13 05:07:39 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (4809e7e1cd)

    lib-storage: mail-duplicate - Add debug messages for database.


M	src/lib-storage/mail-duplicate.c

2021-07-13 04:40:24 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (70af5522c6)

    lib-storage: mail-duplicate - Add event to transaction object.


M	src/lib-storage/mail-duplicate.c

2021-07-13 04:53:11 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (4fe7f887a6)

    lib-storage: mail-duplicate - Add event to database object.


M	src/lib-storage/mail-duplicate.c

2021-06-08 03:51:10 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (63553ff976)

    lib-storage: mail-duplicate - Restructure API to make it transaction-based.


M	src/lib-storage/mail-duplicate.c
M	src/lib-storage/mail-duplicate.h

2021-07-13 04:03:42 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (f786488b23)

    lib-storage: mail-duplicate - Change mail_duplicate_check() return type from
    bool to enum.


M	src/lib-storage/mail-duplicate.c
M	src/lib-storage/mail-duplicate.h

2021-09-17 11:04:55 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (90400db2d6)

    lib-storage: Reformat mail-duplicate.c.


M	src/lib-storage/mail-duplicate.c

2021-08-07 15:43:35 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (8bfdede141)

    lib-storage: mail-user - Add mail_user_get_volatile_dir().


M	src/lib-storage/mail-user.c
M	src/lib-storage/mail-user.h

2021-09-20 02:45:23 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (4c1cf82d61)

    lib: file-lock - Adjust API to allow EDEADLK to be used by application.

    It always caused a Dovecot panic before when returned from kernel.

M	src/lib/file-lock.c
M	src/lib/file-lock.h

2021-09-19 13:09:29 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (083439ed73)

    lib: file-lock - Rework API to make it extensible.


M	src/doveadm/dsync/dsync-brain.c
M	src/lib-dict/dict-file.c
M	src/lib-fs/fs-posix.c
M	src/lib-index/mail-index-lock.c
M	src/lib-index/mail-index-strmap.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib-storage/mail-storage.c
M	src/lib-storage/mail-user.c
M	src/lib-storage/mailbox-list.c
M	src/lib/file-create-locked.c
M	src/lib/file-create-locked.h
M	src/lib/file-lock.c
M	src/lib/file-lock.h
M	src/lib/test-file-create-locked.c
M	src/plugins/fts-squat/squat-trie.c
M	src/plugins/fts-squat/squat-uidlist.c

2021-09-20 02:39:08 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (de5e12a160)

    lib: file-lock - Rename file_{wait,try}_lock_error() to
    file_{wait,try}_lock().


M	src/lib-dict/dict-file.c
M	src/lib-fs/fs-posix.c
M	src/lib-index/mail-index-lock.c
M	src/lib-index/mail-index-strmap.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/lib/file-create-locked.c
M	src/lib/file-lock.c
M	src/lib/file-lock.h
M	src/plugins/fts-squat/squat-trie.c
M	src/plugins/fts-squat/squat-uidlist.c

2021-09-20 02:29:55 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (13b9181e32)

    lib: file-lock - Remove file_{wait,try}_lock().


M	src/lib/file-lock.c
M	src/lib/file-lock.h

2021-09-20 02:26:46 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (4dbae0e6c1)

    global: Avoid use of file_{wait,try}_lock().

    Use the file_{wait,try}_lock_error() variants instead.

M	src/lib-dict/dict-file.c
M	src/lib-fs/fs-posix.c
M	src/lib-index/mail-index-lock.c
M	src/lib-index/mail-index-strmap.c
M	src/lib-storage/index/dbox-common/dbox-file.c
M	src/plugins/fts-squat/squat-trie.c
M	src/plugins/fts-squat/squat-uidlist.c

2021-09-22 17:36:27 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (ed1264368a)

    lib-http: test-http-client-errors - Allow more relaxed timeouts for connect
    retry tests

    With max_connect_attempts=3 the connects come at (0ms, 100ms, 300ms). Before
    the 3rd attempt a timeout at 250ms must have triggered, so there was only
    50ms time for it to trigger. This wasn't always enough when running with
    valgrind on an overloaded system. Solve this by increasing 
    max_connect_attempts=4 so the 4th attempt comes at 700ms, giving the timeout
    450ms to trigger.

M	src/lib-http/test-http-client-errors.c

2021-09-22 12:14:08 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4f605823a4)

    lib: Add most data_stack_grow event fields before checking if event is
    wanted

    This allows using e.g. "event=data_stack_grow and alloc_size > 32768" as an
    event filter.

M	src/lib/data-stack.c

2021-09-21 18:27:29 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (18e1eaf61e)

    config: Add data stack frame


M	src/config/config-request.c

2021-09-21 18:26:53 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9055758361)

    doveconf: Avoid unnecessary data stack use when writing output


M	src/config/doveconf.c

2021-09-21 18:21:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (dab478e5f4)

    master: Create each service in its own data stack frame


M	src/master/service.c

2021-09-21 17:52:15 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e873c9aeae)

    doveadm: Call each run() in its own data stack frame


M	src/doveadm/doveadm-mail.c

2021-09-21 17:14:44 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (7ac69350e3)

    dsync: Add data stack frames to mailbox loops


M	src/doveadm/dsync/dsync-brain-mailbox-tree.c

2021-09-21 17:10:56 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1b4f8cf6a2)

    dsync: Split off dsync_brain_recv_mailbox_tree_add()


M	src/doveadm/dsync/dsync-brain-mailbox-tree.c

2021-09-21 17:50:32 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d83e4f5fd2)

    acl: Code cleanup - Remove pointless while-loop


M	src/plugins/acl/acl-shared-storage.c

2021-09-21 17:03:45 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f78c00f1f3)

    acl: acllist rebuild - Move data stack frame to caller's loop


M	src/plugins/acl/acl-backend-vfile-acllist.c

2021-09-21 16:14:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e05b6df33a)

    acl: Add data stack frame when iterating mailboxes

    Avoids wasting memory when there are a lot of mailboxes.

M	src/plugins/acl/acl-mailbox-list.c

2021-09-21 17:51:15 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5694b04f70)

    lib-storage: mail_user_unref() - Add data stack frame

    The deinit code paths can sometimes eat up quite a lot of data stack.

M	src/lib-storage/mail-user.c

2021-09-22 12:49:46 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (ef84b4e2f6)

    lib-storage: mailbox_create() - Add data stack frames


M	src/lib-storage/mail-storage.c

2021-09-22 12:48:18 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (0b1dff0b1d)

    lib-storage: Add data stack frames to [service] user initialization

    Initialization steps can use a lot of data stack, so try to free it at 
    several checkpoints.

M	src/lib-storage/mail-storage-service.c

2021-09-21 17:49:34 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (1682263f04)

    lib-storage: Add data stack frame when iterating mailboxes to build GUID
    cache


M	src/lib-storage/mailbox-guid-cache.c

2021-09-21 17:48:33 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8c56e2c025)

    lib-storage: mailbox_verify_*name() - Add data stack frames

    This function can eat up quite a lot of data stack.

M	src/lib-storage/mail-storage.c

2021-09-21 17:47:41 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4908b7c139)

    lib-storage: str_contains_special_use() - Add data stack frame

    This function is called in a loop by namespace_find_special_use().

M	src/lib-storage/mail-storage.c

2021-09-21 16:58:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (e22519d85d)

    lib-storage: List index rebuild - Add data stack frames


M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2021-09-21 16:57:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (99b9890db0)

    lib-storage: List index rebuild - Split off
    mail_storage_list_index_find_indexed_mailbox()


M	src/lib-storage/list/mail-storage-list-index-rebuild.c

2021-09-21 16:37:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8b7438a3f9)

    lib-storage: Don't use data stack for mailbox list index header update

    There can be a lot of mailboxes, causing excessive data stack usage.

M	src/lib-storage/list/mailbox-list-index-sync.c

2021-09-21 16:42:39 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (bb75bc110f)

    lib-index: Don't use data stack for building index header update buffer

    The header update can be large (e.g. dovecot.list.index with many mailboxes)
    and grow data stack unnecessarily.

M	src/lib-index/mail-index-transaction-export.c

2021-09-21 17:51:50 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (742053d520)

    lib: module_dir_deinit() - Call each deinit() in its own data stack frame


M	src/lib/module-dir.c

2021-09-21 16:15:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f13526d432)

    lib: test-data-stack - Make sure data stack memory usage doesn't leak


M	src/lib/test-data-stack.c

2021-09-21 13:38:27 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (6d902507c2)

    lib: test-cpu-limit - Remove checking for CPU usage upper limit

    These tests keep randomly failing on loaded systems. It's more important 
    anyway to check that the minimum CPU usage is high enough than it is to 
    check that CPU usage isn't too high.

M	src/lib/test-cpu-limit.c

2021-09-17 16:11:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (ba465f3a04)

    lib: Optimize str_tabescape()


M	src/lib/strescape.c

2021-09-17 16:10:12 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (bcfc14fae3)

    lib: Optimize p_strsplit_tabescaped()


M	src/lib/strescape.c

2021-09-17 16:06:17 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (5615fa62db)

    lib: Optimize t_strsplit_tabescaped()


M	src/lib/strescape.c

2021-09-17 16:04:00 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (09b2f400d2)

    lib: Optimize t_strsplit_tabescaped_inplace()


M	src/lib/strescape.c

2021-09-17 16:02:10 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a6b1c0114c)

    lib: Optimize t_strdup*()

    Avoid zeroing the allocated data stack memory just before it's going to be 
    filled with the duplicated string anyway.

M	src/lib/strfuncs.c

2021-03-12 01:41:35 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (6345e8f021)

    lib: Optimize t_str_tabunescape()


M	src/lib/strescape.c

2021-03-12 01:38:13 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (cd63b1eeea)

    lib: Optimize str_tabunescape()


M	src/lib/strescape.c

2021-03-12 01:27:30 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (ea636c55e4)

    lib: Optimize str_append_tabescaped()

    Avoid calling strlen() and replace for-loop with strcspn().

M	src/lib/strescape.c

2021-03-12 01:23:04 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (1abeccbeca)

    lib: Optimize str_append_tabescaped_n()


M	src/lib/strescape.c
M	src/lib/test-strescape.c

2021-03-12 01:19:38 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (de0871dedb)

    lib: Optimize p_strndup()


M	src/lib/strfuncs.c
M	src/lib/test-lib.inc
M	src/lib/test-strfuncs.c

2021-02-11 02:56:11 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (7371c1033e)

    lib: Optimize buffer_append() and buffer_append_c()


M	src/lib/buffer.c

2021-02-11 02:44:34 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (34d72ca7f2)

    lib: buffer_create_dynamic_max() - Fix max_size handling

    Never allocate buffer larger than its max_size, since it's just wasted 
    memory. Also clarify that the allocation can actually go up to max_size+1 
    because of str_c() NUL byte reservation.

M	src/lib/buffer.c
M	src/lib/buffer.h

2021-02-11 02:30:12 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (53adac82ea)

    lib: buffer_append_zero() - Avoid unnecessary memset()


M	src/lib/buffer.c

2021-02-11 02:21:30 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (93499cd0fd)

    lib: buffer - Add writable_size to simplify checking if buffer needs to be
    grown


M	src/lib/buffer.c
M	src/lib/buffer.h

2021-09-15 14:14:47 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (4a2d3e3b30)

    lib: buffer - Replace casts with container_of()


M	src/lib/buffer.c

2021-08-12 10:02:55 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (c513b9a13d)

    lib-storage: Add data stack frame for mailbox_copy and mailbox_move


M	src/lib-storage/mail-storage.c

2021-08-12 09:58:57 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (d1ef929697)

    lib-storage: Add data stack frame for mailbox_rename


M	src/lib-storage/mail-storage.c

2021-08-12 09:58:41 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (0e6e64c6c0)

    lib-storage: Add data stack frame for mailbox_delete


M	src/lib-storage/mail-storage.c

2021-09-16 19:32:02 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (095089cd8f)

    acl: acl_backend_vfile_has_acl() - Simplify code


M	src/plugins/acl/acl-backend-vfile.c

2021-09-16 19:13:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4f765652f0)

    acl: acl_backend_vfile_has_acl() - Open mailbox to check if it exists

    This is a bit more expensive than the previous behavior, but it's done only 
    when creating or renaming mailboxes which are pretty rare operations.

    This fixes copying parent ACLs with obox when the parent mailbox doesn't 
    exist in local metacache.

M	src/plugins/acl/acl-backend-vfile.c
M	src/plugins/acl/acl-backend-vfile.h

2021-09-16 19:26:07 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (3533994fd9)

    acl: acl_backend_vfile_has_acl() - Avoid unnecessary local ACL file check

    The local ACL file can't exist if its mailbox doesn't exist.

M	src/plugins/acl/acl-backend-vfile.c

2021-09-16 19:22:41 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (0f8fb686c0)

    acl: acl_backend_vfile_has_acl() - Check first if global ACL exists

    Global ACL can be checked more efficiently. If it exists, there's no need 
    anymore to access the local mailbox ro ACL files.

M	src/plugins/acl/acl-backend-vfile.c

2021-09-16 18:05:04 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f63bda4db5)

    acl: Consistently determine whether ACL files are in control or mailbox
    directory

    Add mail_storage_get_acl_list_path_type() that is used for it. This fixes 
    ACL inheritance with obox.

M	src/plugins/acl/acl-backend-vfile-acllist.c
M	src/plugins/acl/acl-backend-vfile.c
M	src/plugins/acl/acl-backend-vfile.h

2021-09-06 00:49:06 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (e1cbc8f64d)

    lib-lua: Add function for restricting global variable definition

    Add "dovecot.restrict_global_variables()" with a boolean argument to
    mitigate unintended variable assignments and to prevent unnecessarily
    populating global namespace.

    If enabled, variables can only be defined local to the script but global 
    functions are still allowed.

M	src/lib-lua/dlua-dovecot.c

2021-09-07 15:03:37 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (460edc6b64)

    lib-lua: Use rawget to check presence of functions in scripts

    With the restricted global variables in next commit, checking for undeclared
    functions results in error. Use rawget to avoid metamethods.

M	src/lib-lua/dlua-script.c

2021-09-17 12:26:35 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (dc21a1d7e8)

    lib-lua: Build test-dict-lua only with Lua 5.3+

    Fixes building with Lua 5.1

M	src/lib-lua/Makefile.am

2021-09-14 10:33:50 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (85e65dd58a)

    lib-compression: bench-compress - Ensure we have both istream and ostream
    constructor

    After 6e5ae5ef0f0f31acd7bde0db53980a708c81eced we have read-only compression 
    mechanism, that leads to null pointer crash in bench-compress.

M	src/lib-compression/bench-compression.c

2021-09-16 20:12:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4ee8601abb)

    NEWS: Add news for 2.3.16


M	NEWS

2021-09-10 15:52:43 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9e3df2cddd)

    lib-lua: Add test-dict-lua


M	src/lib-lua/Makefile.am
A	src/lib-lua/test-dict-lua.c

2021-09-10 15:47:47 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (39f2166fac)

    dict-lua: Change dict:lookup() to actually return nil if key isn't found

    It was previously returning an empty table, although the comment said it 
    should have returned nil.

M	src/lib-dict/dict-lua.c

2021-09-10 12:49:50 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a564b607de)

    lib-dict: dict-lua - Add set_timestamp()


M	src/lib-dict/dict-txn-lua.c

2021-09-01 19:33:49 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (53eeb81a6d)

    lib-dict: dict-lua - Add unset()


M	src/lib-dict/dict-txn-lua.c

2021-09-07 17:00:07 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (3740bc1679)

    indexer: Remove the concept of a "busy" connection

    All the connections are busy, since they are created for a new request and 
    they are disconnected when the request is done.

M	src/indexer/indexer.c
M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h
M	src/indexer/worker-pool.c
M	src/indexer/worker-pool.h

2021-09-07 16:56:16 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (2f8bdc9372)

    indexer: Handle more requests whenever indexer-worker connection closes

    Previously this was done only when worker process sent a "request finished" 
    notification. Crashing worker processes could have caused the queue to get 
    stuck until more requests were added to the queue.

M	src/indexer/indexer.c
M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h
M	src/indexer/worker-pool.c
M	src/indexer/worker-pool.h

2021-09-07 16:52:40 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (61ca1eb1b8)

    indexer: Disconnect from worker after each request

    service_count won't be tracked correctly otherwise.

M	src/indexer/worker-connection.c

2021-09-07 15:47:23 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9718957b84)

    indexer: Fix tracking indexer-worker's process_limit

    After recent changes, the process_limit was too often thought to be 1.

M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h
M	src/indexer/worker-pool.c

2021-08-31 12:14:15 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (4018f44337)

    indexer: Change status callback to take struct indexer_request parameter


M	src/indexer/indexer.c
M	src/indexer/indexer.h
M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h

2021-08-31 12:12:49 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b1c4f2b882)

    indexer: Don't free worker_connection too early

    There's no need for the status callback anymore to free the connection. It
    will be tracked automatically.

M	src/indexer/indexer.c
M	src/indexer/worker-connection.c
M	src/indexer/worker-connection.h
M	src/indexer/worker-pool.c
M	src/indexer/worker-pool.h

2021-08-31 12:08:32 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a15eb469aa)

    indexer: Use a separate indexer_queue_callback_t type for indexer-queue
    callback


M	src/indexer/indexer-queue.c
M	src/indexer/indexer-queue.h

2021-09-14 15:33:50 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (e7a3c48390)

    lib: Remove connect_finished_time field from connection event.


M	src/lib/connection.c

2021-09-10 19:00:09 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (da3bc6ea23)

    lib: ENUM_NEGATE() - Disable runtime sizeof() check with STATIC_CHECKER

    This is to avoid "Dangerous variable-length array (VLA) declaration" errors
    with clang 12 scan-build, which happen because scan-build keeps thinking
    that the enums can become larger than 2147483647.

M	src/lib/macros.h

2021-08-31 15:44:20 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (4826b08c47)

    doveadm: Flush data to server client asynchronously


M	src/doveadm/doveadm-print-server.c

2021-07-13 13:32:09 +0200 Markus Valentin <markus.valentin@open-xchange.com> (d89e8a5c3c)

    virtual: Add storage flag for secondary index


M	src/plugins/virtual/virtual-storage.c

2021-07-13 13:28:43 +0200 Markus Valentin <markus.valentin@open-xchange.com> (69ddbe6dd0)

    lib-storage: Add storage_class_flag for secondary index


M	src/lib-storage/mail-storage-private.h

2021-09-10 06:47:21 +0200 Bernhard M. Wiedemann <bwiedemann@suse.de> (00eba31f19)

    man: doveadm director flush - The parameter is -F, not -f


M	doc/man/doveadm-director.1.in

2021-09-08 09:53:12 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (30eecd1f82)

    doveadm: doveadm-stats - Allocate field_types

    field_types was function local variable that got used outside of function.
    Change to use datastack allocation instead to keep it valid after leaving
    function.

    Broken in e9a46e3a6df2edd6cb68a8fc04a5e8e4564a9d5e

M	src/doveadm/doveadm-stats.c

2021-08-31 12:48:38 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (601b5465dc)

    lib-storage: Move (un)deleting debug message to mailbox_mark_index_deleted


M	src/lib-storage/list/mail-storage-list-index-rebuild.c
M	src/lib-storage/mail-storage.c

2021-08-09 11:56:17 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (99efbc7f81)

    lib-storage: mailbox-list - Detect duplicate GUIDs

    This is only done for LAYOUT=INDEX.

M	src/lib-storage/list/mailbox-list-index.c

2021-08-19 17:10:31 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (f30403df4b)

    lib-storage: mailbox-list - Add duplicate pool for duplicate detection


M	src/lib-storage/list/mailbox-list-index.c

2021-08-16 14:38:47 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (196a5ed776)

    lib-storage: maildir - Use mail_storage_index_list_rebuild


M	src/lib-storage/index/maildir/maildir-storage.c
M	src/lib-storage/index/maildir/maildir-sync.c

2021-08-20 11:43:27 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (18afa46644)

    lib-storage: maildir - Allow creating existing folder when rebuilding list
    index


M	src/lib-storage/index/maildir/maildir-storage.c

2021-08-09 14:23:13 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (a92541c5b9)

    lib-storage: dbox - Use mailbox_list_index_rebuild


M	src/lib-storage/index/dbox-multi/mdbox-storage.c
M	src/lib-storage/index/dbox-multi/mdbox-sync.c
M	src/lib-storage/index/dbox-single/sdbox-storage.c
M	src/lib-storage/index/dbox-single/sdbox-sync.c
M	src/lib-storage/index/index-storage.c

2021-08-09 15:47:28 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (451883dbb8)

    lib-storage: dbox - Allow creating existing folder when rebuilding list
    index


M	src/lib-storage/index/dbox-common/dbox-storage.c
M	src/lib-storage/index/index-storage.c

2021-08-13 14:18:21 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (2fc8d7024b)

    lib-storage: Add list index rebuild code


M	src/lib-storage/list/Makefile.am
A	src/lib-storage/list/mail-storage-list-index-rebuild.c
M	src/lib-storage/mail-storage-private.h

2021-08-27 12:59:59 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (5a75724a2e)

    lib-storage: Populate mailboxes_fs if needed


M	src/lib-storage/mail-storage.c

2021-08-20 14:30:46 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (3855ccbf9a)

    lib-storage: mailbox-list - Try to get GUID from mailbox path


M	src/lib-storage/list/mailbox-list-index-status.c

2021-08-13 10:29:59 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (a92b1f9316)

    lib-storage: Add fields to mail_storage needed for list rebuild


M	src/lib-storage/mail-storage-private.h
M	src/lib-storage/mail-storage.c

2021-06-30 08:44:33 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (36f96c49ca)

    lib-storage: Fix changing mailbox GUID with LAYOUT=index

    The old path would generate Mail/mailboxes/mailboxes/<guid>

M	src/lib-storage/list/mailbox-list-index-backend.c

2021-06-22 15:59:25 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (c1a57f47a7)

    doveadm-stats: Add doveadm stats add/remove documentation


M	doc/man/doveadm-stats.1.in

2021-05-27 11:46:02 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (bc31da4d84)

    doveadm: Add 'stats add' and 'stats remove' commands


M	src/doveadm/Makefile.am
M	src/doveadm/doveadm-cmd.c
M	src/doveadm/doveadm-cmd.h
M	src/doveadm/doveadm-stats.c

2021-06-09 17:23:28 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (eef75dd719)

    stats: replace hardcoded value of default exporter_include with macro


M	src/stats/stats-settings.c
M	src/stats/stats-settings.h

2021-06-09 17:22:39 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (e9a46e3a6d)

    doveadm: Rewrite doveadm stats dump command to allow reuse code in other
    commands.


M	src/doveadm/doveadm-stats.c

2021-05-10 16:39:21 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (57bb3b90cb)

    lib-master: Accept filter updates from stats by stats-client.


M	src/lib-master/stats-client.c

2021-04-20 17:07:36 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (0444b730c2)

    stats: Implement ipc interface for adding and removing metrics


M	src/stats/client-reader.c

2021-05-10 16:13:12 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (adbbd40458)

    stats: Implement sending filter updates to connected processes.


M	src/stats/client-writer.c
M	src/stats/client-writer.h

2021-04-20 17:06:58 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (a2a79fb376)

    stats: Add functions for adding or removing metrics


M	src/stats/stats-metrics.c
M	src/stats/stats-metrics.h

2021-04-13 11:49:43 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (50f36bb1d2)

    stats: Expose stats_metric_setting_parser_info


M	src/stats/stats-settings.h

2021-04-20 17:06:26 +0300 sergey.kitov <sergey.kitov@open-xchange.com> (fcacfde02a)

    lib: Add function removing queries from event_filter


M	src/lib/event-filter.c
M	src/lib/event-filter.h

2021-09-02 14:31:36 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a476e16ae3)

    lib-http: test-http-client-errors - Fix random hangs

    Wait for subprocesses to be initialized before starting each test. This
    should fix random hangs with the test.

M	src/lib-http/test-http-client-errors.c

2021-09-02 15:39:33 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (8b883745d6)

    lib-test: test_subprocess_notify_signal_*() - Add signo parameter

    This allows using multiple notification signals.

M	src/lib-http/test-http-client-errors.c
M	src/lib-test/test-subprocess.c
M	src/lib-test/test-subprocess.h

2021-08-19 12:50:04 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (5280904733)

    lib-storage: Make sure header parsing is deinitialized after failures

    This should fix all the possible reasons for: Panic: file
    index-mail-headers.c: line 198 (index_mail_parse_header_init): assertion
    failed: (!mail->data.header_parser_initialized)

M	src/lib-storage/index/index-mail-headers.c
M	src/lib-storage/index/index-mail.c
M	src/lib-storage/index/index-mail.h

2021-08-19 12:32:45 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (0b6a2fb6c1)

    lib-storage: Fix potential assert-crash if filter-stream fails

    If filter-stream isn't read until header (because the parent istream fails), 
    the header parsing isn't deinitialized. If after the failure the headers are 
    attempted to be parsed again, there's an assert-crash. Make sure this won't 
    happen by finishing the filter-istream read, and if that fails then reset
    the header parsing anyway.

    Destroying the filter_stream may also change the parent istream offset to 
    change, so this commit adds an extra seek to beginning of the istream when 
    beginning to parse the mail headers.

    Fixes: Panic: file index-mail-headers.c: line 198
    (index_mail_parse_header_init): assertion failed:
    (!mail->data.header_parser_initialized)

M	src/lib-storage/index/index-mail-headers.c

2021-08-19 12:29:36 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (45df8159fe)

    lib-storage: Split off index_mail_filter_stream_destroy()


M	src/lib-storage/index/index-mail-headers.c

2021-08-17 14:33:56 +0200 Markus Valentin <markus.valentin@open-xchange.com> (6b7e4d1527)

    imapc: Fix crashing when copying nonexistent mails

    Check the msgmap before attempting to copy an mail which may has been 
    expunged already. Fixes:

    Panic: file mail-storage.c: line 2385
    (mailbox_transaction_commit_get_changes): assertion failed: (ret < 0 ||
    seq_range_count(&changes_r->saved_uids) == save_count ||
    array_count(&changes_r->saved_uids) == 0)

M	src/lib-storage/index/imapc/imapc-save.c

2021-08-18 14:04:53 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8e592661d5)

    lib-storage: Fix assert-crash in special partial mail parsing failures

    This happened for example if:
    - mail_precache() started parsing mail
    - header was parsed, but mail body parsing failed due to mail size mismatch
    - vsize parsing doesn't restart header parsing, because header size is
    already known
    - body parsing assert-crashes because there is no messsage parser
    initialized

    Fixes: Panic: file index-mail.c: line 1290 (index_mail_parse_body):
    assertion failed: (data->parser_ctx != NULL)

M	src/lib-storage/index/index-mail.c

2021-08-12 12:42:40 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (35f7ff1c41)

    lib-oauth2: Add unit test for missing exp field


M	src/lib-oauth2/test-oauth2-jwt.c

2021-08-12 12:40:39 +0300 Aki Tuomi <aki.tuomi@open-xchange.com> (5bc6fa7571)

    lib-oauth2: Add unit tests for valid tokens


M	src/lib-oauth2/test-oauth2-jwt.c

2021-06-08 00:35:13 +0200 s3lph <5564491+s3lph@users.noreply.github.com> (f3bef96857)

    lib-oauth2-jwt: Remove 'nbf < iat' check, as it's not mandated by RFC7519,
    and not uncommon to predate the nbf field


M	src/lib-oauth2/oauth2-jwt.c

2021-08-24 22:58:59 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (8a7fa002d2)

    lib-test: Fix race when subprocess immediately receives signal

    Signal could be received before test_subprocess_is_child=1 is set, causing 
    the subprocess's signal handler to also attempt to cleanup other 
    subprocesses.

    This was causing http-test-client-errors unit tests to fail somewhat 
    randomly, especially when running them only with 1 CPU.

M	src/lib-test/test-subprocess.c

2021-08-24 15:02:44 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (07d66366ab)

    lib: Add test-macros


M	src/lib/Makefile.am
M	src/lib/test-lib.inc
A	src/lib/test-macros.c

2021-08-23 14:21:02 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a4f9219709)

    lib: Rewrite POINTER_CAST_TO() to avoid new clang warning

    Fixes: warning: performing pointer subtraction with a null pointer has
    undefined behavior [-Wnull-pointer-subtraction]

M	src/lib/macros.h

2021-08-23 14:20:54 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9c4077a843)

    dbox: Remove unnecessary variable

    The variable was set and updated, but never read.

M	src/lib-storage/index/dbox-common/dbox-file.c

2021-08-23 14:20:24 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (a11c739b86)

    lib-dcrypt: Remove unnecessary variable

    The variable was set and updated, but never read.

M	src/lib-dcrypt/istream-decrypt.c

2021-08-23 11:46:46 +0300 Martti Rannanjärvi <martti.rannanjarvi@open-xchange.com> (bc679231f1)

    doveadm-dsync: Free ssl_iostream_context on connection failure


M	src/doveadm/doveadm-dsync.c

2021-04-13 18:25:06 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (415c305d6c)

    lib-smtp: smtp-server-cmd-rcpt - Fix assert crash occurring for pipelined
    MAIL RCPT MAIL sequence.

    The assertion is wrong in that it assumes that no MAIL commands can be
    pending once RCPT command is next to reply. The RCPT command does not block
    the pipeline, so that a subsequent MAIL command can also be pending (but
    will almost never succeed).

M	src/lib-smtp/smtp-server-cmd-rcpt.c
M	src/lib-smtp/test-smtp-server-errors.c

2021-04-13 18:25:31 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (23246612f2)

    lib-smtp: smtp-server-cmd-data - Add comment to pipeline state assertion.


M	src/lib-smtp/smtp-server-cmd-data.c

2021-08-20 01:19:28 +0200 Stephan Bosch <stephan.bosch@open-xchange.com> (741a963c19)

    lib-smtp: smtp-server-cmd-data - Remove useless trans != NULL checks.


M	src/lib-smtp/smtp-server-cmd-data.c

2021-08-19 17:06:42 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (285cf9c849)

    dict-sql: Fail early if there's unexpected number of bind arguments for iter

    Otherwise, lib-sql raises a panic.

M	src/lib-dict-backend/dict-sql.c

2021-08-17 15:23:31 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (e34bffaab5)

    lib: istreams - Make sure freeing snapshots can't access freed parent
    istream memory

    This happened after the recent istream-header-filter snapshot changes.

M	src/lib/istream.c

2021-08-18 19:49:43 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b401e4136f)

    imap: Fix mailbox leak if MOVE can't open the source mailbox

    Broken by 143b7c2b412ed8f155e812603fda81886bec466e

    Fixes: Panic: file mail-user.c: line 229 (mail_user_deinit): assertion
    failed: ((*user)->refcount == 1)

M	src/imap/cmd-copy.c

2021-08-18 13:54:39 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (16deb5b8bc)

    lib-lua: Don't include lua_resume_compat() for 5.1

    lua_resume() is not supported in 5.1, so don't try to add a compatibility
    function that fails compilation.

M	src/lib-lua/dlua-compat.c
M	src/lib-lua/dlua-compat.h

2021-05-25 19:26:14 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (bb1d67a870)

    lib: Remove unused event_filter_add()


M	src/lib/event-filter.c
M	src/lib/event-filter.h

2021-08-16 17:13:27 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f1bbfcb712)

    lib: test-event-filter - Replace event_filter_add() with
    event_filter_parse()


M	src/lib/test-event-filter.c

2021-05-24 23:57:13 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (c4369cbf6a)

    lib: Add comments to event-related code


M	src/lib/event-log.c
M	src/lib/event-log.h
M	src/lib/lib-event-private.h
M	src/lib/lib-event.h

2021-05-24 22:26:27 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (d2c0f1374c)

    lib: event_want_level() - Minor code cleanup

    event_want_log_level() internally does both of these checks, so it's enough 
    to just check its return value.

M	src/lib/event-log.c

2021-08-17 12:12:18 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (730b2a449f)

    lib-fs: Fix fs_stats.copy_count tracking with fs_default_copy()

    The copy_count could have been decreased too many times with async 
    operations.

M	src/lib-fs/fs-api-private.h
M	src/lib-fs/fs-api.c

2021-08-16 15:36:37 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (b82faee3cb)

    global: Add ATTR_UNSIGNED_WRAPS to fix various ubsan issues


M	src/auth/crypt-blowfish.c
M	src/lib/numpack.c
M	src/lib/sha3.c

2021-08-05 18:53:57 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (9e80b588f4)

    global: Fix various ubsan issues


M	src/lib-mail/istream-header-filter.c
M	src/lib-mail/test-qp-decoder.c
M	src/lib-test/test-istream.c
M	src/lib/test-base64.c
M	src/lib/test-data-stack.c

2021-08-17 10:59:49 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (05189ecdc7)

    doveadm: Free memory for all loaded mail_plugins at deinit


M	src/doveadm/doveadm-mail.c

2021-08-17 10:50:34 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (654d7b2d11)

    doveadm pw -l: Free all memory to avoid memory leak complaints


M	src/doveadm/doveadm-pw.c

2021-08-17 09:30:25 +0200 Timo Sirainen <timo.sirainen@open-xchange.com> (b997fc957e)

    doveadm batch: Fix memory leak


M	src/doveadm/doveadm-mail-batch.c

2021-08-17 11:06:36 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (46a511412a)

    doveadm: Split off doveadm_mail_cmd_deinit()


M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h

2021-05-07 21:15:04 +0300 Timo Sirainen <timo.sirainen@open-xchange.com> (f708052c5d)

    doveadm: Make doveadm_mail_cmd_free() public


M	src/doveadm/doveadm-mail.c
M	src/doveadm/doveadm-mail.h

2021-08-13 11:08:30 +0100 Siavash Tavakoli <siavash.tavakoli@open-xchange.com> (f28482afb8)

    global: Use consistent lua function names

    Change lua-style function names to be consistent with dovecot's style.

M	src/auth/db-lua.c
M	src/lib-lua/dlua-dovecot.c
M	src/lib-lua/dlua-error.c
M	src/lib-lua/dlua-pushstring.c
M	src/lib-lua/dlua-script-private.h
M	src/lib-lua/dlua-script.c
M	src/lib-storage/mail-lua.c
M	src/lib-storage/mail-storage-lua.c
M	src/lib-storage/mail-user-lua.c
M	src/lib-storage/mailbox-lua.c
